package com.asc.applets;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;

import javax.media.j3d.Appearance;
import javax.media.j3d.Font3D;
import javax.media.j3d.Link;
import javax.media.j3d.OrientedShape3D;
import javax.media.j3d.Shape3D;
import javax.media.j3d.SharedGroup;
import javax.media.j3d.Text3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3f;

import com.asc.applet.ui.objects.CubeInfo;
import com.asc.utils.NaturalOrderComparator;

public class AxisLabels {
	
	private CubeInfo cubeInfo;	 
	
	
	public AxisLabels(CubeInfo cubeInfo) {
		
		this.cubeInfo = cubeInfo;
				
	}
	
	public HashMap getXAxisLabels( String axisLabel, 
			float coordSysLength, SharedGroup tickSG, Appearance a, Font3D f3d ) {
		
		String[] 		axisTickLabels = null;
		Vector3f		tmpVector = new Vector3f();
		Transform3D		tmpTrans = new Transform3D();
		Point3f			origin = new Point3f();
		HashMap 		AxisPlottingPoints = new HashMap();
		HashMap       	returnObjects = new HashMap();
		TransformGroup  axisTG = new TransformGroup();
		
		
		axisTickLabels = cubeInfo.getXAxisLabels();
		
		System.out.println("length of tick labels" + axisTickLabels.length);
		
		int axisIdx = 0;
        
        /*The length of the axis is 2, ie, from -1.0 to +1.0.  While plotting the axis lables at the 
         * position +1.0, we end up overlapping with the next axis label.  To avoid this we now
         * divide the axis into equal parts considering only a length of 1.8f and leaving the 0.2f
         * as a buffer */
        float AxisLoopInc = 1.3f/ (float)axisTickLabels.length;

        for(float i = -0.7f; i <= coordSysLength/2 - 0.7f; i=i+AxisLoopInc) {

        	if (i==-0.7f) continue;
        	
        	System.out.println("axisIdx/value/index of x axis = " + axisIdx + "/" + axisTickLabels[axisIdx] + "/" + i);

        	TransformGroup tickTG = new TransformGroup();
        	tmpVector.set(0.0f, (float)i, 0.0f);
        	tmpTrans.set(tmpVector);
        	tickTG.setTransform(tmpTrans);
            tickTG.addChild(new Link(tickSG));


            TransformGroup tickTextTG = new TransformGroup();
            Text3D tickText = null;
            
            
            Point3f rotationPoint = new Point3f(0.0f, (float)i, 0.0f);                       
            tmpVector.set(0.08f, i, 0.0f); 
            tickText = new Text3D(f3d, axisTickLabels[axisIdx], origin, Text3D.ALIGN_FIRST,
                		Text3D.PATH_RIGHT);
        	tmpTrans.set(0.0475f, tmpVector); // scaling the x axis labels
        	        	
        	tickTextTG.setTransform(tmpTrans);
        	
        	//OrientedShape3D tickTextShape = new OrientedShape3D(tickText,
            //		a, OrientedShape3D.ROTATE_ABOUT_POINT, rotationPoint);
        	Shape3D tickTextShape = new Shape3D(tickText, a);        	
            tickTextTG.addChild(tickTextShape);
            
            axisTG.addChild(tickTextTG);
            axisTG.addChild(tickTG);
            
            
            // load the xAxisPlottingPoints
            AxisPlottingPoints.put(axisTickLabels[axisIdx], i);
            axisIdx++;


        }


        {
        	Point3f rotationPoint = new Point3f(0.0f, coordSysLength/2.0f, 0.0f);
        	TransformGroup tickTextTG = new TransformGroup();
        	
        	Text3D tickText = new Text3D(f3d, cubeInfo.getXAxisTitle(), origin, Text3D.ALIGN_CENTER,
        				Text3D.PATH_RIGHT);
        	
        	
        	tmpTrans.set(0.06f, new Vector3f(0.3f, -1.5f, +0.8f)); // scaling "ASSET CLASS"
        	tickTextTG.setTransform(tmpTrans);
        	OrientedShape3D tickTextShape = new OrientedShape3D(tickText,
        		new Appearance(), OrientedShape3D.ROTATE_ABOUT_POINT, rotationPoint);
        	tickTextTG.addChild(tickTextShape);
        	

        	axisTG.addChild(tickTextTG);

        }
        
        returnObjects.put("AxisTransformGroup", axisTG);
        returnObjects.put("AxisPlottingPoints", AxisPlottingPoints);
        
		return returnObjects;
		
	}
	
	
	
	
	public HashMap getYAxisLabels( String axisLabel, float coordSysLength, 
			SharedGroup tickSG, Appearance a, Font3D f3d ) {
		
		String[] 		axisTickLabels = null;
		Vector3f		tmpVector = new Vector3f();
		Transform3D		tmpTrans = new Transform3D();
		Point3f			origin = new Point3f();
		HashMap 		AxisPlottingPoints = new HashMap();
		HashMap       	returnObjects = new HashMap();
		TransformGroup  axisTG = new TransformGroup();
		
		
		axisTickLabels = cubeInfo.getYAxisLabels();
		
		System.out.println("length of tick labels" + axisTickLabels.length);
		
		int axisIdx = 0;
        
        /*The length of the axis is 2, ie, from -1.0 to +1.0.  While plotting the axis lables at the 
         * position +1.0, we end up overlapping with the next axis label.  To avoid this we now
         * divide the axis into equal parts considering only a length of 1.8f and leaving the 0.2f
         * as a buffer */
        float AxisLoopInc = 1.3f/ (float)axisTickLabels.length;
        
        
        // load the yAxisPlottingPoints, with the default low values,
        // where D is the denomination placeholder
        AxisPlottingPoints.put("0.0D", -0.7f);
        
        for(float i = -0.7f; i <= coordSysLength/2 - 0.7f; i=i+AxisLoopInc) {
        	        	
        	if (i==-0.7f || (axisIdx > axisTickLabels.length - 1)) continue;
        	
        	        	
        	System.out.println("axisIdx/value/index of y axis = " + axisIdx + "/" + axisTickLabels[axisIdx] + "/" + i);

        	TransformGroup tickTG = new TransformGroup();
        	tmpVector.set(0.0f, (float)i, 0.0f);
        	tmpTrans.set(tmpVector);
        	tickTG.setTransform(tmpTrans);
            tickTG.addChild(new Link(tickSG));

            
            TransformGroup tickTextTG = new TransformGroup();
            Text3D tickText = new Text3D(f3d, axisTickLabels[axisIdx], origin,
    				Text3D.ALIGN_LAST, Text3D.PATH_RIGHT);    
            tmpVector.set(-0.08f, i, 0.0f);
            tmpTrans.set(0.0475f, tmpVector); // scaling the Y axis labels
            tickTextTG.setTransform(tmpTrans);
        	       	
        	
        	Shape3D tickTextShape = new Shape3D(tickText, a);        	
            tickTextTG.addChild(tickTextShape);
            
            
            TransformGroup rotatedTickTextTG = new TransformGroup();            
            tmpTrans.rotY(0.7f);
            rotatedTickTextTG.setTransform(tmpTrans);
            rotatedTickTextTG.addChild(tickTextTG);

            axisTG.addChild(rotatedTickTextTG);
            axisTG.addChild(tickTG);
            
            
            // load the xAxisPlottingPoints
            AxisPlottingPoints.put(axisTickLabels[axisIdx], i);            
            axisIdx++;


        }


        {
        	Point3f rotationPoint = new Point3f(0.0f, coordSysLength/2.0f, 0.0f);
        	TransformGroup tickTextTG = new TransformGroup();        	
        	Text3D tickText = new Text3D(f3d, cubeInfo.getYAxisTitle(), origin, Text3D.ALIGN_CENTER,
            		Text3D.PATH_RIGHT);
            tmpVector.set(0.1f, 1.2f, 0.0f);
        	tmpTrans.set(0.06f, tmpVector); // scaling MARKET CAPITALIZATION
        	tickTextTG.setTransform(tmpTrans);
        	OrientedShape3D tickTextShape = new OrientedShape3D(tickText,
        			new Appearance(), OrientedShape3D.ROTATE_ABOUT_POINT, rotationPoint);
        	tickTextTG.addChild(tickTextShape);
        	

        	axisTG.addChild(tickTextTG);

        }
        
        returnObjects.put("AxisTransformGroup", axisTG);
        returnObjects.put("AxisPlottingPoints", AxisPlottingPoints);
        
		return returnObjects;
		
	}
	
	
	
	
	
	public HashMap getZAxisLabels( String axisLabel, float coordSysLength, 
			SharedGroup tickSG, Appearance a, Font3D f3d ) {
		
		String[] 		axisTickLabels = null;
		Vector3f		tmpVector = new Vector3f();
		Transform3D		tmpTrans = new Transform3D();
		Point3f			origin = new Point3f();
		HashMap 		AxisPlottingPoints = new HashMap();
		HashMap       	returnObjects = new HashMap();
		TransformGroup  axisTG = new TransformGroup();
		
		
		axisTickLabels = cubeInfo.getZAxisLabels();
		
		System.out.println("length of tick labels" + axisTickLabels.length);
		
		int axisIdx = 0;
        
        /*The length of the axis is 2, ie, from -1.0 to +1.0.  While plotting the axis lables at the 
         * position +1.0, we end up overlapping with the next axis label.  To avoid this we now
         * divide the axis into equal parts considering only a length of 1.8f and leaving the 0.2f
         * as a buffer  */
        float AxisLoopInc = 1.3f/ (float) axisTickLabels.length;

        for(float i = -0.7f; (i <= coordSysLength/2 - 0.7f) && (axisIdx < axisTickLabels.length); 
        										i=i+AxisLoopInc) {

           	if (i==-0.7f) continue;
           	
           	System.out.println("axisIdx/value/index of z axis = " + axisIdx + "/" + axisTickLabels[axisIdx] + "/" + i);

        	TransformGroup tickTG = new TransformGroup();
        	tmpVector.set(0.0f, (float)i, 0.0f);
        	tmpTrans.set(tmpVector);
        	tickTG.setTransform(tmpTrans);
            tickTG.addChild(new Link(tickSG));


            TransformGroup tickTextTG = new TransformGroup();
            Text3D tickText = new Text3D(f3d, axisTickLabels[axisIdx], origin, Text3D.ALIGN_LAST,
            		Text3D.PATH_RIGHT);
            tmpVector.set(-0.08f, i, 0.0f);
        	tmpTrans.set(0.0475f, tmpVector); // scaling the Z axis labels
        	tickTextTG.setTransform(tmpTrans);

        	Shape3D tickTextShape = new Shape3D(tickText, a);
            tickTextTG.addChild(tickTextShape);


            TransformGroup rotatedTickTextTG = new TransformGroup();
            tmpTrans.rotY(0.01f);
            rotatedTickTextTG.setTransform(tmpTrans);
            rotatedTickTextTG.addChild(tickTextTG);

            axisTG.addChild(rotatedTickTextTG);
            axisTG.addChild(tickTG);
            
            // load the zAxisPlottingPoints
            AxisPlottingPoints.put(axisTickLabels[axisIdx], i);
            axisIdx++;
            
        }


        {
        	Point3f rotationPoint = new Point3f(0.0f, coordSysLength/2.0f, 0.0f);
        	TransformGroup tickTextTG = new TransformGroup();
        	Text3D tickText = new Text3D(f3d, cubeInfo.getZAxisTitle(), origin, Text3D.ALIGN_CENTER,
        		Text3D.PATH_RIGHT);
        	tmpVector.set(-0.2f, -1.0f, 0.7f);
        	tmpTrans.set(0.06f, tmpVector); // scaling the SECTOR label
        	tickTextTG.setTransform(tmpTrans);
        	OrientedShape3D tickTextShape = new OrientedShape3D(tickText,
        			new Appearance(), OrientedShape3D.ROTATE_ABOUT_POINT, rotationPoint);
        	
        	tickTextTG.addChild(tickTextShape);


        	axisTG.addChild(tickTextTG);

        }
        
        returnObjects.put("AxisTransformGroup", axisTG);
        returnObjects.put("AxisPlottingPoints", AxisPlottingPoints);
        
		return returnObjects;
		
	}
	
	
	/** If innerCoordinate coordinate value keys are found in the plotting
	 *  HashMap then we get the value and continue.  If not found as a key
	 *  in the plotting Hashmap, then we will have to calculate the coordinate  
	 *  values.  The fourmula is as follows:
	 *  
	 *  locateKey = Key whose value has to be located
	 *  lowerRangeKey, upperRangeKey =  Key Range within which our key will be found
	 *  lowerRangeValue, upperRangeValue =  Value Range for the above Key Range 
	 *  intervalKey = interval of the plotting keys 
	 *  intervalValue = intervalue of the plotting values 
	 *  upperLowerRangeInterval = interval between upper Range and Lower Range
	 *  
	 *   intervalKey = upperRange - lowerRange
	 *   intervalValue = upperRangeValue - lowerRangeValue
	 *   locateKeyInc = (intervalValue/upperLowerRangeInterval) * (locateKey - lowerRangeKey)
	 *   locateValue = lowerRangeValue + locateKeyInc
	 *  	
	**/
	
	public float getCoordinateLoc(HashMap plottingPoints, String inLocateKey, String axisType) {
		
		float locateValue = 0.0f;
		String lowerRangeKey = null;  		
		String upperRangeKey = null; 
		float lowerRangeValue = 0.0f;
		float upperRangeValue = 0.0f;
		float intervalKey = 0.0f;
		float intervalValue = 0.0f;
		float locateKeyInc = 0.0f;
		float locateKey = 0.0f;
		
		
		// Only for Market Capitalization we have included the Denomination for
		// the values. For the other Frequencty types we do not include the Denomination.
		if(axisType.equals("Market Cap")) {
		   lowerRangeKey = "0D";
		   locateKey = Float.parseFloat(inLocateKey.substring(0, inLocateKey.length()-1));
		}  else {
		   lowerRangeKey = "0";
		   locateKey = Float.parseFloat(inLocateKey);
		}		
				
		
		ArrayList sortedArrayList = new ArrayList();
				
		Iterator it = plottingPoints.keySet().iterator();		
		while(it.hasNext()) { 
			String key = it.next().toString();				
			sortedArrayList.add(key);
		} 
		
		
		Collections.sort(sortedArrayList, new NaturalOrderComparator());
		
		
		for (Iterator<String> ita = sortedArrayList.iterator (); ita.hasNext (); ) {
		    
			String strObject = ita.next();
			
			// Only for Market Capitalization::: We do a substring on strObject to remove the 
			// denomination from the value, for example for	a strObject of 100M we want to 
			// remove the M off and only provide the numeral part to the parseFloat function.
			float arrayListValue = 0.0f;
			if(axisType.equals("Market Cap")) { 
				arrayListValue = Float.parseFloat(strObject.substring(0, strObject.length()-1));
			} else {
				arrayListValue = Float.parseFloat(strObject);
			}
		   	
		    		    
		    if( locateKey > arrayListValue ) {
		    	lowerRangeKey = strObject;
		    } else {
		    	upperRangeKey = strObject; 		    	
		    	break;
		    }
		    		    
		}
		
		
		
		upperRangeValue = Float.parseFloat(plottingPoints.get(upperRangeKey).toString());
		lowerRangeValue = Float.parseFloat(plottingPoints.get(lowerRangeKey).toString());
		
				
		intervalValue = upperRangeValue - lowerRangeValue;
		
		// Only for Market Capitalization::: Remove the Denomination from the Value,  for 
		// others we do not include the Denomination.
		if(axisType.equals("Market Cap")) { 
			intervalKey = Float.parseFloat(upperRangeKey.substring(0, upperRangeKey.length()-1)) - 
		   			  Float.parseFloat(lowerRangeKey.substring(0, lowerRangeKey.length()-1));
			locateKeyInc = (intervalValue/intervalKey) * 
		             	(locateKey - Float.parseFloat(lowerRangeKey.substring(0, lowerRangeKey.length()-1)));
		} else {
			intervalKey = Float.parseFloat(upperRangeKey) - Float.parseFloat(lowerRangeKey); 			  		
			locateKeyInc = (intervalValue/intervalKey) * (locateKey - Float.parseFloat(lowerRangeKey));           					
		}
		
		
		System.out.println("upperRangeValue/lowerRangeValue/locateKeyInc = " + upperRangeValue + "/" + 
				lowerRangeValue + '/' + locateKeyInc);
		
		locateValue = lowerRangeValue + locateKeyInc;
		
		System.out.println("locateKeyValue = " + inLocateKey + "; " + locateValue);
		
		return locateValue;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	

}
