/*************************************************************************
 * Author : Kavitha Subramani
 * Date   : Sep 02 2007
 * Version: 1.0
**************************************************************************/

package com.asc.applets;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsConfiguration;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.io.ObjectInputStream;
import java.net.URL;
import java.net.URLConnection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.media.j3d.AmbientLight;
import javax.media.j3d.Appearance;
import javax.media.j3d.Background;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.Bounds;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Font3D;
import javax.media.j3d.Geometry;
import javax.media.j3d.Material;
import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Shape3D;
import javax.media.j3d.SharedGroup;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TransparencyAttributes;
import javax.media.j3d.View;
import javax.swing.JPanel;
import javax.vecmath.AxisAngle4f;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import netscape.javascript.JSObject;

import com.asc.applet.ui.objects.CompanyInfo;
import com.asc.applet.ui.objects.CubeInfo;
import com.asc.applet.ui.objects.InnerCube;
import com.asc.applet.ui.objects.UserData;
import com.asc.behaviors.CubeZoomCallback;
import com.asc.behaviors.RestrictedMouseRotate;
import com.asc.utils.CoordSys;
import com.asc.utils.Cube;
import com.asc.utils.CubeAppearance;
import com.asc.utils.CylinderCreator;
import com.asc.utils.FloatEvent;
import com.asc.utils.FloatLabelJSlider;
import com.asc.utils.FloatLabelJSliderHorizontal;
import com.asc.utils.FloatLabelJSliderVertical;
import com.asc.utils.FloatListener;
import com.asc.utils.PortfolioCubeConstants;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.Cone;
import com.sun.j3d.utils.geometry.Cylinder;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.picking.behaviors.PickMouseBehavior;
import com.sun.j3d.utils.picking.behaviors.PickZoomBehavior;
import com.sun.j3d.utils.picking.behaviors.PickingCallback;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.universe.ViewingPlatform;



public class DynamicCube3d extends Applet implements
	PortfolioCubeConstants {

	// Incoming Parameters
	String					userId;
	String					portfolioId;
	String					xAxisLabel;
	String					yAxisLabel;
	String					zAxisLabel;
	String[]				assetClassList;
	
	
	String devURL  = "http://ejbserver:9081/Portfolio/CubeInfoServlet?portfolioId=";
	String prodURL = "http://www.trinlogix.com/asc/CubeInfoServlet?portfolioId=";
	
	String tickerDevURL = "http://ejbserver:9081/Portfolio/TickerInfoServlet?tickerSymbol=";
	String tickerProdURL = "http://www.trinlogix.com/asc/TickerInfoServlet?tickerSymbol=";
		
	String cubeInfoServletURL = devURL;
	String tickerServerURL = tickerDevURL;
	
    SimpleUniverse 			u;
    boolean					isApplication;
    Canvas3D  				canvas;
    GraphicsConfiguration 	config;
    OffScreenCanvas3D   	offScreenCanvas;
    View					view;
    BranchGroup 			objRoot;
    TransformGroup 			outerCubeTG;
    TransformGroup 			innerCubeTG;
  

    // transformation factors for the cube
    Vector3f		cubeTranslation = new Vector3f(0.0f, 0.0f, 0.0f);
    float			cubeScale = 1.0f;
    Vector3d		cubeNUScale = new Vector3d(1.0f, 1.0f, 1.0f);
    Vector3f		cubeRotateAxis = new Vector3f(1.0f, 0.0f, 0.0f);
    Vector3f		cubeRotateNAxis = new Vector3f(1.0f, 0.0f, 0.0f);
    float			cubeRotateAngle = 0.0f;
    AxisAngle4f		cubeRotateAxisAngle = new AxisAngle4f(cubeRotateAxis,
    							cubeRotateAngle);
    Vector3f		cubeRefPt = new Vector3f(0.0f, 0.0f, 0.0f);
    
    
    // sliders
    public static FloatLabelJSliderVertical cubeRotateYAxisAngleSlider;
    public static FloatLabelJSliderHorizontal cubeRotateXAxisAngleSlider;
    
    
    //  rotation factors for the cube
    double Xdeg;
    double Ydeg;
    double Zdeg;
    
    
    public static boolean rotationByMouse = false;
  
    // this tells whether to use the compound transformation
    // Important Note: If this is true then all objects are translated to
    // the origin and then rotated.  If you want to rotate an object in
    // its current position, then leave this as false
    boolean			useCompoundTransform = false;

    // These are Transforms are used for the compound transformation
    Transform3D		translateTrans = new Transform3D();
    Transform3D		scaleTrans = new Transform3D();
    Transform3D		rotateTrans = new Transform3D();
    Transform3D		refPtTrans = new Transform3D();
    Transform3D 	refPtInvTrans = new Transform3D();

    // this tells whether to use the uniform or non-uniform scale when
    // updating the compound transform
    boolean		useUniformScale = true;

    // The axis indicator, used to show the rotation axis
    RotAxis		rotAxis;
    boolean		showRotAxis = true;
    float		rotAxisLength = 3.0f;

    
    // The coord sys used to show the coordinate system
    CoordSys	coordSys;
    boolean		showCoordSys = true;
    float		coordSysLength = 2.8f;


    // GUI elements
    float		offScreenScale;
    

    
    // Temporaries that are reused
    Transform3D		tmpTrans = new Transform3D();
    Vector3f		tmpVector = new Vector3f();
    AxisAngle4f		tmpAxisAngle = new AxisAngle4f();

    // geometric constant
    Point3f			origin = new Point3f();
    Vector3f		yAxis = new Vector3f(0.0f, 1.0f, 0.0f);
    
    
    // Inner cubes plotting hashMaps
    HashMap xAxisPlottingPoints = new HashMap();
    HashMap yAxisPlottingPoints = new HashMap();
    HashMap zAxisPlottingPoints = new HashMap();
       
    
    // JavaScript Object
    JSObject mJSDoc;
    
    

    /*================================================================
     * Start of Inner Class Definitions
     ================================================================*/
        

    /*****************************************************************
	 * Class for mouse click behavior call back
 	 *****************************************************************/

    public class MousePickBehavior extends PickMouseBehavior {

    	
      	public MousePickBehavior(Canvas3D canvas, BranchGroup root,
    			       Bounds bounds, Applet applet) {
      		super(canvas, root, bounds);
      		
      		mJSDoc = JSObject.getWindow(applet);      		
      		mJSDoc = (JSObject) mJSDoc.getMember("document"); // not sure I need this
      		
      		this.setSchedulingBounds(bounds);
      		root.addChild(this);

      		pickCanvas.setMode(PickTool.BOUNDS);
      		
      		
      	}


        public void updateScene(int xpos, int ypos) {

        	System.out.println("updating Scene on mouse pick...");
        	MouseEvent mEvent = mevent;
        	System.out.println("getClickCount()" + mEvent.getClickCount() );
        	
        	BranchGroup pickedCubeParent = null;    		
    		Shape3D pickedCube = null;
    		

    		pickCanvas.setShapeLocation(xpos, ypos);

    		PickResult[] pickResultArray = pickCanvas.pickAllSorted();
    		if(pickResultArray != null) {
    		
    			for(int i=0; i< pickResultArray.length; i++) {    			
    				pickedCube = (Shape3D) pickResultArray[i].getNode(PickResult.SHAPE3D);
    				System.out.println("pickedCube of " + i + " = " + pickedCube.toString());
    				// if we have got a good pick then exit for loop and process pick
    				if(pickedCube.getUserData() != null) {
    					break;
    				}
    				pickedCube = null; // reset for next pick
    			}
    			
    		}
    		    		
    		

    		if (pickedCube != null) {
				
    			System.out.println("pickedCube = " + pickedCube.toString());
    			
    			try {
    				pickedCubeParent = (BranchGroup) pickedCube.getParent().getParent().
    																		getParent().getParent();
    			} catch(ClassCastException e) {
    				
    			}
    			
    			
    			UserData userData= (UserData) pickedCube.getUserData();
    			CompanyInfo companyInfo = null;
    			
    			if(userData != null) {

    				System.out.println("UserData.Sector=" + userData.getSector());
    				
    				if(isApplication) {
    					    					
    				}else {
	    				try{
	    					
	    					mJSDoc.eval("showSubSectorDIV()");
	    					mJSDoc.eval("hideCompanyDIV()");
	    					
	    					// Asset Class
	    		        	JSObject textBoxLabel = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeXaxis')");
	    		        	textBoxLabel.setMember("innerHTML", "<b>" + userData.getXAxisType()+ ": </b>" + userData.getXAxisValue());
	    		        	// Market Capitalization
	    		        	JSObject textBoxLabel2 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeYaxis')");
	    		        	textBoxLabel2.setMember("innerHTML", "<b>" + userData.getYAxisType()+ ": </b>" + userData.getYAxisValue());
	    		        	JSObject textBoxLabel3 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeZaxis')");
	    		        	textBoxLabel3.setMember("innerHTML", "<b>" + userData.getZAxisType()+ ": </b>" + userData.getZAxisValue());
	    		        	
	    		        	
	    		        	String[] subsectors = userData.getSubSectors();
	    		        	System.out.println("subsectors.length = " + subsectors.length);
	    		        	if(subsectors.length > 0) {
	    		        		StringBuffer subsectorsHTML = new StringBuffer();
	    		        	
	    		        		for(int i=0; i<subsectors.length; i++) {
	    		        			subsectorsHTML.append("        ");
	    		        			subsectorsHTML.append(subsectors[i]);
	    		        			subsectorsHTML.append("<br/>");
	    		        		}
	    		        	
	    		        		JSObject textBoxLabel4 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeSubSector')");
	    		        		textBoxLabel4.setMember("innerHTML", subsectorsHTML);
	    		        	
	    		        	} else {
	    		        		
	    		        		mJSDoc.eval("hideSubSectorDIV()");
	    		        		mJSDoc.eval("showCompanyDIV()");
	    		        		
	    		        		companyInfo = userData.getCompanyInfo();
	    		        		
	    		        		StringBuffer companyHTML = new StringBuffer();
	    		        		companyHTML.append("<B> Company: </B> ");
	    		        		companyHTML.append(companyInfo.getName());
	    		        		companyHTML.append("<br/>");
	    		        		companyHTML.append("<B> Symbol: </B> ");
	    		        		companyHTML.append(companyInfo.getTicker());
	    		        		companyHTML.append("<br/>");
	    		        		
	    		        		
	    		        		// Call this JavaScript function only on a single click of the mouse
		    		        	if(mEvent.getClickCount() == 1) {
		    		        		
		    		        		if(companyInfo != null) {
		    		        			System.out.println("Calling positionClicked()");
		    		        			String function = "positionclicked('" + companyInfo.getTicker() +
		    		        					"')";
		    		        			mJSDoc.eval(function);
		    		        		} else {
		    		        			System.out.println("Calling noTickerSymbol()");
		    		        			mJSDoc.eval("noTickerSymbol()");
		    		        		}
		    		        		
		    		        		
		    		        	}
	    		        		
	    		        		
	    		        		JSObject textBoxLabel5 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeCompanyDetails')");
	    		        		textBoxLabel5.setMember("innerHTML", companyHTML);
	    		        		
	    		        	}
	    		        	
	    		        } catch(Exception e){
	    		        	e.printStackTrace();
	    				}
    				}

    				
    				// If user double clicked, only then explode the inner cubes having 
    				// subsectors in them
    				if(mEvent.getClickCount() == 2 && userData.getSubSectors().length > 0) {
    				
    					
    					mJSDoc.eval("hideSubSectorDIV()");
    					mJSDoc.eval("hideQuoteDIV()");
    					
    					// parent of parent gets us the objRoot node declared in createSceneGraph method.
    					// We can then redraw the cube.    					
    					if(pickedCubeParent != null) {
    						pickedCubeParent.detach();    					
    						pickedCubeParent = null;
    					}	
    					
    					
    					
    					// Cleanup JSP display tags
    					try{
	    					// Asset Class
	    		        	JSObject textBoxLabel = (JSObject) mJSDoc.eval("document.getElementById('PickedCube')");
	    		        	textBoxLabel.setMember("innerHTML", " ");
	    		        	// Market Capitalization
	    		        	JSObject textBoxLabel2 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeMarketCapitalization')");
	    		        	textBoxLabel2.setMember("innerHTML", " ");
	    		        	JSObject textBoxLabel3 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeSector')");
	    		        	textBoxLabel3.setMember("innerHTML", " ");
	    		        	JSObject textBoxLabel4 = (JSObject) mJSDoc.eval("document.getElementById('PickedCubeSubSector')");
	    		        	textBoxLabel4.setMember("innerHTML", " ");

	    		        }catch(Exception e){
	    		        	e.printStackTrace();
	    				}

    				    				
	    				// Generate the drill down screen
	    		        HashMap cubeInfoServletResponse = (HashMap) getCubeInfoFromServlet(userData.getSectorId(), 
	    		        						userData.getAssetClassId());
	    		        CubeInfo cubeInfo = (CubeInfo) cubeInfoServletResponse.get("Level1");
	    		        
    		        
	    				BranchGroup scene = createSceneGraph(cubeInfo);
	    				u.addBranchGraph(scene);
    				} // end of double clicking
    				

				} else {
					System.out.println("cubeInfo was null!");
				}

    		}

        }

    }

    /*================================================================
     * End of Inner Class Definitions
     ================================================================*/


    /*================================================================
     * Start of Method Definitions
    =================================================================*/


    /*****************************************************************
	 *
	 *
	 *****************************************************************/
    public DynamicCube3d() {

		this(false, 1.0f);
				
   	}


	/*****************************************************************
	 *
	 *
	 *****************************************************************/
   	public DynamicCube3d(boolean isApplication, float initOffScreenScale) {

		this.isApplication = isApplication;
		this.offScreenScale = initOffScreenScale;
		
   	}



    /*****************************************************************
	 *  Create the Screen
	 *
 	 *****************************************************************/

    BranchGroup createSceneGraph( CubeInfo cubeInfo ) {
    	
    	// Clear the plotting HashMaps
    	xAxisPlottingPoints.clear();
    	yAxisPlottingPoints.clear();
    	zAxisPlottingPoints.clear();
    	

    	MousePickBehavior 		mousePick = null;
    	PickZoomBehavior		pickZoom = null;
    	

    	// Create the root of the branch graph
		objRoot = new BranchGroup();
		objRoot.setCapability(BranchGroup.ALLOW_DETACH);

		// Create a TransformGroup to scale the scene down by 3.5x
		TransformGroup objScale = new TransformGroup();
		Transform3D scaleTrans = new Transform3D();
		scaleTrans.set(1/ 2.45f);
		objScale.setTransform(scaleTrans);
		objRoot.addChild(objScale);

		// Create a TransformGroup and initialize it to the
		// identity.  Enable the TRANSFORM_WRITE capability so that
		// the mouse behaviors code can modify it at runtime.  Add it to the
		// root of the subgraph.
		TransformGroup objTrans = new TransformGroup();
		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		//objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);		
		objScale.addChild(objTrans);


		BoundingSphere behaveBounds = new BoundingSphere(new Point3d(), Double.MAX_VALUE);


		// Create the Pick Zoom Behavior
		// Register the class callback to be called if a Zoom Behavior occured...
		pickZoom = new PickZoomBehavior(objRoot, canvas, behaveBounds);
		objTrans.addChild(pickZoom);
		PickingCallback zoomCallback = new CubeZoomCallback();
		pickZoom.setupCallback(zoomCallback);
		
		
		//Create the Mouse Pick Behavior
		mousePick = new MousePickBehavior(canvas, objRoot, behaveBounds, this);
		
		// Add the container cuber and inner cubes and the rotation axis
		objScale.addChild(createCubeTransformGroup(cubeInfo, 0.7f, new Vector3f(1.0f, 1.0f, 0.0f), white, 0.7236f));
		
		// Enable rotate on Mouse activities 
		// Register the class callback to be called if a Rotation occurs...
		RestrictedMouseRotate myMouseRotate = new RestrictedMouseRotate(outerCubeTG);
		myMouseRotate.setSchedulingBounds(behaveBounds);
		objRoot.addChild(myMouseRotate);
		
		
		// Use a grey background for the figures
		Background bg = new Background(PortfolioCubeConstants.medGrey);
		bg.setApplicationBounds(behaveBounds);
		objTrans.addChild(bg);

		
        // Set up the ambient light
        Color3f ambientColor = new Color3f(1.0f, 1.0f, 1.0f);
        AmbientLight ambientLightNode = new AmbientLight(ambientColor);
        ambientLightNode.setInfluencingBounds(behaveBounds);
        objRoot.addChild(ambientLightNode);

        // Set up the directional lights
        Color3f light1Color = new Color3f(1.0f, 1.0f, 1.0f);
        Vector3f light1Direction  = new Vector3f(0.0f, -0.2f, -1.0f);

        DirectionalLight light1
            = new DirectionalLight(light1Color, light1Direction);
        light1.setInfluencingBounds(behaveBounds);
        objRoot.addChild(light1);
        
        
        // Final Translation of the objRoot before attaching it to the scene
        Transform3D scaleTrans2 = new Transform3D();
        scaleTrans2.set(0.42f, new Vector3f(-0.4f, -0.39f, 0.0f)); // scale by 3.5x
        //objScale.setTransform(scaleTrans2);
		
		// Setup the Initial rotation placement
		Xdeg = 0.0f;		
		Ydeg = -50.0f;
		Zdeg = 0.0f;		
		performRotation();
		
        objRoot.compile();

		return objRoot;

    }
    
    
    
    /*****************************************************************
	 * Returns the radians of the degree
 	 *****************************************************************/
    
    public static double toRadians (double degrees) {

	      double radians = (Math.PI / 180) * degrees;
	      return (radians);
	}



	/*****************************************************************
	 * Returns the TransformGroup we will be editing to change the
	 * transform on the cube
 	 *****************************************************************/

    TransformGroup createCubeTransformGroup(CubeInfo cubeInfo, float dimension, Vector3f pos, Color3f color, float transparency) {
    	
    	Transform3D transform = new Transform3D();
    	TransformGroup coordinatesGroup = new TransformGroup();

    	//AxisAngle4f	tmpAxisAngle = new AxisAngle4f();
    	tmpTrans = new Transform3D();
    	tmpVector = new Vector3f();


    	//float labelOffset = coordSysLength / 20.0f;
    	float axisRadius  = coordSysLength / 500.0f;
    	float arrowRadius = coordSysLength / 125.0f;
    	float arrowHeight = coordSysLength / 50.0f;
    	float tickRadius  = coordSysLength / 250.0f;
    	float tickHeight  = coordSysLength / 250.0f;
    	

    	// Create a TransformGroup for the Outer Cube, allow tranform changes,
    	transform.setTranslation(pos);		
		outerCubeTG = new TransformGroup();
		outerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		outerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);		


		TransparencyAttributes ta = new TransparencyAttributes();
        ta.setTransparencyMode (ta.BLENDED);
        ta.setTransparency (transparency);

        Material m = new Material(color, color, color, color, 75.0f);
        m.setLightingEnable(true);


        CubeAppearance a = new CubeAppearance();
        a.setMaterial(m);
        a.setTransparencyAttributes(ta);

        
        Appearance a1 = new CubeAppearance().getWireframeAppearance(color);

        Appearance a3 = new CubeAppearance().createRedAppearance();

        Appearance textAppearance = new CubeAppearance().createYellowAppearance();
        PolygonAttributes polyAttrib = new PolygonAttributes();
        polyAttrib.setCullFace(PolygonAttributes.CULL_NONE);
        polyAttrib.setBackFaceNormalFlip(true);
        textAppearance.setPolygonAttributes(polyAttrib);

        Appearance a5 = new CubeAppearance().createGreenAppearance();
        
        Appearance a4 = new CubeAppearance().createTransparentAppearance();
        
                


        /*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         * Y axis cylinder
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        TransformGroup yAxisTG = new TransformGroup();
        TransformGroup yTopTG = new TransformGroup();

        CylinderCreator yCylinder = new CylinderCreator();
        yAxisTG = yCylinder.create(new Point3d(0.0f, 0.0f, 0.0f), new Point3d(0.0f, coordSysLength/2, 0.0f), axisRadius, a5);
        
        tmpVector.set(0.0f, coordSysLength/4 + arrowHeight/2, 0.0f);
        tmpTrans.set(tmpVector);
        yTopTG.setTransform(tmpTrans);

        // Create a Transform group to move the arrow head to the top of the axis
        tmpVector.set(0.0f, coordSysLength/4 + arrowHeight/2, 0.0f);
        tmpTrans.set(tmpVector);
        yTopTG.setTransform(tmpTrans);
        Cone yArrowHead = new Cone(arrowRadius, arrowHeight, a5);
        yTopTG.addChild(yArrowHead);
        yAxisTG.addChild(yTopTG);

    	// Add the Y axis to the outer cube
        coordinatesGroup.addChild(yAxisTG);


        /*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         *  X axis cylinder
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        TransformGroup xAxisTG = new TransformGroup();
        TransformGroup xTopTG = new TransformGroup();

        CylinderCreator xCylinder = new CylinderCreator();
        xAxisTG = xCylinder.create(new Point3d(0.0f, 0.0f, 0.0f), new Point3d(coordSysLength/2, 0.0f, 0.0f), axisRadius, a5);

        tmpVector.set(0.0f, coordSysLength/4 + arrowHeight/2, 0.0f);
        tmpTrans.set(tmpVector);
        xTopTG.setTransform(tmpTrans);
        Cone xArrowHead = new Cone(arrowRadius, arrowHeight, a5);
        xTopTG.addChild(xArrowHead);
        xAxisTG.addChild(xTopTG);

        // Add the X axis to the outer cube
        coordinatesGroup.addChild(xAxisTG);


        /*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         *  Z axis cylinder
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        TransformGroup zAxisTG = new TransformGroup();
        TransformGroup zTopTG = new TransformGroup();

        CylinderCreator zCylinder = new CylinderCreator();
        zAxisTG = zCylinder.create(new Point3d(coordSysLength/2, 0.0f, 0.0f), new Point3d(coordSysLength/2, 0.0f, -coordSysLength/2), axisRadius, a5);

        tmpVector.set(0.0f, coordSysLength/4 + arrowHeight/2, 0.0f);
        tmpTrans.set(tmpVector);
        zTopTG.setTransform(tmpTrans);
        Cone zArrowHead = new Cone(arrowRadius, arrowHeight, a5);
        zTopTG.addChild(zArrowHead);
        zAxisTG.addChild(zTopTG);

        // Add the Z axis to the outer cube
        coordinatesGroup.addChild(zAxisTG);



       
        Cylinder tick = new Cylinder(tickRadius, tickHeight, a3);
        SharedGroup tickSG = new SharedGroup();
        tickSG.addChild(tick);

        
        Font3D f3d = new Font3D(new Font("Arial", Font.BOLD, 2), null);
                
        AxisLabels axisLabels = new AxisLabels(cubeInfo);

        /*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         *  X axis ticks and labels
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        HashMap returnObjects = axisLabels.getXAxisLabels(cubeInfo.getXAxisTitle(), 
        		coordSysLength,	tickSG, textAppearance, f3d);
        xAxisPlottingPoints = (HashMap) returnObjects.get("AxisPlottingPoints");
        xAxisTG.addChild((TransformGroup) returnObjects.get("AxisTransformGroup"));
                

        /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         *  Y axis ticks and labels
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        returnObjects.clear();
        returnObjects = axisLabels.getYAxisLabels(cubeInfo.getYAxisTitle(), 
        		coordSysLength,	tickSG, textAppearance, f3d);
        yAxisPlottingPoints = (HashMap) returnObjects.get("AxisPlottingPoints");
        yAxisTG.addChild((TransformGroup) returnObjects.get("AxisTransformGroup"));
        
        
        /*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         *  Z axis ticks and labels
         ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
        returnObjects.clear();
        returnObjects = axisLabels.getZAxisLabels(cubeInfo.getZAxisTitle(), 
        		coordSysLength,	tickSG, textAppearance, f3d);
        zAxisPlottingPoints = (HashMap) returnObjects.get("AxisPlottingPoints");
        zAxisTG.addChild((TransformGroup) returnObjects.get("AxisTransformGroup"));



		// create the outer transparent cube, we are superimposing a wired cube(cubeWire) over a
        // normal cube(cube)....
        Cube cube = new Cube(dimension, a4);
		Cube cubeWire = new Cube(dimension, a1); //a4=transparent, a1=wired
		outerCubeTG.addChild(cube);
		outerCubeTG.addChild(cubeWire);
		
		System.out.println("Created Outer Cube = " + cube.toString());

			
		InnerCube[] innerCubes = cubeInfo.getInnerCubes();
		
		System.out.println("Number of Inner Cubes = " + innerCubes.length);
		
		for(int i=0; i<innerCubes.length; i++) {
			InnerCube innerCube = innerCubes[i];
			
			UserData userData = new UserData();
			userData.setXAxisValue(innerCube.getXAxisValue());
			userData.setYAxisValue(innerCube.getYAxisValue());
			userData.setZAxisValue(innerCube.getZAxisValue());
			userData.setXAxisType(innerCube.getXAxisType());
			userData.setYAxisType(innerCube.getYAxisType());
			userData.setZAxisType(innerCube.getZAxisType());
			userData.setSector(innerCube.getSector());
			userData.setSectorId(innerCube.getSectorId());
			userData.setAssetClassId(innerCube.getAssetClassId());
			userData.setSubSectors(innerCube.getSubSectors());
			userData.setCompanyInfo(innerCube.getCompanyInfo());
			
			
			
			/** If innerCoordinate coordinate value keys are found in the plotting
			 *  HashMap then we get the value and continue.  If not found as a key
			 *  in the plotting Hashmap, then we will have to calculate the coordinate  
			 *  values.  
			**/
			
			float xValue = 0.0f;
			float yValue = 0.0f;
			float zValue = 0.0f;
			String svalue = null;
			
			System.out.println("***$$$$ " + innerCube.getXAxisType() + " / " + innerCube.getXAxisValue() + " $$$$$****");
			if( xAxisPlottingPoints.containsKey(innerCube.getXAxisValue()) ) {
				svalue =  xAxisPlottingPoints.get(innerCube.getXAxisValue()).toString();			
			    xValue =  Float.parseFloat(svalue.trim());
			} else {
				
				xValue = axisLabels.getCoordinateLoc(xAxisPlottingPoints, innerCube.getXAxisValue(), innerCube.getXAxisType());				
				
			}
			
			
			System.out.println("***$$$$ " + innerCube.getYAxisType() + " / " + innerCube.getYAxisValue() + " $$$$$****");
			if( yAxisPlottingPoints.containsKey(innerCube.getYAxisValue()) ) {
				svalue =  yAxisPlottingPoints.get(innerCube.getYAxisValue()).toString();			
			    yValue =  Float.parseFloat(svalue.trim());
			} else {
				
				yValue = axisLabels.getCoordinateLoc(yAxisPlottingPoints, innerCube.getYAxisValue(), innerCube.getYAxisType());				
				
			}
			
			
			System.out.println("***$$$$ " + innerCube.getZAxisType() + " / " + innerCube.getZAxisValue() + " $$$$$****");
			if( zAxisPlottingPoints.containsKey(innerCube.getZAxisValue()) ) {
				svalue =  zAxisPlottingPoints.get(innerCube.getZAxisValue()).toString();			
			    zValue =  Float.parseFloat(svalue.trim());
			} else {
				
				zValue = axisLabels.getCoordinateLoc(zAxisPlottingPoints, innerCube.getZAxisValue(), innerCube.getZAxisType());				
				
			}
			
			
			System.out.println("InnerCube coordinates for " + innerCube.getXAxisValue() + "/" + innerCube.getYAxisValue() + "/" 
								+ innerCube.getZAxisValue() + " is " + xValue + "; " + yValue + "; " + zValue);
			
			float[] colorArray = innerCube.getColor();
			
			// Create the inner cube
			outerCubeTG.addChild(createInnerCubeTransformGroup(0.02f, new Vector3f(xValue, yValue, zValue), 
					new Color3f(colorArray[0], colorArray[1], colorArray[2]), 0.0f, userData));			
			
		}
		

		// transform the axis coordinates
		tmpVector.set(-0.7f, -0.7f, 0.7f);
        tmpTrans.set(tmpVector);
        coordinatesGroup.setTransform(tmpTrans);

		outerCubeTG.addChild(coordinatesGroup);

		
		
		//  Add  the rotation axis
		rotAxis = new RotAxis(rotAxisLength);
		scaleTrans.set(1 / 3.5f, new Vector3f(-1.35f, -1.4f, 0.0f)); // scale down by 3.5x		
		outerCubeTG.addChild(rotAxis);
		
		
		

		return outerCubeTG;

    }
    
    
    
    
    /*****************************************************************
	 * Returns the TransformGroup we will be editing to change the
	 * transform on the cube
 	 *****************************************************************/

    TransformGroup createInnerCubeTransformGroup(float dimension, Vector3f pos, Color3f color,
    				float transparency, UserData cubeInfo) {

    	Transform3D transform = new Transform3D();
    	transform.setTranslation(pos);

		// create a TransformGroup for the cube, allow tranform changes,
		innerCubeTG = new TransformGroup(transform);
		innerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		innerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		innerCubeTG.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		innerCubeTG.setPickable(true);
		
		
		
		TransparencyAttributes ta = new TransparencyAttributes();
        ta.setTransparencyMode (TransparencyAttributes.BLENDED);
        ta.setTransparency (transparency);

        Material m = new Material(color, color, color, color, 75.0f);

        Appearance a = new Appearance();
        a.setMaterial(m);
        a.setTransparencyAttributes(ta);
        PolygonAttributes pa = new PolygonAttributes();        
        pa.setCullFace(PolygonAttributes.CULL_BACK);
        a.setPolygonAttributes(pa);


		// create the cube, and user data  and add it to the innerCubeTG
		Cube cube = new Cube(dimension, a);
		cube.setCapability(Shape3D.ENABLE_PICK_REPORTING);
		cube.setPickable(true);
		PickTool.setCapabilities(cube, PickTool.INTERSECT_FULL); 
		for (Enumeration e = cube.getAllGeometries(); e.hasMoreElements();) { 
            Geometry g = (Geometry)e.nextElement(); 
            g.setCapability(Geometry.ALLOW_INTERSECT); 
         } 



		cube.setUserData(cubeInfo);
		innerCubeTG.addChild(cube);
		
		System.out.println("created inner cube = " + cube.toString());

		return innerCubeTG;

    }
    
    
    /*****************************************************************
	 * canvasPanel()
	 *****************************************************************/

	JPanel canvasPanel() {

		JPanel panel = new JPanel(new BorderLayout());

		canvas = new Canvas3D(config);
		panel.add("Center", canvas);

		panel.add("East", yAxisSliderPanel());

		panel.add("South", xAxisSliderPanel());


		return panel;

	}

	
	
	/*****************************************************************
	 * xAxisSliderPanel()
 	 *****************************************************************/

	JPanel xAxisSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 2;
		c.weightx = 0.5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy = 0;
		c.insets = new Insets(5,65,10,200);

		cubeRotateXAxisAngleSlider = new FloatLabelJSliderHorizontal(
				"Rotate X:", 1.0f, -180.0f, 180.0f, 0.0f);
		cubeRotateXAxisAngleSlider.setMajorTickSpacing(1.0f);
		cubeRotateXAxisAngleSlider.setPaintTicks(true);
		
		cubeRotateXAxisAngleSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				
				Xdeg = e.getValue();				
				performRotation();		
				
			}
		});
		panel.add(cubeRotateXAxisAngleSlider,c);


		return panel;
	}
	

	/*****************************************************************
	 * yAxisSliderPanel()
 	 *****************************************************************/

	JPanel yAxisSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.VERTICAL;
		c.gridx = 0;
		c.weightx = 0;
		c.weighty = 0.5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy = 2;
		c.insets = new Insets(50,10,70,0);

		cubeRotateYAxisAngleSlider = new FloatLabelJSliderVertical(
				"Rotate Y:", 1.0f, -180.0f, 180.0f, 0.0f);
		cubeRotateYAxisAngleSlider.setMajorTickSpacing(1.0f);
		cubeRotateYAxisAngleSlider.setPaintTicks(true);

		cubeRotateYAxisAngleSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				
				Ydeg = e.getValue()-50.0f;
				performRotation();
				
			}
		});
		
		panel.add(cubeRotateYAxisAngleSlider,c);

		return panel;

	}


	
	/*****************************************************************
	 * zAxisSliderPanel()
 	 *****************************************************************/

	JPanel zAxisSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 2;
		c.weightx = 0.5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy = 0;
		c.insets = new Insets(5,65,10,20);

		FloatLabelJSliderHorizontal cubeRotateAxisZSlider = new FloatLabelJSliderHorizontal(
				"Rotate Z:", 1.0f, -180.0f, 180.0f, 0.0f);
		cubeRotateAxisZSlider.setMajorTickSpacing(1.0f);
		cubeRotateAxisZSlider.setPaintTicks(true);

		cubeRotateAxisZSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				
				Zdeg = e.getValue();				
				performRotation();		
				
			}
		});
		panel.add(cubeRotateAxisZSlider,c);


		return panel;
	}

	
	
	

	/*****************************************************************
	 * Perform the cube rotation from the established values of Xdeg
	 * and Ydeg. Called from AxisSlider listeners and Mouse Rotation
	 * call back.
 	 *****************************************************************/
	void performRotation() {
		
		if(rotationByMouse == false) {
			
			System.out.println("performRotation(): rotationByMouse =" + rotationByMouse + "( " +
					Xdeg + ", " + Ydeg + ", " + Zdeg + " )");
			
			//	rotate object has composited transformation matrix
			outerCubeTG.getTransform(tmpTrans); // get the old transform
			Transform3D yTempRotate = new Transform3D();
			Transform3D zTempRotate = new Transform3D();
				
			tmpTrans.rotX( toRadians(Xdeg) ); // set rotational factors
			yTempRotate.rotY( toRadians(Ydeg) );
			zTempRotate.rotZ( toRadians(Zdeg) );
		
			tmpTrans.mul(yTempRotate);
			tmpTrans.mul(zTempRotate);
		
			tmpTrans.setScale(cubeScale); // set scaling/zooming factors
		
			outerCubeTG.setTransform(tmpTrans); // set the new transform
		
		}
		
	}
		 
	 
	 
	/*****************************************************************
	 * zoomPanel():
	 *****************************************************************/

	JPanel zoomXSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		panel.add(zoomPanel(), c);
		panel.add(zAxisSliderPanel(), c);
		
		return panel;
		
	} 



	/*****************************************************************
	 * zoomPanel():
 	 *****************************************************************/

	JPanel zoomPanel() {

		JPanel panel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		// Uniform Scaling...
		FloatLabelJSlider cubeScaleSlider = new FloatLabelJSlider(
						"Zoom:", 0.1f, 0.4f, 2.0f, cubeScale);
		cubeScaleSlider.setMajorTickSpacing(1.0f);
		cubeScaleSlider.setPaintTicks(true);
		cubeScaleSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				cubeScale = e.getValue();					
				performZoom();				
			}
		});
		c.gridx = 0;
		c.gridy = 0;
		c.insets = new Insets(10,0,0,50); 
		panel.add(cubeScaleSlider, c);		
		
		
		return panel;

	}
	
	
	/*****************************************************************
	 *
	 *
	 *****************************************************************/

   void performZoom() {
	   
		outerCubeTG.getTransform(tmpTrans); // get the old transform
		tmpTrans.setScale(cubeScale);  // set only scale
		outerCubeTG.setTransform(tmpTrans); // set the new transform

   }

	
	
	/*****************************************************************
	 * Called from JSP via JavaScript
     *
	 *****************************************************************/
	
	public void backButtonPressed() {
		
		// parent of parent gets us the objRoot node declared in createSceneGraph method.
		// We can then redraw the cube.    					
		if(objRoot != null) {
			objRoot.detach();    					
			objRoot = null;
		}	
		
		
		// Get Level 1 Cube Info from CubeInfoServlet
		HashMap cubeInfoServletResponse = new HashMap();
		
		cubeInfoServletResponse = (HashMap) getCubeInfoFromServlet();
		CubeInfo cubeInfo = (CubeInfo) cubeInfoServletResponse.get("Level1");
		
		BranchGroup scene = createSceneGraph(cubeInfo);
		u.addBranchGraph(scene);
		
		
	}
	
	
	
   	/*****************************************************************
	 *
     *
	 *****************************************************************/

    public void destroy() {

		u.removeAllLocales();
		u.cleanup();

    }


    /*****************************************************************
	 * init():
	 *
 	 *****************************************************************/
    public void init() {


    	// input parameter setup
    	userId = getParameter("userId");
    	portfolioId = getParameter("portfolioId");
    	
    	System.out.println("init() userId = " + userId);
    	System.out.println("init() portfolioId = " + portfolioId);
    	
    	
		setLayout(new BorderLayout());
		config = SimpleUniverse.getPreferredConfiguration();

		add("Center", canvasPanel());
		
		// Get Level 1 Cube Info from CubeInfoServlet
		HashMap cubeInfoServletResponse = new HashMap();
		
		cubeInfoServletResponse = (HashMap) getCubeInfoFromServlet();
		CubeInfo cubeInfo = (CubeInfo) cubeInfoServletResponse.get("Level1");
		
		//Setting up the values in the details panel in jsp page.
		mJSDoc = JSObject.getWindow(this);
		JSObject x_AxisLabel = (JSObject) mJSDoc.eval("document.getElementById('X_axis')");
		x_AxisLabel.setMember("innerHTML", "<b>X: </b>" + cubeInfo.getXAxisTitle());
		JSObject y_AxisLabel = (JSObject) mJSDoc.eval("document.getElementById('Y_axis')");
		y_AxisLabel.setMember("innerHTML", "<b>Y: </b>" + cubeInfo.getYAxisTitle());
		JSObject z_AxisLabel = (JSObject) mJSDoc.eval("document.getElementById('Z_axis')");
		z_AxisLabel.setMember("innerHTML", "<b>Z: </b>" + cubeInfo.getZAxisTitle());
		
				
		
		
		
		// Create a simple scene and attach it to the virtual universe
		u = new SimpleUniverse(canvas);
		BranchGroup scene = createSceneGraph(cubeInfo);

				
		view = u.getViewer().getView();
		

        // This will move the ViewPlatform back a bit so the
        // objects in the scene can be viewed.
		ViewingPlatform viewingPlatform = u.getViewingPlatform();
		viewingPlatform.setNominalViewingTransform();

        // add an orbit behavior to move the viewing platform
        //OrbitBehavior orbit = new OrbitBehavior(canvas,
        //                                       OrbitBehavior.STOP_ZOOM);
        //BoundingSphere bounds =
        //    new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
        //orbit.setSchedulingBounds(bounds);
        //viewingPlatform.setViewPlatformBehavior(orbit);

		u.addBranchGraph(scene);

		add("North", zoomXSliderPanel());
		
		
    }


    /*****************************************************************
     * Retrieve Cube Information from the CubeInfoServlet (Main Screen)
     *****************************************************************/
    private Map getCubeInfoFromServlet() {
    	
    	String servletPath = cubeInfoServletURL + portfolioId;
    	    	
    	Map response = invokeServlet(servletPath);
    	
    	return response;
    	
    }
    
    
    
    
    /*****************************************************************
     * Retrieve Cube Information from the CubeInfoServlet (Drill Down Screen)
     *****************************************************************/
    private Map getCubeInfoFromServlet(int parentSectorId, int assetClassId) {
    	
        String servletPath = cubeInfoServletURL + portfolioId +"&parentSectorId=" + parentSectorId + 
        				"&assetClassId=" + assetClassId;
    	
    	
    	Map response = invokeServlet(servletPath);
    	
    	return response;
    	
    }
    
    
    
    
    
    /*****************************************************************
     * Retrieve Ticker Symbol Info 
     *****************************************************************/
    public void searchForTicker(String ticker) {
    	
    	
    	StringTokenizer st = new StringTokenizer(ticker," ",false);
    	String searchTicker="";
    	while (st.hasMoreElements()) searchTicker += st.nextElement();
    	    	
    	searchTicker = searchTicker.trim();
    	
    	System.out.println("searchForTicker(): " + searchTicker);
    	
    	mJSDoc = JSObject.getWindow(this);
    
    	String servletPath = tickerServerURL + searchTicker + "&portfolioId=" + portfolioId;
    	
		// Get TickerLevel Cube Info from TickerInfoServlet
		HashMap response = new HashMap();
		
		response = (HashMap) invokeServlet(servletPath);
		CubeInfo cubeInfo = (CubeInfo) response.get("LevelTicker");
		
		
		InnerCube[] innerCubes = cubeInfo.getInnerCubes();
				
		if(innerCubes.length != 0) {
			// parent of parent gets us the objRoot node declared in createSceneGraph method.
			// We can then redraw the cube.    					
			if(objRoot != null) {
				objRoot.detach();    					
				objRoot = null;
			}	
			BranchGroup scene = createSceneGraph(cubeInfo);
			u.addBranchGraph(scene);			
		} else {
						
			mJSDoc.eval("alert('Ticker Symbol not found')"); 
			
		}
		
		mJSDoc.eval("document.getElementById('ticker').value = ' '");
    			
	    	
    }
    
    
    
    /*****************************************************************
     * Retrieve Cube Information from the CubeInfoServlet 
     *****************************************************************/

     private Map invokeServlet(String servletPath) {
    	  
    	Map response = null;
    	  
        try {

          // URL to servlet
          URL servletURL = new URL(servletPath);
          URLConnection connection = servletURL.openConnection();
          
          // Connection will be used for both input and output
          connection.setDoOutput(true);  
          connection.setDoInput(true);
          
          // Disable caching
          connection.setUseCaches(false);  
          
          // Connection will be use for transferring serialzied Java objects
          connection.setRequestProperty("Content-Type", "application/octet-stream");
          
          // receiving the Object          
          ObjectInputStream inputStream = new ObjectInputStream(connection.getInputStream());
          response = (Map) inputStream.readObject();
         
          
          inputStream.close();
          
        } catch (Exception e) {
          e.printStackTrace();
          System.out.println("An error occurred: " + e.toString());
        }
        
        return response;
        
    }

     
     
    
     
     
     
    /*****************************************************************
	 * Splitting input parms into a String Array
	 *
	 *****************************************************************/
    public static String[] getParametersArray(String paramStr) {

		// Put the parameters into a vector first, because you don't
		// know how many parameters you are getting.
		Vector vec = new Vector();

		if (paramStr == null)
				return new String[0];

		// If you got the parameter, add the it to the vector
		vec.addElement(paramStr);

		// The tokenizer will separate out the parameters from the string
		StringTokenizer tok = new StringTokenizer(paramStr, "/");


		// Create a string array to hold the values
		String[] returnValues = new String[vec.size()];

		// Copy the vector values into the new string array
		vec.copyInto((Object[]) returnValues);

		return returnValues;

	}
    

    
	/*****************************************************************
	 * The following allows DynamicCube3d to be run as an application
     * as well as an applet call java DynamicCube3d -s 950, 600
	 *
	 *****************************************************************/

    public static void main(String[] args) {

		float initOffScreenScale = 2.5f;
		for (int i = 0; i < args.length; i++) {
	    	if (args[i].equals("-s")) {
				if (args.length >= (i+1)) {
		    		initOffScreenScale = Float.parseFloat(args[i+1]);
		    	i++;
				}
		    }
		}

		MainFrame frame = new MainFrame(new DynamicCube3d (true, initOffScreenScale),
													950, 760);
		frame.setTitle("Portfolio 3D Cube");
    }

}
