/*************************************************************************
 * Author : Kavitha Subramani
 * Date   : Aug 28 2007
 * Version: 1.0
**************************************************************************/
/**
 * OffScreenCanvas3D is used to do off screen rendering for screen captures.
 * This file output JPEG images.  To output TIFF images, change the
 * marked sections of code.
 */

package com.asc.applets;

import java.awt.GraphicsConfiguration;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.image.BufferedImage;
import java.awt.image.RenderedImage;
import java.awt.image.DataBuffer;
/* JAI
import javax.media.jai.*;
import com.sun.media.jai.codec.*;
*/

/* No-JAI */
import com.sun.image.codec.jpeg.*;
import java.io.FileOutputStream;
import java.io.BufferedOutputStream;


class OffScreenCanvas3D extends Canvas3D {

    OffScreenCanvas3D(GraphicsConfiguration graphicsConfiguration,
		      boolean offScreen) {

	super(graphicsConfiguration, offScreen);
    }

    private BufferedImage doRender(int width, int height) {

	BufferedImage bImage =
	    new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);

	ImageComponent2D buffer =
	    new ImageComponent2D(ImageComponent.FORMAT_RGB, bImage);
	//buffer.setYUp(true);

	setOffScreenBuffer(buffer);
	renderOffScreenBuffer();
	waitForOffScreenRendering();
	bImage = getOffScreenBuffer().getImage();
	return bImage;
    }

    void snapImageFile(String filename, int width, int height) {
	BufferedImage bImage = doRender(width, height);

	/* JAI:
	RenderedImage fImage = JAI.create("format", bImage,
	    DataBuffer.TYPE_BYTE);
	JAI.create("filestore", fImage, filename + ".tif", "tiff", null);
	*/

	/* No JAI: */
	try {
	     FileOutputStream fos = new FileOutputStream(filename+".jpg");
	     BufferedOutputStream bos = new BufferedOutputStream(fos);

	     JPEGImageEncoder jie = JPEGCodec.createJPEGEncoder(bos);
	     JPEGEncodeParam param = jie.getDefaultJPEGEncodeParam(bImage);
	     param.setQuality(1.0f,true);
	     jie.setJPEGEncodeParam(param);
	     jie.encode(bImage);

	     bos.flush();
	     fos.close();
	 } catch (Exception e) {
		System.out.println(e);
	 }
    }
}
