/*************************************************************************
 * Author : Kavitha Subramani
 * Date   : Sep 02 2007
 * Version: 1.0
**************************************************************************/

package com.asc.applets;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsConfiguration;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.media.j3d.AmbientLight;
import javax.media.j3d.Appearance;
import javax.media.j3d.BoundingSphere;
import javax.media.j3d.BranchGroup;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.ColoringAttributes;
import javax.media.j3d.DirectionalLight;
import javax.media.j3d.Font3D;
import javax.media.j3d.Geometry;
import javax.media.j3d.Group;
import javax.media.j3d.Material;
import javax.media.j3d.Node;
import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Shape3D;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TransparencyAttributes;
import javax.media.j3d.View;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;
import javax.vecmath.AxisAngle4f;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;
import javax.vecmath.Point3f;
import javax.vecmath.Vector3d;
import javax.vecmath.Vector3f;

import com.asc.applet.ui.objects.CubeInfo;
import com.asc.applet.ui.objects.InnerCube;
import com.asc.applet.ui.objects.UserData;
import com.asc.utils.CoordSys;
import com.asc.utils.Cube;
import com.asc.utils.FloatEvent;
import com.asc.utils.FloatLabelJSlider;
import com.asc.utils.FloatLabelJSliderHorizontal;
import com.asc.utils.FloatLabelJSliderVertical;
import com.asc.utils.FloatListener;
import com.asc.utils.PortfolioCubeConstants;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.Box;
import com.sun.j3d.utils.geometry.Primitive;
import com.sun.j3d.utils.picking.PickCanvas;
import com.sun.j3d.utils.picking.PickResult;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.picking.behaviors.PickZoomBehavior;
import com.sun.j3d.utils.picking.behaviors.PickingCallback;
import com.sun.j3d.utils.universe.SimpleUniverse;
import com.sun.j3d.utils.universe.ViewingPlatform;





public class PickingDynamicCube3d extends Applet implements
	PortfolioCubeConstants {

	// Incoming Parameters
	String					userId;
	String					portfolioId;
	String					xAxisLabel;
	String					yAxisLabel;
	String					zAxisLabel;
	String[]				assetClassList;



    SimpleUniverse 			u;
    boolean					isApplication;
    Canvas3D  				canvas;
    GraphicsConfiguration 	config;
    OffScreenCanvas3D   	offScreenCanvas;
    View					view;
    BranchGroup 			objRoot;
    TransformGroup 			outerCubeTG;
    TransformGroup 			innerCubeTG;
    TransformGroup 			objAxis;
    
    TransformGroup 			objScale;


    // transformation factors for the cube
    Vector3f		cubeTranslation = new Vector3f(0.0f, 0.0f, 0.0f);
    float			cubeScale = 1.0f;
    Vector3d		cubeNUScale = new Vector3d(1.0f, 1.0f, 1.0f);
    Vector3f		cubeRotateAxis = new Vector3f(1.0f, 0.0f, 0.0f);
    Vector3f		cubeRotateNAxis = new Vector3f(1.0f, 0.0f, 0.0f);
    float			cubeRotateAngle = 0.0f;
    AxisAngle4f		cubeRotateAxisAngle = new AxisAngle4f(cubeRotateAxis,
    							cubeRotateAngle);
    Vector3f		cubeRefPt = new Vector3f(0.0f, 0.0f, 0.0f);


    // this tells whether to use the compound transformation
    // Important Note: If this is true then all objects are translated to
    // the origin and then rotated.  If you want to rotate an object in
    // its current position, then leave this as false
    boolean			useCompoundTransform = false;

    // These are Transforms are used for the compound transformation
    Transform3D		translateTrans = new Transform3D();
    Transform3D		scaleTrans = new Transform3D();
    Transform3D		rotateTrans = new Transform3D();
    Transform3D		refPtTrans = new Transform3D();
    Transform3D 	refPtInvTrans = new Transform3D();

    // this tells whether to use the uniform or non-uniform scale when
    // updating the compound transform
    boolean		useUniformScale = true;

    // The axis indicator, used to show the rotation axis
    //RotAxis		rotAxis;
    //boolean		showRotAxis = true;
    //float		rotAxisLength = 3.0f;

    
    // The coord sys used to show the coordinate system
    CoordSys	coordSys;
    boolean		showCoordSys = true;
    float		coordSysLength = 4.0f;


    // GUI elements
    float		offScreenScale;
    

    
    // Temporaries that are reused
    Transform3D		tmpTrans = new Transform3D();
    Vector3f		tmpVector = new Vector3f();
    AxisAngle4f		tmpAxisAngle = new AxisAngle4f();

    // geometric constant
    Point3f			origin = new Point3f();
    Vector3f		yAxis = new Vector3f(0.0f, 1.0f, 0.0f);
    
    
    // plotting hashMaps
    HashMap xAxisPlottingPoints = new HashMap();
    HashMap yAxisPlottingPoints = new HashMap();
    HashMap zAxisPlottingPoints = new HashMap();
    
    

    /*================================================================
     * Start of Inner Class Definitions
     ================================================================*/
    

    /*****************************************************************
	 * Class for mouse Pick & Zoom behavior call back
 	 *****************************************************************/

    public class MyZoomCallbackClass extends Object implements PickingCallback{
    	public void transformChanged(int type, TransformGroup tg) {
    		System.out.println("Mouse Zoom callback function ...:");

			if(tg != null) {
				System.out.println("Mouse Zoom callback function ...:" + tg.toString());
			}
        }
    }
    
    /*================================================================
     * End of Inner Class Definitions
     ================================================================*/


    /*================================================================
     * Start of Method Definitions
    =================================================================*/


    /*****************************************************************
	 *
	 *
	 *****************************************************************/
    public PickingDynamicCube3d() {

		this(false, 1.0f);

   	}


	/*****************************************************************
	 *
	 *
	 *****************************************************************/
   	public PickingDynamicCube3d(boolean isApplication, float initOffScreenScale) {

		this.isApplication = isApplication;
		this.offScreenScale = initOffScreenScale;

   	}



    /*****************************************************************
	 *  Create the Screen
	 *
 	 *****************************************************************/

    BranchGroup createSceneGraph( CubeInfo cubeInfo ) {
    	
    	// Clear the plotting HashMaps
    	xAxisPlottingPoints.clear();
    	yAxisPlottingPoints.clear();
    	zAxisPlottingPoints.clear();
    	

    	PickZoomBehavior		pickZoom = null;

    	// Create the root of the branch graph
		objRoot = new BranchGroup();
		objRoot.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
		objRoot.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
		objRoot.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		objRoot.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);		
		objRoot.setCapability(BranchGroup.ENABLE_PICK_REPORTING);
		objRoot.setCapability(BranchGroup.ALLOW_DETACH);

		// Create a TransformGroup to scale the scene down by 3.5x
		objScale = new TransformGroup();
		objScale.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
		objScale.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
		objScale.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		objScale.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		objScale.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		Transform3D scaleTrans = new Transform3D();
		scaleTrans.set(1/ 2.45f);
		objScale.setTransform(scaleTrans);
		objRoot.addChild(objScale);

		// Create a TransformGroup and initialize it to the
		// identity.  Enable the TRANSFORM_WRITE capability so that
		// the mouse behaviors code can modify it at runtime.  Add it to the
		// root of the subgraph.
		TransformGroup objTrans = new TransformGroup();
		objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
		objTrans.setCapability(TransformGroup.ALLOW_CHILDREN_EXTEND);
		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		objTrans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		objTrans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		objScale.addChild(objTrans);


		BoundingSphere behaveBounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);

		
		// Create the Zooming Behavior
		// Register the class callback to be called if a Zoom Behavior occured...
		pickZoom = new PickZoomBehavior(objRoot, canvas, behaveBounds);
		objTrans.addChild(pickZoom);
		PickingCallback zoomCallback = new MyZoomCallbackClass();
		pickZoom.setupCallback(zoomCallback);


		// Add the container cuber and inner cubes and the rotation axis		
		objAxis = new TransformGroup();
		objScale.addChild(objAxis);
		objScale.addChild(createCubeTransformGroup(cubeInfo, 1.0f, new Vector3f(0.0f, 0.0f, 0.0f), white, 0.7236f));
		
		//UserData userData = new UserData();
		//userData.setSector("Test Sector");
		//objScale.addChild(createInnerCubeTransformGroup(0.04f, new Vector3f(-0.256f, 0.25f, 0.856f), blue, 0.0f, userData));


		BoundingSphere bounds = new BoundingSphere(new Point3d(), 100.0f);

		// Use a white background for the figures
		//Background bg = new Background(new Color3f(1.0f, 1.0f, 1.0f));
		//bg.setApplicationBounds(bounds);
		//objTrans.addChild(bg);

        // Set up the ambient light
        Color3f ambientColor = new Color3f(1.0f, 1.0f, 1.0f);
        AmbientLight ambientLightNode = new AmbientLight(ambientColor);
        ambientLightNode.setInfluencingBounds(bounds);
        objRoot.addChild(ambientLightNode);

        // Set up the directional lights
        Color3f light1Color = new Color3f(1.0f, 1.0f, 1.0f);
        Vector3f light1Direction  = new Vector3f(0.0f, -0.2f, -1.0f);

        DirectionalLight light1
            = new DirectionalLight(light1Color, light1Direction);
        light1.setInfluencingBounds(bounds);
        objRoot.addChild(light1);


        /**
        // ====================================================================================

        // Final Translation of the objRoot before attaching it to the scene
        Transform3D scaleTrans2 = new Transform3D();
        scaleTrans2.set(0.42f, new Vector3f(-0.4f, -0.39f, 0.0f)); // scale by 3.5x
        objScale.setTransform(scaleTrans2);

        **/

		// Perform the below rotation for the initial angle rotation of the cube
		cubeRotateAxis.x = 0.0f;
		cubeRotateAxis.y = 1.0f; // force y axis rotation
		cubeRotateAxis.z = 0.0f;
		cubeRotateAngle =  -50.0f;
		performRotateTransformationforSetValues();

		//====================================================================================
		//enablePicking(objRoot);

        objRoot.compile();

		return objRoot;

    }
    
    
    /*****************************************************************
	 * Returns the TransformGroup we will be editing to change the
	 * transform on the cube
 	 *****************************************************************/

    public void enablePicking(Node node) { 

        node.setPickable(true); 
        node.setCapability(Node.ENABLE_PICK_REPORTING); 

        try { 
           Group group = (Group) node;
           for (Enumeration e = group.getAllChildren(); e.hasMoreElements();) {
              enablePicking((Node)e.nextElement()); 
           } 

        } catch(ClassCastException e) {
            // if not a group node, there are no children so ignore exception
        } 

        try { 
              Shape3D shape = (Shape3D) node;
              System.out.println("enabledPicking for Shape3D object " + shape.toString());
              PickTool.setCapabilities(node, PickTool.INTERSECT_FULL);
              for (Enumeration e = shape.getAllGeometries(); e.hasMoreElements();) {
                 Geometry g = (Geometry)e.nextElement(); 
                 g.setCapability(Geometry.ALLOW_INTERSECT); 
              }
           } 

        catch(ClassCastException e) { 

           // not a Shape3D node ignore exception 

        } 

    } 







	/*****************************************************************
	 * Returns the TransformGroup we will be editing to change the
	 * transform on the cube
 	 *****************************************************************/

    TransformGroup createCubeTransformGroup(CubeInfo cubeInfo, float dimension, Vector3f pos, Color3f color, float transparency) {
    	
    	Transform3D transform = new Transform3D();
    	TransformGroup coordinatesGroup = new TransformGroup();

    	tmpTrans = new Transform3D();
    	tmpVector = new Vector3f();


    	float labelOffset = coordSysLength / 20.0f;
    	float axisRadius  = coordSysLength / 500.0f;
    	float arrowRadius = coordSysLength / 125.0f;
    	float arrowHeight = coordSysLength / 50.0f;
    	float tickRadius  = coordSysLength / 250.0f;
    	float tickHeight  = coordSysLength / 250.0f;


    	Font3D f3d = new Font3D(new Font("Default", Font.PLAIN, 1), null);

    	// Create a TransformGroup for the Outer Cube, allow tranform changes,
    	transform.setTranslation(pos);
		//outerCubeTG = new TransformGroup(transform);
		outerCubeTG = new TransformGroup();
		outerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
		outerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);		
		
		
		TransparencyAttributes ta = new TransparencyAttributes();
        ta.setTransparencyMode (ta.BLENDED);
        ta.setTransparency (transparency);



        Material m = new Material(color, color, color, color, 75.0f);
        m.setLightingEnable(true);


        Appearance a = new Appearance();
        PolygonAttributes pa = new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        a.setMaterial(m);
        a.setPolygonAttributes(pa);
        a.setTransparencyAttributes(ta);


        Appearance a1 = getWireframeAppearance(color);
   
		// create the outer transparent cube
		Cube cube = new Cube(dimension, a1); //a4=transparent, a1=wired
			
		
		System.out.println("Created Outer Cube = " + cube.toString());

			
		InnerCube[] innerCubes = cubeInfo.getInnerCubes();
		
		//Inspector.inspect(innerCubes);
		
		for(int i=0; i<innerCubes.length; i++) {
			InnerCube innerCube = innerCubes[i];
			
			UserData userData = new UserData();
			userData.setXAxisValue(innerCube.getXAxisValue());
			userData.setYAxisValue(innerCube.getYAxisValue());
			userData.setZAxisValue(innerCube.getZAxisValue());
			userData.setSector(innerCube.getSector());
			userData.setSubSectors(innerCube.getSubSectors());
			
			if(i==0) {
				outerCubeTG.addChild(createInnerCubeTransformGroup(0.04f, new Vector3f(-0.256f, 0.25f, 0.856f), blue, 0.0f, userData));
			}	
			if(i==1) {
				outerCubeTG.addChild(createInnerCubeTransformGroup(0.04f, new Vector3f(-0.256f, 0.25f, -0.0f), blue, 0.0f, userData));
			}
			if(i==2) {
				outerCubeTG.addChild(createInnerCubeTransformGroup(0.04f, new Vector3f(0.75f, 0.75f, -1.0f), blue, 0.0f, userData));
			}
			
		}
		
		System.out.println("Adding Outer Cube = " + cube.toString());
		outerCubeTG.addChild(cube);

		return outerCubeTG;

    }
    
    
    
    
    /*****************************************************************
	 * Returns the TransformGroup we will be editing to change the
	 * transform on the cube
 	 *****************************************************************/

    TransformGroup createInnerCubeTransformGroup(float dimension, Vector3f pos, Color3f color,
    				float transparency, UserData cubeInfo) {

    	// create a TransformGroup for the cube, allow tranform changes,
		innerCubeTG = new TransformGroup();
		
		innerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
		innerCubeTG.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);		
		innerCubeTG.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
		innerCubeTG.setCapability(TransformGroup.ALLOW_CHILDREN_READ);
		innerCubeTG.setCapability(TransformGroup.ALLOW_CHILDREN_WRITE);

				
        Material m = new Material(color, color, color, color, 75.0f);

        Appearance a = new Appearance();
        PolygonAttributes pa = new PolygonAttributes();
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        a.setMaterial(m);
        a.setPolygonAttributes(pa);

        // create the cube, and user data  and add it to the innerCubeTG
		//Cube cube = new Cube(dimension, a);
		//cube.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
		//cube.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		//cube.setCapability(Shape3D.ALLOW_PICKABLE_READ);
		//cube.setCapability(Shape3D.ALLOW_PICKABLE_WRITE);
		//cube.setCapability(Shape3D.ENABLE_PICK_REPORTING);
		Box cube = new Box(dimension, dimension, dimension,
                Primitive.ENABLE_GEOMETRY_PICKING|Primitive.GENERATE_NORMALS,
                 a, 1);
		
		cube.setCapability(Shape3D.ENABLE_PICK_REPORTING);
		
		cube.setUserData(cubeInfo);
		innerCubeTG.addChild(cube);
		
		
		Transform3D transform = new Transform3D();
    	transform.setTranslation(pos);
		innerCubeTG.setTransform(transform);
		
		
		System.out.println("created inner cube = " + cube.toString());

		return innerCubeTG;

    }





    /*****************************************************************
	 * Returns the Wireframe Appearance
 	 *****************************************************************/
    public static Appearance getWireframeAppearance(Color3f color) {
        Appearance app = new Appearance();
        //Color awtColor = new Color(255, 255, 0);// use any Color you like
        //Color3f color = new Color3f(awtColor);
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(color);
        app.setColoringAttributes(ca);
        PolygonAttributes pa = new PolygonAttributes();
        pa.setPolygonMode(PolygonAttributes.POLYGON_LINE);
        pa.setCullFace(PolygonAttributes.CULL_NONE);
        app.setPolygonAttributes(pa);
        return app;
      }


	/*****************************************************************
	 *
	 *
 	 *****************************************************************/

    void setCubeUScale() {

		outerCubeTG.getTransform(tmpTrans); // get the old transform
		tmpTrans.setScale(cubeScale);  // set only scale
		outerCubeTG.setTransform(tmpTrans); // set the new transform

    }


	/*****************************************************************
	 *
	 *
 	 *****************************************************************/

    void setCubeNUScale() {

		outerCubeTG.getTransform(tmpTrans); // get the old transform
		System.out.println("cubeNUScale.x = " + cubeNUScale.x);
		tmpTrans.setScale(cubeNUScale);// set only scale
		outerCubeTG.setTransform(tmpTrans); // set the new transform

    }


	/*****************************************************************
	 *
	 *
 	 *****************************************************************/

    void setCubeRotation() {

		outerCubeTG.getTransform(tmpTrans); // get the old transform
		tmpTrans.setRotation(cubeRotateAxisAngle); // set only rotation
		outerCubeTG.setTransform(tmpTrans); // set the new transform

    }


    /*****************************************************************
	 *
	 *
 	 *****************************************************************/

    void updateUsingCompoundTransform() {

		// set the component transformations
		translateTrans.set(cubeTranslation);
		if (useUniformScale) {
		    scaleTrans.set(cubeScale);
		} else {
		    scaleTrans.setIdentity();
		    scaleTrans.setScale(cubeNUScale);
		}
		rotateTrans.set(cubeRotateAxisAngle);

		// translate from ref pt to origin
		tmpVector.sub(origin, cubeRefPt); // vector from ref pt to origin
		refPtTrans.set(tmpVector);

		// translate from origin to ref pt
		tmpVector.sub(cubeRefPt, origin); // vector from origin to ref pt
		refPtInvTrans.set(tmpVector);

		// now build up the transfomation
		// trans = translate * refPtInv * scale * rotate * refPt;
		tmpTrans.set(translateTrans);
		tmpTrans.mul(refPtInvTrans);
		tmpTrans.mul(scaleTrans);
		tmpTrans.mul(rotateTrans);
		tmpTrans.mul(refPtTrans);

		// Copy the transform to the TransformGroup
		outerCubeTG.setTransform(tmpTrans);

    }


    /*****************************************************************
	 * Ensure that the cube rotation axis is a unit vector
	 *
 	 *****************************************************************/

    void normalizeCubeRotateAxis() {

		// normalize, watch for length == 0, if so, then use default
		float lengthSquared = cubeRotateAxis.lengthSquared();
		if (lengthSquared > 0.0001) {
		    cubeRotateNAxis.scale((float)(1.0 / Math.sqrt(lengthSquared)),
			cubeRotateAxis);
		} else {
		    cubeRotateNAxis.set(1.0f, 0.0f, 0.0f);
		}

    }


	/*****************************************************************
	 * copy the current axis and angle to the axis angle, convert angle
     * to radians
 	 *****************************************************************/

    void updateCubeAxisAngle() {

		cubeRotateAxisAngle.set(cubeRotateNAxis,
					(float)Math.toRadians(cubeRotateAngle));

    }


	/*****************************************************************
	 *
	 *
 	 *****************************************************************/

    void updateCubeRotateNormalizedLabels() {

		nf.setMinimumFractionDigits(2);
		nf.setMaximumFractionDigits(2);

    }



    /*****************************************************************
	 *
	 *
	 *****************************************************************/

    void updateCubeRotateAngleNormalizedLabel() {

		//cubeRotateNAxisAngleLabel.setText("Angle: " + nf.format(cubeRotateAngle));
		// Need to muck around to try to make sure that the width of the label
	   	// is wide enough for the largest value.  Pad the string
	   	// be large enough to hold the largest value.
	   	int pad = 8;  // fudge to make up for variable width fonts
	   	int min = 0;
	   	int max = 360;
	   	float maxVal = Math.max(Math.abs(min), Math.abs(max));
	   	int intDigits = Math.round((float)(Math.log(maxVal) / Math.log(10))) + pad;
	   	if (min < 0) {
	   		intDigits++; // add one for the '-'
	   	}

	   	// fractDigits is num digits of resolution for fraction. Use base 10 log
	   	// of scale, rounded up, + 2.
	   	int scale = 2;
	   	int fractDigits = (int) Math.ceil((Math.log(scale) / Math.log(10)));
	   	nf.setMinimumFractionDigits(fractDigits);
	   	nf.setMaximumFractionDigits(fractDigits);
	   	String value = nf.format((float) cubeRotateAngle);
	   	while (value.length() < (intDigits + fractDigits)) {
	   		value = value + "  ";
	   	}

	   
   }












    /*****************************************************************
	 * canvasPanel()
	 *****************************************************************/

	JPanel canvasPanel() {

		JPanel panel = new JPanel(new BorderLayout());

		canvas = new Canvas3D(config);
		canvas.addMouseListener(new java.awt.event.MouseAdapter() {
		      public void mouseClicked(MouseEvent e) {
		        canvas_mouseClicked(e);
		      }
		    });
		panel.add("Center", canvas);

		panel.add("East", yAxisSliderPanel());

		panel.add("South", xAxisSliderPanel());


		return panel;

	}
	

	/*****************************************************************
	 * yAxisSliderPanel()
 	 *****************************************************************/	
	void canvas_mouseClicked(MouseEvent e) {
		
	     //TransformGroup tg = null;
	     Shape3D sh = null;
	     Box box = null;

	     //PickCanvas pickCanvas = new PickCanvas(u.getCanvas(), u.getLocale());
	     PickCanvas pickCanvas = new PickCanvas(u.getCanvas(), objRoot);
	     pickCanvas.setTolerance(0.0f);
	     pickCanvas.setShapeLocation(e);
	          
	     
	     PickResult pr = pickCanvas.pickClosest();

	     if ((pr != null)&&
	         ((sh = (Shape3D) pr.getNode(PickResult.SHAPE3D)) != null)&&
	         ((box = (Box) pr.getNode(PickResult.PRIMITIVE)) != null)) {
	             String mensaje = "";
	             if (sh.equals(box.getShape(Box.FRONT))) mensaje += "FRONT was clicked";
	             if (sh.equals(box.getShape(Box.BACK))) mensaje += "BACK was clicked";
	             if (sh.equals(box.getShape(Box.BOTTOM))) mensaje += "BOTTOM was clicked";
	             if (sh.equals(box.getShape(Box.LEFT))) mensaje += "LEFT was clicked";
	             if (sh.equals(box.getShape(Box.RIGHT))) mensaje += "RIGHT was clicked";
	             if (sh.equals(box.getShape(Box.TOP))) mensaje += "TOP was clicked";
	             System.out.println(mensaje);
	     }
	     
	     if ((pr != null)&&
		         ((sh = (Shape3D) pr.getNode(PickResult.SHAPE3D)) != null)) {		             		             
		             System.out.println(sh.toString());
		 }
	     
	}
	
	


	/*****************************************************************
	 * yAxisSliderPanel()
 	 *****************************************************************/

	JPanel yAxisSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.VERTICAL;
		c.gridx = 0;
		c.weightx = 0;
		c.weighty = 0.5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy = 2;
		c.insets = new Insets(50,10,70,0);

		FloatLabelJSliderVertical cubeRotateYAxisAngleSlider = new FloatLabelJSliderVertical(
				"Rotate Y:", 1.0f, -50.0f, 230.0f, (float) cubeRotateAxis.y);
		cubeRotateYAxisAngleSlider.setMajorTickSpacing(1.0f);
		cubeRotateYAxisAngleSlider.setPaintTicks(true);

		cubeRotateYAxisAngleSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				cubeRotateAxis.x = 0.0f;
				cubeRotateAxis.y = 0.1f; // force y axis rotation
				cubeRotateAxis.z = 0.0f;
				cubeRotateAngle = e.getValue();

				performRotateTransformationforSetValues();
			}
		});
		panel.add(cubeRotateYAxisAngleSlider,c);

		return panel;

	}



	/*****************************************************************
	 * xAxisSliderPanel()
 	 *****************************************************************/

	JPanel xAxisSliderPanel() {

		JPanel panel = new JPanel(new GridBagLayout());

		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		c.gridx = 2;
		c.weightx = 0.5;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.gridy = 0;
		c.insets = new Insets(5,65,10,200);

		FloatLabelJSliderHorizontal cubeRotateAxisXSlider = new FloatLabelJSliderHorizontal(
				"Rotate X:", 1.0f, 0.0f, 180.0f, (float) cubeRotateAxis.x);
		cubeRotateAxisXSlider.setMajorTickSpacing(1.0f);
		cubeRotateAxisXSlider.setPaintTicks(true);

		cubeRotateAxisXSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				cubeRotateAxis.x = 0.1f; // force x axis rotation
				cubeRotateAxis.y = 0.0f;
				cubeRotateAxis.z = 0.0f;
				cubeRotateAngle = e.getValue();

				performRotateTransformationforSetValues();

			}
		});
		panel.add(cubeRotateAxisXSlider,c);


		return panel;
	}


	/*****************************************************************
	 * perform rotation transformation for x axis and y axis sliders
 	 *****************************************************************/
	void performRotateTransformationforSetValues() {

		normalizeCubeRotateAxis();

		updateCubeAxisAngle();
		if (useCompoundTransform) {
			updateUsingCompoundTransform();
		} else {
			setCubeRotation();
		}
		//rotAxis.setRotationAxis(cubeRotateAxis);
		updateCubeRotateNormalizedLabels();
		//updateCubeRotateAngleNormalizedLabel();

	}




	/*****************************************************************
	 * searchPanel()
 	 *****************************************************************/

	JPanel searchPanel() {

		JPanel panel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		JButton search = new JButton("Search:");
		JTextField searchText = new JTextField(25);
		searchText.setBorder( new LineBorder(Color.red, 1) );
		c.gridx = 0;
		c.gridy = 1;
		c.weightx = 0.0;
		c.insets = new Insets(0,250,10,0);
		panel.add(search,c);

		c.gridx = 2;
		c.gridy = 1;
		c.insets = new Insets(0,10,10,250);
		c.weightx = 0.0;
		panel.add(searchText,c);

		return panel;

	}



	/*****************************************************************
	 * zoomPanel():
 	 *****************************************************************/

	JPanel zoomPanel() {

		JPanel panel = new JPanel(new GridBagLayout());
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;

		// Uniform Scaling...
		FloatLabelJSlider cubeScaleSlider = new FloatLabelJSlider(
						"Zoom:", 0.1f, 0.3f, 1.0f, cubeScale);
		cubeScaleSlider.setMajorTickSpacing(1.0f);
		cubeScaleSlider.setPaintTicks(true);
		cubeScaleSlider.addFloatListener( new FloatListener() {
			public void floatChanged(FloatEvent e) {
				cubeScale = e.getValue();
					useUniformScale = true;
				if (useCompoundTransform) {
					updateUsingCompoundTransform();
				} else {
					setCubeUScale();
				}
			}
		});
		c.gridx = 0;
		c.gridy = 0;
		c.insets = new Insets(10,0,0,420); 
		panel.add(cubeScaleSlider, c);		
		
		
		return panel;

	}
	
	
	/*****************************************************************
	 * Called from JSP via JavaScript
     *
	 *****************************************************************/
	
	public void backButtonPressed() {
		
		// parent of parent gets us the objRoot node declared in createSceneGraph method.
		// We can then redraw the cube.    					
		if(objRoot != null) {
			objRoot.detach();    					
			objRoot = null;
		}	
		
		
		// Get Level 1 Cube Info from CubeInfoServlet
		HashMap response = new HashMap();
		
		response = (HashMap) getCubeInfoFromServlet();
		CubeInfo cubeInfo = (CubeInfo) response.get("Level1");
		
		BranchGroup scene = createSceneGraph(cubeInfo);
		u.addBranchGraph(scene);
		
		
	}
	
	
	
   	/*****************************************************************
	 *
     *
	 *****************************************************************/

    public void destroy() {

		u.removeAllLocales();
		u.cleanup();

    }


    /*****************************************************************
	 * init():
	 *
 	 *****************************************************************/
    public void init() {


    	// input parameter setup
    	userId = getParameter("userId");
    	portfolioId = getParameter("portfolioId");
    	xAxisLabel = getParameter("xAxisLabel");
    	yAxisLabel = getParameter("yAxisLabel");
    	zAxisLabel = getParameter("zAxisLabel");
    	assetClassList = getParametersArray(getParameter("assetClassParm"));


    	System.out.println("userId = " + userId);
    	portfolioId = getParameter("portfolioId");

    	//Inspector.inspect(assetClassParm);

		setLayout(new BorderLayout());
		config = SimpleUniverse.getPreferredConfiguration();

		add("Center", canvasPanel());
		
		// Get Level 1 Cube Info from CubeInfoServlet
		HashMap response = new HashMap();
		
		response = (HashMap) getCubeInfoFromServlet();
		CubeInfo cubeInfo = (CubeInfo) response.get("Level1");
		
		
		// Create a simple scene and attach it to the virtual universe
		u = new SimpleUniverse(canvas);
		BranchGroup scene = createSceneGraph(cubeInfo);
		
		
		// get the view
		//Transform3D t3d = new Transform3D();
		//t3d.ortho(-2.0, 2.0, -2.0, 2.0, -2.0, 2.0);
		
		view = u.getViewer().getView();
		//view.setCompatibilityModeEnable(true);
		//view.setLeftProjection(t3d);
		//view.setRightProjection(t3d);
		//view.setProjectionPolicy(View.PARALLEL_PROJECTION);
		

        // This will move the ViewPlatform back a bit so the
        // objects in the scene can be viewed.
		ViewingPlatform viewingPlatform = u.getViewingPlatform();
		viewingPlatform.setNominalViewingTransform();

        // add an orbit behavior to move the viewing platform
        //OrbitBehavior orbit = new OrbitBehavior(canvas,
        //                                       OrbitBehavior.STOP_ZOOM);
        //BoundingSphere bounds =
        //    new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
        //orbit.setSchedulingBounds(bounds);
        //viewingPlatform.setViewPlatformBehavior(orbit);

		u.addBranchGraph(scene);

		add("North", zoomPanel());

		//add("South", searchPanel());

		
    }

    
    
    
    /*****************************************************************
     * Retrieve Cube Information from the CubeInfoServlet 
     *****************************************************************/

     private Map getCubeInfoFromServlet() {
    	  
    	Map responseMap = new HashMap();
 				
 		// Initialize the Axis Label Arrays
 		String[] assetClass = {"Asia Growth Equities", "Asia Value Equities", "Asia Investment Grade Bonds", "Europe Growth Equities", "Europe Value Equities"};
        String[] marketCapitalization = {"50M", "100M", "150M", "200M", "250M", "300M", "350M", "400M",
         		"450M", "500M", "550M"};		
        String[] sector = {"Automotive", "Retail", "Utilities", "Transportation", "Real Estate"};
 		
 		InnerCube[] innerCubes = new InnerCube[3];
 		InnerCube innerCube = null;
 		for(int i =0; i<innerCubes.length; i++) {
 			switch(i) {
 				case 0:
 					innerCube = new InnerCube();			
 					innerCube.setXAxisValue("Europe Value Equities");
 					innerCube.setYAxisValue("100M");
 					innerCube.setZAxisValue("Automotive");
 					innerCube.setSector("Automotive");
 					//innerCube.setColor(new Color3f(0.0f, 0.0f, 1.0f)); //blue
 					innerCube.setSubSectors( new String[] {"Auto Parts", "Recreational Vehicles",
 							                                "Trucks & Other Vehicles"});
 					innerCubes[i] = innerCube;
 					break;
 				case 1:
 					innerCube = new InnerCube();			
 					innerCube.setXAxisValue("Europe Growth Equities");
 					innerCube.setYAxisValue("100M");
 					innerCube.setZAxisValue("Real Estate");
 					innerCube.setSector("Real Estate");
 					//innerCube.setColor(new Color3f(0.0f, 1.0f, 0.0f)); //yellow
 					innerCube.setSubSectors( new String[] {"Commercial", "Residential"});
 					innerCubes[i] = innerCube;
 					break;
 				case 2:
 					innerCube = new InnerCube();			
 					innerCube.setXAxisValue("Asia Value Equities");
 					innerCube.setYAxisValue("200M");
 					innerCube.setZAxisValue("Transportation");
 					innerCube.setSector("Transportation");
 					//innerCube.setColor(new Color3f(0.0f, 1.0f, 0.0f)); //yellow
 					innerCube.setSubSectors( new String[] {"Gas", "Electricity"});
 					innerCubes[i] = innerCube;
 					break;
 			}
 		}
         
        CubeInfo cubeInfo = new CubeInfo();
 		cubeInfo.setXAxisLabels(assetClass);
 		cubeInfo.setYAxisLabels(marketCapitalization);
 		cubeInfo.setZAxisLabels(sector);
 		cubeInfo.setInnerCubes(innerCubes);
 		
 		/*
 		put watever objects you wants to return to applet.
 		This objects must be serializable. */

 		responseMap.put("Level1", cubeInfo);
 		
 		return responseMap;
 		
        
      }
    
    

    /*****************************************************************
	 * Splitting input parms into a String Array
	 *
	 *****************************************************************/
    public static String[] getParametersArray(String paramStr) {

		// Put the parameters into a vector first, because you don't
		// know how many parameters you are getting.
		Vector vec = new Vector();

		if (paramStr == null)
				return new String[0];

		// If you got the parameter, add the it to the vector
		vec.addElement(paramStr);

		// The tokenizer will separate out the parameters from the string
		StringTokenizer tok = new StringTokenizer(paramStr, "/");


		// Create a string array to hold the values
		String[] returnValues = new String[vec.size()];

		// Copy the vector values into the new string array
		vec.copyInto((Object[]) returnValues);

		return returnValues;

	}




	/*****************************************************************
	 * The following allows DynamicCube3d to be run as an application
     * as well as an applet call java DynamicCube3d -s 950, 600
	 *
	 *****************************************************************/

    public static void main(String[] args) {

		float initOffScreenScale = 2.5f;
		for (int i = 0; i < args.length; i++) {
	    	if (args[i].equals("-s")) {
				if (args.length >= (i+1)) {
		    		initOffScreenScale = Float.parseFloat(args[i+1]);
		    	i++;
				}
		    }
		}

		MainFrame frame = new MainFrame(new PickingDynamicCube3d (true, initOffScreenScale),
													950, 760);
		frame.setTitle("Portfolio 3D Cube");
    }

}
