package com.asc.behaviors;

import java.awt.AWTEvent;
import java.awt.event.MouseEvent;
import java.util.Enumeration;

import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnAWTEvent;
import javax.swing.SwingUtilities;
import javax.vecmath.Matrix3d;
import javax.vecmath.Matrix4d;
import javax.vecmath.Vector3d;

import com.asc.applets.DynamicCube3d;
import com.asc.utils.Java3DMath;
import com.sun.j3d.utils.behaviors.mouse.MouseRotate;

public class RestrictedMouseRotate extends MouseRotate {

	double y_angle;
	double y_factor;
	
	double x_angle;
	double x_factor;
		
	
	public RestrictedMouseRotate(TransformGroup transformGroup) {			
		super(transformGroup);	
		setFactor(0.03d, 0.03d);	
		
	}

	public void transformChanged(Transform3D transform) {

		
		System.out
				.println("Mouse Rotate callback function from RestrictedMouseRotate ...:");

		if (transform != null) {
			System.out
					.println("Mouse Rotate callback function from RestrictedMouseRotate...:"
							+ transform.toString());
		}

	}

	public void initialize() {
		super.initialize();
		y_angle = 0;
		y_factor = .01;
		
		x_angle = 0;
		x_factor = .01;
		
				
		
		if ((flags & INVERT_INPUT) == INVERT_INPUT) {
			invert = true;
			y_factor *= -1;
			x_factor *= -1;
		}
	}
	
	

	public double getYFactor() {
		return y_factor;
	}

	
	public double getXFactor() {
		return x_factor;
	}
	
	public void setFactor(double factor) {
		y_factor = factor;
		x_factor = factor;
	}

	
	
	public void processStimulus(Enumeration criteria) {
		
			
		WakeupCriterion wakeup;
		AWTEvent[] event;
		int id;
		int dx;
		int dy;
		
		
		while (criteria.hasMoreElements()) {
			wakeup = (WakeupCriterion) criteria.nextElement();
			if (wakeup instanceof WakeupOnAWTEvent) {
				event = ((WakeupOnAWTEvent) wakeup).getAWTEvent();
				for (int i = 0; i < event.length; i++) {
					processMouseEvent((MouseEvent) event[i]);
					
					
					
					if (((buttonPress) && ((flags & MANUAL_WAKEUP) == 0))
							|| ((wakeUp) && ((flags & MANUAL_WAKEUP) != 0))) {
						
						
						id = event[i].getID();
						if ((id == MouseEvent.MOUSE_DRAGGED)								
								&& !((MouseEvent) event[i]).isAltDown()) {
							
							x = ((MouseEvent) event[i]).getX();
							y = ((MouseEvent) event[i]).getY();

							dx = x - x_last;
							dy = y - y_last;
							
							System.out.println("delta in y movement = " + dy);
							System.out.println("delta in x movement = " + dx);
							

							if (!reset) {
								
								//	 If Right mouse button pressed
								//if( SwingUtilities.isRightMouseButton((MouseEvent)event[i]) ) {
								if(dy != 0 && dx == 0) {
									x_angle = dy * x_factor;
									transformY.rotX(x_angle);
								}
								
								// If Left mouse button pressed
								//if( SwingUtilities.isLeftMouseButton((MouseEvent)event[i]) ) {
								if(dx != 0 && dy == 0) {
									y_angle = dx * y_factor;
									transformY.rotY(y_angle);
								} 
									

								transformGroup.getTransform(currXform);

								// Vector3d translation = new Vector3d();
								// Matrix3f rotation = new Matrix3f();
								Matrix4d mat = new Matrix4d();
								
								// Remember old matrix
								currXform.get(mat);
								

								// Translate to origin
								currXform.setTranslation(new Vector3d(0.0, 0.0,
										0.0));
								if (invert) {
									currXform.mul(currXform, transformX);
									currXform.mul(currXform, transformY);
								} else {
									currXform.mul(transformX, currXform);
									currXform.mul(transformY, currXform);
								}

								// Set old translation back
								Vector3d translation = new Vector3d(mat.m03,
										mat.m13, mat.m23);
								currXform.setTranslation(translation);

								// Update xform
								transformGroup.setTransform(currXform);
																
								
								Matrix3d m = new Matrix3d();
								currXform.get(m);
								
								Vector3d vect = Java3DMath.rotationMatrixToEuler(m);
								
								System.out.println("*********** vect.x *********" + vect.x + ", " + (int)Math.toDegrees(vect.x));
								System.out.println("*********** vect.y *********" + vect.x + ", " + (int)Math.toDegrees(vect.y));
								System.out.println("*********** vect.z *********" + vect.x + ", " + (int)Math.toDegrees(vect.z));
																
								// Dynamically move the Jslider for the rotations
								DynamicCube3d.rotationByMouse = true;
								
//								// Add 50.0f for compensating the Y slider value
								int Xdeg = (int) Math.toDegrees(vect.x);  
								int Ydeg = (int)(Math.toDegrees(vect.y)+50.0f);
								
								DynamicCube3d.cubeRotateXAxisAngleSlider.slider.setValue(Xdeg);
								DynamicCube3d.cubeRotateYAxisAngleSlider.slider.setValue(Ydeg);
								DynamicCube3d.rotationByMouse = false;
								
							} else {
								reset = false;
							}

							x_last = x;
							y_last = y;
							
						} else if (id == MouseEvent.MOUSE_PRESSED) {
							
							x_last = ((MouseEvent) event[i]).getX();
							y_last = ((MouseEvent) event[i]).getY();
							
						}
					}
					
				}
			}
		}

		wakeupOn(mouseCriterion);

	}
	

}
