package com.asc.behaviors;

import java.awt.AWTEvent;
import java.awt.event.MouseEvent;
import java.util.Enumeration;

import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnAWTEvent;
import javax.vecmath.Matrix4d;
import javax.vecmath.Vector3d;

import com.sun.j3d.utils.behaviors.mouse.MouseRotate;

public class RestrictedMouseXRotate extends MouseRotate {

	double x_angle;
	double x_factor;
	
	
	public RestrictedMouseXRotate(TransformGroup transformGroup) {
		super(transformGroup);		
	}

	public void transformChanged(Transform3D transform) {

		System.out.println("getXFactor() " + getXFactor());
		System.out.println("getYFactor() " + getYFactor());

		System.out
				.println("Mouse Rotate callback function from RestrictedMouseRotate ...:");

		if (transform != null) {
			System.out
					.println("Mouse Rotate callback function from RestrictedMouseRotate...:"
							+ transform.toString());
		}

	}

	public void initialize() {
		super.initialize();
		x_angle = 0;
		x_factor = .03;
		
				
		
		if ((flags & INVERT_INPUT) == INVERT_INPUT) {
			invert = true;
			x_factor *= -1;
		}
	}
	
	

	public double getYFactor() {
		return x_factor;
	}

	
	
	public void setFactor(double factor) {
		x_factor = factor;

	}

	
	
	public void processStimulus(Enumeration criteria) {
		WakeupCriterion wakeup;
		AWTEvent[] event;
		int id;
		int dx;

		while (criteria.hasMoreElements()) {
			wakeup = (WakeupCriterion) criteria.nextElement();
			if (wakeup instanceof WakeupOnAWTEvent) {
				event = ((WakeupOnAWTEvent) wakeup).getAWTEvent();
				for (int i = 0; i < event.length; i++) {
					processMouseEvent((MouseEvent) event[i]);

					if (((buttonPress) && ((flags & MANUAL_WAKEUP) == 0))
							|| ((wakeUp) && ((flags & MANUAL_WAKEUP) != 0))) {

						id = event[i].getID();
						if ((id == MouseEvent.MOUSE_DRAGGED)
								&& !((MouseEvent) event[i]).isMetaDown()
								&& !((MouseEvent) event[i]).isAltDown()) {

							x = ((MouseEvent) event[i]).getX();

							dx = x - x_last;

							if (!reset) {
								x_angle = dx * x_factor;

								transformY.rotX(x_angle);

								transformGroup.getTransform(currXform);

								// Vector3d translation = new Vector3d();
								// Matrix3f rotation = new Matrix3f();
								Matrix4d mat = new Matrix4d();

								// Remember old matrix
								currXform.get(mat);

								// Translate to origin
								currXform.setTranslation(new Vector3d(0.0, 0.0,
										0.0));
								if (invert) {
									currXform.mul(currXform, transformX);
									currXform.mul(currXform, transformY);
								} else {
									currXform.mul(transformX, currXform);
									currXform.mul(transformY, currXform);
								}

								// Set old translation back
								Vector3d translation = new Vector3d(mat.m03,
										mat.m13, mat.m23);
								currXform.setTranslation(translation);

								// Update xform
								transformGroup.setTransform(currXform);
							} else {
								reset = false;
							}

							x_last = x;
						} else if (id == MouseEvent.MOUSE_PRESSED) {
							x_last = ((MouseEvent) event[i]).getX();
						}
					}
				}
			}
		}

		wakeupOn(mouseCriterion);

	}

}
