package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class AssetClassDB extends DBAPI {


    private static final String className = "AssetClassDB.";

    /**
     *
     * @param context
     */
    public AssetClassDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "AssetClassDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Role table
     *
     * @param newAssetClass
     */
    public int createAssetClass(AssetClass newAssetClass)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Asset_Class_ID = 0;
        String location = className + "createAssetClass";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Object: " + newAssetClass.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Asset_Class (" +
                    "Asset_Class_ID, "+
                    "Asset_Class_Name "+
                    " ) " +
                    " values ('" +
                    newAssetClass.getAssetClassIdString()+"','"+
                    newAssetClass.getAssetClassName()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Role record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Asset_Class_ID;
    }



    /**
     * Function that creates a record in the Role table
     *
     * @param newAssetClass
     */
    public boolean modifyAssetClass(AssetClass newAssetClass)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyAssetClass";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Asset Class Object: " + newAssetClass.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Asset_Class set"
                               + " Asset_Class_Name = '"
                               + newAssetClass.getAssetClassName()
                               + "' where Asset_Class_ID = "
							   + newAssetClass.getAssetClassIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Asset Class record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getAssetClassList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        AssetClass assetClassEntry = null;
        Collection assetClass = new ArrayList();

        String location = className + "getAssetClassList";

        this.logger.debugMessage(location);

        String sql = "select * from Asset_Class;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                assetClassEntry = new AssetClass();
                assetClassEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                assetClassEntry.setAssetClassName(convertFromDBString(rs.getString("Asset_Class_Name")));

                assetClass.add(assetClassEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return assetClass;



	}


    /**
     *
     * @param Asset_Class_ID
     */
    public AssetClass getAssetClass(String Asset_Class_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        AssetClass assetClassEntry = null;

        String location = className + "getAssetClass";

        this.logger.debugMessage(location);

        String sql = "select * from Asset_Class where Asset_Class_ID=";
        sql += Asset_Class_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                assetClassEntry = new AssetClass();
                assetClassEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                assetClassEntry.setAssetClassName(convertFromDBString(rs.getString("Asset_Class_Name")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return assetClassEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}