package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class AuditEventDB extends DBAPI {


    private static final String className = "AuditEventDB.";

    /**
     *
     * @param context
     */
    public AuditEventDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "AuditEventDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the AuditEvent table
     *
     * @param newAuditEvent
     */
    public int createAuditEvent(AuditEvent newAuditEvent)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Event_ID = 0;
        String location = className + "createAuditEvent";
        this.logger.debugMessage(location);
        this.logger.debugMessage("AuditEvent Object: " + newAuditEvent.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Audit_Event (" +
                    "Event_ID, "+
                    "Event_Type "+
                    " ) " +
                    " values ('" +
                    newAuditEvent.getAuditEventIdString()+"','"+
                    newAuditEvent.getAuditEventType()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one AuditEvent record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Event_ID;
    }



    /**
     * Function that creates a record in the AuditEvent table
     *
     * @param newAuditEvent
     */
    public boolean modifyAuditEvent(AuditEvent newAuditEvent)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyAuditEvent";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Audit Event Object: " + newAuditEvent.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Audit_Event set"
                               + " Event_Type = '"
                               + newAuditEvent.getAuditEventType()
                               + "' where Event_ID = "
							   + newAuditEvent.getAuditEventIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Audit Event record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getAuditEventList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        AuditEvent auditEventEntry = null;
        Collection auditEventList = new ArrayList();

        String location = className + "getAuditEventList";

        this.logger.debugMessage(location);

        String sql = "select * from Audit_Event;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                auditEventEntry = new AuditEvent();
                auditEventEntry.setAuditEventId(rs.getInt("Event_ID"));
                auditEventEntry.setAuditEventType(convertFromDBString(rs.getString("Event_Type")));

                auditEventList.add(auditEventEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return auditEventList;



	}


    /**
     *
     * @param Event_ID
     */
    public AuditEvent getAuditEvent(String Event_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        AuditEvent auditEventEntry = null;

        String location = className + "getAuditEvent";

        this.logger.debugMessage(location);

        String sql = "select * from Audit_Event where Event_ID=";
        sql += Event_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                auditEventEntry = new AuditEvent();
                auditEventEntry.setAuditEventId(rs.getInt("Event_ID"));
                auditEventEntry.setAuditEventType(convertFromDBString(rs.getString("Event_Type")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return auditEventEntry;

    }

    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}