package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.Axis;

public class AxisDB extends DBAPI {


    private static final String className = "AxisDB.";

    /**
     *
     * @param context
     */
    public AxisDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "AxisDB";
        this.logger.debugMessage(location);
    }

    public String getTableName(String axisType){
		 if (axisType.equals("X") || axisType.equals("x"))
		 {
			return new String("X_Axis");
         }
		 if (axisType.equals("Y") || axisType.equals("y"))
		 {
			return new String("Y_Axis");
         }
		 if (axisType.equals("Z") || axisType.equals("z"))
		 {
			return new String("Z_Axis");
         }

         return "";
    }

    /**
     * Function that creates a record in the Axis table
     *
     * @param newAxis
     */
    public int createAxis(Axis newAxis)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Axis_ID = 0;
        String location = className + "createAxis";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Axis Object: " + newAxis.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into " + getTableName(newAxis.getType()) + " (" +
                    "Axis_ID, "+
                    "Label_Name, "+
                    "Label_Type, "+
                    "Scale_Min, "+
                    "Scale_Max, "+
                    "Portfolio_ID, "+
                    "User_ID, "+
                    "Category_ID, "+
                    "Interval_Value "+
                    " ) " +
                    " values ('" +
                    newAxis.getAxisIdString()+"','"+
                    newAxis.getLabelName()+"','"+
                    newAxis.getLabelType()+"','"+
                    newAxis.getScaleMinString()+"','"+
                    newAxis.getScaleMaxString()+"','"+
                    newAxis.getPortfolioIdString()+"','"+
                    newAxis.getUserIdString()+"','"+
                    newAxis.getCategoryIdString()+"','"+
                    newAxis.getIntervalString()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Axis record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Axis_ID;
    }



    /**
     * Function that creates a record in the Axis table
     *
     * @param newAxis
     */
    public boolean modifyAxis(Axis newAxis)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyAxis";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Axis Object: " + newAxis.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update " + getTableName(newAxis.getType()) +  " set " +
                               " Label_Name = '"
                               + newAxis.getLabelName()
                               + "',"
                               + " Scale_Min = '"
                               + newAxis.getScaleMinString()
                               + "',"
                               + " Label_Type = '"
                               + newAxis.getLabelType()
                               + "',"
                               + " Scale_Max = '"
                               + newAxis.getScaleMaxString()
                               + "',"
                               + " Portfolio_ID = '"
                               + newAxis.getPortfolioIdString()
                               + "',"
                               + " User_ID = '"
                               + newAxis.getUserIdString()
                               + "',"
                               + " Interval_Value = '"
                               + newAxis.getIntervalString()
                               + "',"
                               + " Category_ID = '"
                               + newAxis.getCategoryIdString()
                               + "' where Axis_ID = "
							   + newAxis.getAxisIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Axis record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    /**
     *
     * @param Axis_ID
     */
    public Axis getAxis(String Axis_ID, String tableName) throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Axis axisEntry = null;

        String location = className + "getAxis";

        this.logger.debugMessage(location);

        String sql = "select * from " + tableName + " where Axis_ID=";
        sql += Axis_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                axisEntry = new Axis();
                axisEntry.setAxisId(rs.getInt("Axis_ID"));
                axisEntry.setLabelName(convertFromDBString(rs.getString("Label_Name")));
                axisEntry.setLabelType(convertFromDBString(rs.getString("Label_Type")));
                axisEntry.setScaleMin(rs.getLong("Scale_Min"));
                axisEntry.setScaleMax(rs.getLong("Scale_Max"));
                axisEntry.setPortfolioId(rs.getInt("Portfolio_ID"));
                axisEntry.setInterval(rs.getInt("Interval_Value"));
                axisEntry.setUserId(rs.getInt("User_ID"));
                axisEntry.setCategoryId(rs.getInt("Category_ID"));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return axisEntry;

    }



    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}