package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.Investment;

public class InvestmentDB extends DBAPI {


    private static final String className = "InvestmentDB.";

    /**
     *
     * @param context
     */
    public InvestmentDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "InvestmentDB";
        this.logger.debugMessage(location);
    }
    
    

    /**
     * Function that creates a record in the Investment table
     *
     * @param newInvestment
     */
    public int createInvestment(Investment newInvestment)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Investment_id = 0;
        String location = className + "createInvestment";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Investment Object: " + newInvestment.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }

            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Investment (" +
                    "Investment_ID, "+
                    "Company_Name, "+
                    "Ticker_Symbol, "+
                    "CUSIP, "+
                    "Market_Cap, "+
                    "Sector_ID, "+
                    "Asset_Class_ID, "+
                    "Type_ID, "+
                    "Created_Date, "+
                    " ) " +
                    " values ('" +
                    newInvestment.getInvestmentIdString()+"','"+
                    newInvestment.getCompanyName()+"','"+
                    newInvestment.getTickerSymbol()+"','"+
                    newInvestment.getCusip()+"','"+
                    newInvestment.getMarketCap()+"','"+
                    newInvestment.getSectorIdString()+"','"+
                    newInvestment.getAssetClassIdString()+"','"+
                    newInvestment.getTypeIdString()+"','"+
                    this.sdf.format(cal.getTime())
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Investment record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return Investment_id;
    }


    public boolean modifyInvestment(Investment newInvestment)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        //int Investment_id = 0;
        String location = className + "modifyInvestment";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Investment Object: " + newInvestment.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }



            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Investment set" +
                               " Sector_ID = '"
                               + newInvestment.getSectorIdString()
                               + "',"
                               + " Company_Name = '"
                               + newInvestment.getCompanyName()
                               + "',"
                               + " Ticker_Symbol = '"
                               + newInvestment.getTickerSymbol()
                               + "',"
                               + " CUSIP = '"
                               + newInvestment.getCusip()
                               + "',"
                               + " Asset_Class_ID = '"
                               + newInvestment.getAssetClassIdString()
                               + "',"
                               + " Type_ID = '"
                               + newInvestment.getTypeIdString()
                               + "',"
                               + " Market_Cap = '"
                               + newInvestment.getMarketCap()
                               + "',"
                               + " EPS = "
                               + newInvestment.getEPS()
                               + ","
                               + " Volume = "
                               + newInvestment.getVolume()
                               + ","
                               + " PE = "
                               + newInvestment.getPE()
                               + " where Investment_id = "
							   + newInvestment.getInvestmentIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully updated one Investment record");
            }


        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return true;
    }


    public Collection getInvestmentList(String order) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;
        Collection Investment = new ArrayList();

        String location = className + "getInvestmentList";

        this.logger.debugMessage(location);

        String sql = "select * from Investment ";
        sql += " order by ";
        sql += order;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


                

            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
            	investmentEntry = new Investment();
                investmentEntry.setInvestmentId(rs.getInt("Investment_ID"));
                investmentEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                investmentEntry.setTickerSymbol(convertFromDBString(rs.getString("Ticker_Symbol")));
                investmentEntry.setCusip(convertFromDBString(rs.getString("CUSIP")));
                investmentEntry.setMarketCap(convertFromDBString(rs.getString("Market_Cap")));
                investmentEntry.setSectorId(rs.getInt("Sector_ID"));
                investmentEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                investmentEntry.setTypeId(rs.getInt("Type_ID"));
                investmentEntry.setCreatedDate(convertFromDBString(rs.getString("Created_Date")));


                Investment.add(investmentEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Investment;



	}



    public Collection getInvestmentList(String company_name, String order) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;
        Collection Investment = new ArrayList();

        String location = className + "getInvestmentList";

        this.logger.debugMessage(location);

        String sql = "select * from Investment where 1=1 ";

        sql += buildSQLLikeFilter(company_name,"Company_Name");
        sql += " order by ";
        sql += order;
        sql += ";";
        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }



                investmentEntry = new Investment();

            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentEntry.setInvestmentId(rs.getInt("Investment_ID"));
                investmentEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                investmentEntry.setTickerSymbol(convertFromDBString(rs.getString("Ticker_Symbol")));
                investmentEntry.setCusip(convertFromDBString(rs.getString("CUSIP")));
                investmentEntry.setMarketCap(convertFromDBString(rs.getString("Market_Cap")));
                investmentEntry.setSectorId(rs.getInt("Sector_ID"));
                investmentEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                investmentEntry.setTypeId(rs.getInt("Type_ID"));
                investmentEntry.setCreatedDate(convertFromDBString(rs.getString("Created_Date")));


                Investment.add(investmentEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Investment;



	}

    /**
     *
     * @param Investment_id
     */
    public Investment getInvestment(String Investment_id)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;

        String location = className + "getInvestment";

        this.logger.debugMessage(location);

        String sql = "select * from Investment where Investment_id=";
        sql += Investment_id;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


                investmentEntry = new Investment();

            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentEntry.setInvestmentId(rs.getInt("Investment_ID"));
                investmentEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                investmentEntry.setTickerSymbol(convertFromDBString(rs.getString("Ticker_Symbol")));
                investmentEntry.setCusip(convertFromDBString(rs.getString("CUSIP")));
                investmentEntry.setMarketCap(convertFromDBString(rs.getString("Market_Cap")));
                investmentEntry.setSectorId(rs.getInt("Sector_ID"));
                investmentEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                investmentEntry.setTypeId(rs.getInt("Type_ID"));
                investmentEntry.setCreatedDate(convertFromDBString(rs.getString("Created_Date")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentEntry;

    }



    /**
     *
     * @param Investment_id
     */
    public Investment getInvestment(String column, String value)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;

        String location = className + "getInvestment";

        this.logger.debugMessage(location);

        String sql = "select * from Investment where 1=1 ";
        sql += buildSQLLikeFilter(value, column);
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }


            investmentEntry = new Investment();

            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentEntry.setInvestmentId(rs.getInt("Investment_ID"));
                investmentEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                investmentEntry.setTickerSymbol(convertFromDBString(rs.getString("Ticker_Symbol")));
                investmentEntry.setCusip(convertFromDBString(rs.getString("CUSIP")));
                investmentEntry.setMarketCap(convertFromDBString(rs.getString("Market_Cap")));
                investmentEntry.setSectorId(rs.getInt("Sector_ID"));
                investmentEntry.setAssetClassId(rs.getInt("Asset_Class_ID"));
                investmentEntry.setTypeId(rs.getInt("Type_ID"));
                investmentEntry.setCreatedDate(convertFromDBString(rs.getString("Created_Date")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentEntry;

    }


    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}