package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.TimeZone;

import javax.servlet.ServletContext;

import com.asc.server.objects.Investment;
import com.asc.server.objects.InvestmentHolding;
import com.asc.server.objects.InvestmentSummary;
import com.core.server.common.WebPageException;
import com.core.server.database.DBAPI;

public class InvestmentHoldingDB extends DBAPI {


    private static final String className = "InvestmentHoldingDB.";

    /**
     *
     * @param context
     */
    public InvestmentHoldingDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "InvestmentHoldingDB";
        this.logger.debugMessage(location);
    }



    public boolean investmentHoldingExists(InvestmentHolding newInvestmentHolding)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;

        String location = className + "investmentHoldingExists";
        this.logger.debugMessage(location);

        boolean investmentExists = false;

        try {
           if (useInternalConnectionPool) {
		       conn = this.pool.getConnection();
		   } else {
		       conn = this.ds.getConnection(dbUsername, dbPassword);
		   }
           stmt = conn.createStatement();
           String sql =
                    "SELECT COUNT(*) FROM Investment_Holding WHERE Portfolio_ID = '"
                    + newInvestmentHolding.getPortfolioIdString()
                    + "' and Investment_ID = '"
                    + newInvestmentHolding.getInvestmentIdString()
                    + "' and User_ID = '"
                    + newInvestmentHolding.getUserIdString()
                    + "';";
            logSQL(sql);
            this.logger.debugMessage(sql);

            rs = stmt.executeQuery(sql);
            if (rs.next()) {
                investmentExists =  rs.getInt("COUNT(*)") > 0 ? true : false;
            }


        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return investmentExists;
    }

    /**
     * Function that creates a record in the Investment_Holding table
     *
     * @param newInvestmentHolding
     */
    public int createInvestmentHolding(InvestmentHolding newInvestmentHolding)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Investment_id = 0;
        String location = className + "createInvestmentHolding";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Investment_Holding Object: " + newInvestmentHolding.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Investment_Holding (" +
                    "Investment_ID, "+
                    "Portfolio_ID, "+
                    "User_ID, "+
                    "Quantity, "+
                    "Date_Added, "+
                    "Value "+
                    " ) " +
                    " values ('" +
                    newInvestmentHolding.getInvestmentIdString()+"','"+
                    newInvestmentHolding.getPortfolioIdString()+"','"+
                    newInvestmentHolding.getUserIdString()+"','"+
                    newInvestmentHolding.getQuantityString()+"','"+
                    this.sdf.format(cal.getTime())+"','"+
                    newInvestmentHolding.getValueString()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Investment_Holding record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return Investment_id;
    }

    public int deleteInvestment(int investment_id,
                                    int portfolio_id,
                                    int user_id) throws  Exception, WebPageException
    {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;
        Collection investmentList = new ArrayList();
        int recordsUpdated = 0;

        String location = className + "deleteInvestment";

        this.logger.debugMessage(location);

        String sql = "delete from Investment_Holding where ";
        sql += "Investment_ID = ";
        sql += Integer.toString(investment_id);
        sql += " and Portfolio_ID = ";
        sql += Integer.toString(portfolio_id);
        sql += " and User_ID = ";
        sql += Integer.toString(user_id);
        sql += ";";


        this.logger.debugMessage("Sql " + sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }

            stmt = conn.createStatement();
    //        rs = stmt.executeQuery(sql);


            recordsUpdated = stmt.executeUpdate(sql);

            logSQL(sql);


        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return recordsUpdated;




	}

    public int getMaximumInvestmentId(int portfolioID)throws SQLException, WebPageException{



        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        int investmentId = 0;

        String location = className + "getMaximumInvestmentId";
        this.logger.debugMessage(location);
        try {

            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }

      stmt = conn.createStatement();
            String sql2 = "SELECT MAX(Investment_ID) as bId1 FROM Investment_Holding where Portfolio_ID = ";
            sql2 += Integer.toString(portfolioID);

            this.logger.debugMessage(sql2);

            logSQL(sql2);
            rs = stmt.executeQuery(sql2);

            if (rs.next()) {
                investmentId =  rs.getInt("bId1");
            }

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return investmentId;
    }

    public boolean updateNumberOfHoldings(String numberOfHoldings, int investmentID)throws SQLException, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;

        String location = className + "updateNumberOfHoldings";
        this.logger.debugMessage(location);
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Investment_Holding set"
                               + " Quantity = "
                               + numberOfHoldings
                               + " where Investment_ID = "
							   + Integer.toString(investmentID)
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully update one Investment Holding record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;

 }


    public Collection getInvestmentList(int portfolio_id, String order) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Investment investmentEntry = null;
        Collection investmentList = new ArrayList();

        String location = className + "getInvestmentList";

        this.logger.debugMessage(location);

        String sql = "select * from Investment_Holding IH, Investment I ";
        sql += "where IH.Investment_ID = I.Investment_ID and IH.Portfolio_ID= ";
        sql += Integer.toString(portfolio_id);
        if(order.equals("Investment_ID"))
        {
              sql += " order by ";
              sql += "I.Investment_ID";
	    }
        else if(order.equals("Company_Name"))
        {
              sql += " order by ";
              sql += "I.Company_Name";
	    }
        else if(order.equals("Ticker_Symbol"))
        {
              sql += " order by ";
              sql += "I.Ticker_Symbol";
	    }

        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentEntry = new Investment();
                investmentEntry.setInvestmentId(rs.getInt("I.Investment_ID"));
                investmentEntry.setCompanyName(convertFromDBString(rs.getString("I.Company_Name")));
                investmentEntry.setTickerSymbol(convertFromDBString(rs.getString("I.Ticker_Symbol")));
                investmentEntry.setCusip(convertFromDBString(rs.getString("I.CUSIP")));
                investmentEntry.setMarketCap(convertFromDBString(rs.getString("I.Market_Cap")));
                investmentEntry.setEPS(rs.getLong("I.Volume"));
                investmentEntry.setPE(rs.getFloat("I.PE"));
                investmentEntry.setEPS(rs.getFloat("I.EPS"));
                investmentEntry.setSectorId(rs.getInt("I.Sector_ID"));
                investmentEntry.setAssetClassId(rs.getInt("I.Asset_Class_ID"));
                investmentEntry.setTypeId(rs.getInt("I.Type_ID"));
                investmentEntry.setCreatedDate(convertFromDBString(rs.getString("IH.Date_Added")));
                investmentEntry.setPositionsHeld(rs.getInt("IH.Quantity"));
                investmentList.add(investmentEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentList;

	}


public Collection getInvestmentSummaryListBySector(int portfolio_id) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        InvestmentSummary investmentSummaryEntry = null;
        Collection investmentSummaryList = new ArrayList();

        String location = className + "getInvestmentSummaryListBySector";

        this.logger.debugMessage(location);

        String sql = "SELECT a.Portfolio_ID, b.Asset_Class_ID, ";
        sql += "if(c.parent_Sector = 0, c.Sector_ID, c.parent_Sector) Parent_Sector, ";
        sql += "sum(b.Market_Cap) Market_Cap, ";
        sql += "sum(b.Volume) Volume, ";
        sql += "sum(b.EPS) EPS, ";
        sql += "sum(b.PE) PE, ";
        sql += "if(c.parent_Sector = 0, b.Ticker_Symbol, ' ') Ticker_Symbol, ";
        sql += "if(c.parent_Sector = 0, b.Company_Name, ' ') Company_Name ";
        sql += "FROM Investment_Holding a, Investment b, Sector c ";
        sql += "where a.Investment_ID = b.Investment_ID ";
        sql += "and a.Portfolio_ID = " + Integer.toString(portfolio_id) + " ";         
        sql += "and b.Sector_ID = c.Sector_ID ";
        sql += "group by b.Asset_Class_ID, parent_Sector";
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
            	investmentSummaryEntry = new InvestmentSummary();
            	investmentSummaryEntry.setPortfolio_id(rs.getInt("a.Portfolio_ID"));
            	investmentSummaryEntry.setAssetClass_id(rs.getInt("b.Asset_Class_ID"));
            	investmentSummaryEntry.setParentSector_id(rs.getInt("Parent_Sector"));
            	investmentSummaryEntry.setMarketCap(rs.getLong("Market_Cap"));
            	investmentSummaryEntry.setVolume(rs.getLong("Volume"));
            	investmentSummaryEntry.setEPS(rs.getFloat("EPS"));
            	investmentSummaryEntry.setPE(rs.getFloat("PE"));
            	investmentSummaryEntry.setTickerSymbol(convertFromDBString(rs.getString("Ticker_Symbol")));
            	investmentSummaryEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
            	
            	investmentSummaryList.add(investmentSummaryEntry);

            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentSummaryList;



	}

    
    
    
    
    public Collection getInvestmentSummaryListForAssetClassAndParentSector(int portfolio_id, int assetClass_id, 
    		int parentSectorId) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        InvestmentSummary investmentSummaryEntry = null;
        Collection investmentSummaryList = new ArrayList();

        String location = className + "getInvestmentSummaryListForAssetClassAndParentSector";

        this.logger.debugMessage(location);

        String sql = "SELECT a.Portfolio_ID, b.Asset_Class_ID, ";        
        sql += "c.Sector_ID, ";
        sql += "b.Market_Cap, ";
        sql += "b.Volume, ";
        sql += "b.EPS, ";
        sql += "b.PE, ";        
        sql += "b.Ticker_Symbol, ";
        sql += "b.Company_Name ";
        sql += "FROM Investment_Holding a, Investment b, Sector c ";
        sql += "where a.Investment_ID = b.Investment_ID ";
        sql += "and b.Sector_ID = c.Sector_ID ";
        sql += "and a.Portfolio_ID = " + Integer.toString(portfolio_id) + " ";         
        sql += "and b.Asset_Class_ID = " + assetClass_id + " ";
        sql += "and c.parent_Sector = " + parentSectorId;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
            	investmentSummaryEntry = new InvestmentSummary();
            	investmentSummaryEntry.setPortfolio_id(rs.getInt("a.Portfolio_ID"));
            	investmentSummaryEntry.setAssetClass_id(rs.getInt("b.Asset_Class_ID"));
            	investmentSummaryEntry.setParentSector_id(rs.getInt("c.Sector_ID"));
            	investmentSummaryEntry.setMarketCap(rs.getLong("b.Market_Cap"));
            	investmentSummaryEntry.setVolume(rs.getLong("b.Volume"));
            	investmentSummaryEntry.setEPS(rs.getFloat("b.EPS"));
            	investmentSummaryEntry.setPE(rs.getFloat("b.PE"));
            	investmentSummaryEntry.setTickerSymbol(convertFromDBString(rs.getString("b.Ticker_Symbol")));
            	investmentSummaryEntry.setCompanyName(convertFromDBString(rs.getString("b.Company_Name")));
            	
            	investmentSummaryList.add(investmentSummaryEntry);

            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentSummaryList;



	}
        

    
    public Collection getSubSectorsForInvestment(int portfolio_id, int assetClass_id, int parentSector_id) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        
        Collection subSectorsList = new ArrayList();

        String location = className + "getSubSectorsForInvestment";

        this.logger.debugMessage(location);

        String sql = "SELECT distinct c.Sector_Name ";
        sql += "FROM Investment_Holding a, Investment b, Sector c ";
        sql += "where a.Investment_ID = b.Investment_ID ";                 
        sql += "and b.Sector_ID = c.Sector_ID ";
        sql += "and a.Portfolio_ID = " + Integer.toString(portfolio_id) + " ";
        sql += "and b.Asset_Class_ID = " + Integer.toString(assetClass_id) + " ";
        sql += "and Parent_Sector = " + Integer.toString(parentSector_id) + " ";        
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
            	
            	subSectorsList.add(convertFromDBString(rs.getString("c.Sector_Name")));

            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return subSectorsList;



	}



    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}