package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class InvestmentTypeLookupDB extends DBAPI {


    private static final String className = "InvestmentTypeLookupDB.";

    /**
     *
     * @param context
     */
    public InvestmentTypeLookupDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "InvestmentTypeLookupDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the InvestmentTypeLookup table
     *
     * @param newInvestmentTypeLookup
     */
    public int createInvestmentTypeLookup(InvestmentTypeLookup newInvestmentTypeLookup)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Type_ID = 0;
        String location = className + "createInvestmentTypeLookup";
        this.logger.debugMessage(location);
        this.logger.debugMessage("InvestmentTypeLookup Object: " + newInvestmentTypeLookup.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Investment_Type_Lookup (" +
                    "Type_ID, "+
                    "Type_Name "+
                    " ) " +
                    " values ('" +
                    newInvestmentTypeLookup.getTypeIdString()+"','"+
                    newInvestmentTypeLookup.getTypeName()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one InvestmentTypeLookup record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Type_ID;
    }



    /**
     * Function that creates a record in the InvestmentTypeLookup table
     *
     * @param newInvestmentTypeLookup
     */
    public boolean modifyInvestmentTypeLookup(InvestmentTypeLookup newInvestmentTypeLookup)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyInvestmentTypeLookup";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Audit Event Object: " + newInvestmentTypeLookup.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Investment_Type_Lookup set"
                               + " Type_Name = '"
                               + newInvestmentTypeLookup.getTypeName()
                               + "' where Type_ID = "
							   + newInvestmentTypeLookup.getTypeIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Audit Event record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getInvestmentTypeLookupList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        InvestmentTypeLookup investmentTypeLookupEntry = null;
        Collection investmentTypeLookupList = new ArrayList();

        String location = className + "getInvestmentTypeLookupList";

        this.logger.debugMessage(location);

        String sql = "select * from Investment_Type_Lookup;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentTypeLookupEntry = new InvestmentTypeLookup();
                investmentTypeLookupEntry.setTypeId(rs.getInt("Type_ID"));
                investmentTypeLookupEntry.setTypeName(convertFromDBString(rs.getString("Type_Name")));

                investmentTypeLookupList.add(investmentTypeLookupEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentTypeLookupList;



	}


    /**
     *
     * @param Type_ID
     */
    public InvestmentTypeLookup getInvestmentTypeLookup(String Type_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        InvestmentTypeLookup investmentTypeLookupEntry = null;

        String location = className + "getInvestmentTypeLookup";

        this.logger.debugMessage(location);

        String sql = "select * from Investment_Type_Lookup where Type_ID=";
        sql += Type_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                investmentTypeLookupEntry = new InvestmentTypeLookup();
                investmentTypeLookupEntry.setTypeId(rs.getInt("Type_ID"));
                investmentTypeLookupEntry.setTypeName(convertFromDBString(rs.getString("Type_Name")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return investmentTypeLookupEntry;

    }

    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}