package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class LocalSearchDB extends DBAPI {


    private static final String className = "LocalSearchDB.";

    /**
     *
     * @param context
     */
    public LocalSearchDB(ServletContext context)throws WebPageException{
        super(context);
        String location = className + "LocalSearchDB";
        this.logger.debugMessage(location);
    }

    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }

    public Collection getCities(String state)throws SQLException, WebPageException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String city = null;

        String location = className + "getCities";
        Collection cityEntries = new ArrayList();

        this.logger.debugMessage(location);

        String sql = "select distinct city from locale_search where state = '";
        sql += state;
        sql += "' order by city;";

        this.logger.debugMessage("Sql " + sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                city = new String(convertFromDBString(rs.getString("city")));

                cityEntries.add(city);

            }

        } catch (SQLException e) {
            logger.exceptionMessage(e);
            throw e;
        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (useInternalConnectionPool) {
                    this.pool.freeConnection(conn);
                } else {
                    if (conn != null) {
                        conn.close();
                        conn = null;
                    }
                }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return cityEntries;


    }

    public Collection getStates()throws SQLException, WebPageException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String state = null;

        String location = className + "getCities";
        Collection stateEntries = new ArrayList();

        this.logger.debugMessage(location);

        String sql = "select distinct state from locale_search order by state;";

        this.logger.debugMessage("Sql " + sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                state = new String(convertFromDBString(rs.getString("state")));

                stateEntries.add(state);

            }

        } catch (SQLException e) {
            logger.exceptionMessage(e);
            throw e;
        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (useInternalConnectionPool) {
                    this.pool.freeConnection(conn);
                } else {
                    if (conn != null) {
                        conn.close();
                        conn = null;
                    }
                }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return stateEntries;


    }

        public String getCityState(String zipCode)throws SQLException, WebPageException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String city = null;
        String state = null;
        String cityStateCombination = null;

        String location = className + "getCityState";
        Collection cityStateEntries = new ArrayList();

        this.logger.debugMessage(location);

        String sql = "select city, state from locale_search where zip_code = '";
        sql += zipCode;
        sql += "' order by city, state;";

        this.logger.debugMessage("Sql " + sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                city = new String(convertFromDBString(rs.getString("city")));
                state = new String(convertFromDBString(rs.getString("state")));
                cityStateCombination = new String(city+":"+state);
            }

        } catch (SQLException e) {
            logger.exceptionMessage(e);
            throw e;
        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (useInternalConnectionPool) {
                    this.pool.freeConnection(conn);
                } else {
                    if (conn != null) {
                        conn.close();
                        conn = null;
                    }
                }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return cityStateCombination;


    }


}