package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.PortfolioAxesDefinition;
import com.asc.server.objects.Axis;

public class PortfolioAxesDefinitionDB extends DBAPI {


    private static final String className = "PortfolioAxesDefinitionDB.";

    /**
     *
     * @param context
     */
    public PortfolioAxesDefinitionDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "PortfolioAxesDefinitionDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the PortfolioAxesDefinition table
     *
     * @param newPortfolioAxesDefinition
     */
    public int createPortfolioAxesDefinition(PortfolioAxesDefinition newPortfolioAxesDefinition)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Portfolio_id = 0;
        String location = className + "createPortfolioAxesDefinition";
        this.logger.debugMessage(location);
        this.logger.debugMessage("PortfolioAxesDefinition Object: " + newPortfolioAxesDefinition.toString());
        try {


                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Portfolio_Axes_Definition (" +
                    "Portfolio_ID, "+
                    "User_ID, "+
                    "XAxis_ID, "+
                    "YAxis_ID, "+
                    "ZAxis_ID "+
                    " ) " +
                    " values ('" +
                    newPortfolioAxesDefinition.getPortfolioIdString()+"','"+
                    newPortfolioAxesDefinition.getUserIdString()+"','"+
                    newPortfolioAxesDefinition.getXAxisIdString()+"','"+
                    newPortfolioAxesDefinition.getYAxisIdString()+"','"+
                    newPortfolioAxesDefinition.getZAxisIdString()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one PortfolioAxesDefinition record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return Portfolio_id;
    }


    public boolean modifyPortfolioAxesDefinition(PortfolioAxesDefinition newPortfolioAxesDefinition)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Portfolio_id = 0;
        String location = className + "modifyPortfolioAxesDefinition";
        this.logger.debugMessage(location);
        this.logger.debugMessage("PortfolioAxesDefinition Object: " + newPortfolioAxesDefinition.toString());
        try {


            if (useInternalConnectionPool) {
			      conn = this.pool.getConnection();
			} else {
			      conn = this.ds.getConnection(dbUsername, dbPassword);
			}

            Calendar cal = Calendar.getInstance(TimeZone.getDefault());


             String sql2 ="update Portfolio_Axes_Definition set" +
                          " User_ID = '"
                          + newPortfolioAxesDefinition.getUserIdString()
                          + "',"
                          + " XAxis_ID = '"
                          + newPortfolioAxesDefinition.getXAxisIdString()
                          + "',"
                          + " YAxis_ID = '"
                          + newPortfolioAxesDefinition.getYAxisIdString()
                          + "',"
                          + " ZAxis_ID = '"
                          + newPortfolioAxesDefinition.getZAxisIdString()
                          + "' where Portfolio_id = "
     				      + newPortfolioAxesDefinition.getPortfolioIdString()
						  + ";";

            this.logger.debugMessage("sql2: " + sql2);
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully updated one PortfolioAxesDefinition record");
            }


        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return true;
    }



    /**
     *
     * @param Portfolio_id
     */
    public PortfolioAxesDefinition getPortfolioAxesDefinition(String Portfolio_id)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        PortfolioAxesDefinition portfolioEntry = null;
        Axis xAxis = null;
        Axis yAxis = null;
        Axis zAxis = null;
        String location = className + "getPortfolioAxesDefinition";

        this.logger.debugMessage(location);

        String sql = "select pad.*, xA.*, yA.*, zA.* ";
        sql += " from Portfolio_Axes_Definition pad, X_Axis xA, Y_Axis yA, Z_Axis zA ";
        sql += " where pad.Portfolio_ID=";
        sql += Portfolio_id;
        sql += " and xA.Axis_ID = pad.XAxis_ID ";
        sql += " and yA.Axis_ID = pad.YAxis_ID ";
        sql += " and zA.Axis_ID = pad.ZAxis_ID ";
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }



            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new PortfolioAxesDefinition();
                portfolioEntry.setPortfolioId(rs.getInt("Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("User_ID"));
                portfolioEntry.setXAxisId(rs.getInt("XAxis_ID"));
                portfolioEntry.setYAxisId(rs.getInt("YAxis_ID"));
                portfolioEntry.setZAxisId(rs.getInt("ZAxis_ID"));

                xAxis = new Axis();
                yAxis = new Axis();
                zAxis = new Axis();

                xAxis.setAxisId(rs.getInt("xA.Axis_ID"));
                xAxis.setLabelName(convertFromDBString(rs.getString("xA.Label_Name")));
                xAxis.setLabelType(convertFromDBString(rs.getString("xA.Label_Type")));
                xAxis.setScaleMin(rs.getLong("xA.Scale_Min"));
                xAxis.setScaleMax(rs.getLong("xA.Scale_Max"));
                xAxis.setPortfolioId(rs.getInt("xA.Portfolio_ID"));
                xAxis.setInterval(rs.getLong("xA.Interval_Value"));
                xAxis.setUserId(rs.getInt("xA.User_ID"));
                xAxis.setCategoryId(rs.getInt("xA.Category_ID"));

                yAxis.setAxisId(rs.getInt("yA.Axis_ID"));
                yAxis.setLabelName(convertFromDBString(rs.getString("yA.Label_Name")));
                yAxis.setLabelType(convertFromDBString(rs.getString("yA.Label_Type")));
                yAxis.setScaleMin(rs.getLong("yA.Scale_Min"));
                yAxis.setScaleMax(rs.getLong("yA.Scale_Max"));
                yAxis.setPortfolioId(rs.getInt("yA.Portfolio_ID"));
                yAxis.setInterval(rs.getLong("yA.Interval_Value"));
                yAxis.setUserId(rs.getInt("yA.User_ID"));
                yAxis.setCategoryId(rs.getInt("yA.Category_ID"));

                zAxis.setAxisId(rs.getInt("zA.Axis_ID"));
                zAxis.setLabelName(convertFromDBString(rs.getString("zA.Label_Name")));
                zAxis.setLabelType(convertFromDBString(rs.getString("zA.Label_Type")));
                zAxis.setScaleMin(rs.getLong("zA.Scale_Min"));
                zAxis.setScaleMax(rs.getLong("zA.Scale_Max"));
                zAxis.setPortfolioId(rs.getInt("zA.Portfolio_ID"));
                zAxis.setInterval(rs.getLong("zA.Interval_Value"));
                zAxis.setUserId(rs.getInt("zA.User_ID"));
                zAxis.setCategoryId(rs.getInt("zA.Category_ID"));


                portfolioEntry.setXAxis(xAxis);
                portfolioEntry.setYAxis(yAxis);
                portfolioEntry.setZAxis(zAxis);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return portfolioEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}