package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.Portfolio;

public class PortfolioDB extends DBAPI {


    private static final String className = "PortfolioDB.";

    /**
     *
     * @param context
     */
    public PortfolioDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "PortfolioDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Portfolio table
     *
     * @param newPortfolio
     */
    public int createPortfolio(Portfolio newPortfolio)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Portfolio_id = 0;
        String location = className + "createPortfolio";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Portfolio Object: " + newPortfolio.toString());
        try {


                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Portfolio (" +
                    "Portfolio_ID, "+
                    "Name, " +
                    "User_ID, "+
                    "Investment_ID, "+
                    "Created_By, "+
                    "Parent_Account, "+
//                    "Expiration_Date, "+
                    "Created_Date "+
                    " ) " +
                    " values ('" +
                    newPortfolio.getPortfolioIdString()+"','"+
                    newPortfolio.getName()+"','"+
                    newPortfolio.getUserIdString()+"','"+
                    newPortfolio.getInvestmentIdString()+"','"+
                    newPortfolio.getCreatedBy()+"','"+
                    newPortfolio.getParentIdString()+"','"+
//                    newPortfolio.getExpirationDateDBString()+"','"+
                    this.sdf.format(cal.getTime())
                    + "');";
            logSQL(sql2);

  stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Portfolio record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return Portfolio_id;
    }


    public boolean modifyPortfolio(Portfolio newPortfolio)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Portfolio_id = 0;
        String location = className + "modifyPortfolio";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Portfolio Object: " + newPortfolio.toString());
        try {


            if (useInternalConnectionPool) {
			      conn = this.pool.getConnection();
			} else {
			      conn = this.ds.getConnection(dbUsername, dbPassword);
			}

            Calendar cal = Calendar.getInstance(TimeZone.getDefault());


             String sql2 ="update Portfolio set" +
                          " Name = '"
                          + newPortfolio.getName()
                           + "' where Portfolio_id = "
     				      + newPortfolio.getPortfolioIdString()
						  + ";";

            this.logger.debugMessage("sql2: " + sql2);
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully updated one Portfolio record");
            }


        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return true;
    }


    public Collection getPortfolioListByRoleType(String order, String roleType) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;
        Collection Portfolio = new ArrayList();

        String location = className + "getPortfolio";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio P, Users U";
        sql += " where U.User_ID = P.User_Id and  ";
        sql += " U.Role_ID in (select Role_ID from Roles where Role_Type_ID = ";
        sql += roleType;
        sql += ") ";


        if(order.equals("Name"))
        {
              sql += " order by ";
              sql += "P.Name";
	    }
        else if(order.equals("User_ID"))
        {
              sql += " order by ";
              sql += "P.User_ID";
	    }
        else if(order.equals("Portfolio_ID"))
        {
              sql += " order by ";
              sql += "P.Portfolio_ID";
	    }


        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("P.Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("P.User_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("P.Name")));
                portfolioEntry.setUserName(convertFromDBString(rs.getString("U.Username")));
                portfolioEntry.setInvestmentId(rs.getInt("P.Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("P.Created_By"));
                portfolioEntry.setParentId(rs.getInt("P.Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("P.Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("P.Expiration_Date")));


                Portfolio.add(portfolioEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Portfolio;



	}



    public Collection getPortfolioListByParentID(String parentId, String order, String roleType) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;
        Collection Portfolio = new ArrayList();

        String location = className + "getPortfolioListByParentID";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio P, Users U";
        sql += " where U.User_ID = P.User_Id and  ";
        sql += " U.Parent_User_ID = ";
        sql += parentId;


        if(order.equals("Name"))
        {
              sql += " order by ";
              sql += "P.Name";
	    }
        else if(order.equals("User_ID"))
        {
              sql += " order by ";
              sql += "P.User_ID";
	    }
        else if(order.equals("Portfolio_ID"))
        {
              sql += " order by ";
              sql += "P.Portfolio_ID";
	    }


        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("P.Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("P.User_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("P.Name")));
                portfolioEntry.setUserName(convertFromDBString(rs.getString("U.Username")));
                portfolioEntry.setInvestmentId(rs.getInt("P.Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("P.Created_By"));
                portfolioEntry.setParentId(rs.getInt("P.Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("P.Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("P.Expiration_Date")));


                Portfolio.add(portfolioEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Portfolio;



	}



    public Collection getPortfolioListByCompany(String companyId, String order, String roleType) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;
        Collection Portfolio = new ArrayList();

        String location = className + "getPortfolioListByCompany";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio P, Users U";
        sql += " where U.User_ID = P.User_Id and ";
        sql += "U.Parent_User_ID in (select User_ID from Users where Parent_User_ID = ";
        sql += companyId;
        sql += ") ";

        if(order.equals("Name"))
        {
              sql += " order by ";
              sql += "P.Name";
	    }
        else if(order.equals("User_ID"))
        {
              sql += " order by ";
              sql += "P.User_ID";
	    }
        else if(order.equals("Portfolio_ID"))
        {
              sql += " order by ";
              sql += "P.Portfolio_ID";
	    }


        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("P.Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("P.User_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("P.Name")));
                portfolioEntry.setUserName(convertFromDBString(rs.getString("U.Username")));
                portfolioEntry.setInvestmentId(rs.getInt("P.Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("P.Created_By"));
                portfolioEntry.setParentId(rs.getInt("P.Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("P.Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("P.Expiration_Date")));


                Portfolio.add(portfolioEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Portfolio;



	}




    public Collection getPortfolioList(String order, String user_id) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;
        Collection Portfolio = new ArrayList();

        String location = className + "getPortfolioList";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio P, Users U";
        sql += " where U.User_ID = P.User_Id and P.User_Id = ";
        sql += user_id;
        if(order.equals("Name"))
        {
              sql += " order by ";
              sql += "P.Name";
	    }
        else if(order.equals("User_ID"))
        {
              sql += " order by ";
              sql += "P.User_ID";
	    }
        else if(order.equals("Portfolio_ID"))
        {
              sql += " order by ";
              sql += "P.Portfolio_ID";
	    }


        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("P.Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("P.User_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("P.Name")));
                portfolioEntry.setUserName(convertFromDBString(rs.getString("U.Username")));
                portfolioEntry.setInvestmentId(rs.getInt("P.Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("P.Created_By"));
                portfolioEntry.setParentId(rs.getInt("P.Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("P.Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("P.Expiration_Date")));


                Portfolio.add(portfolioEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Portfolio;



	}



   public Collection getPortfolioListByAdmin(String order) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;
        Collection Portfolio = new ArrayList();

        String location = className + "getPortfolioList";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio P, Users U";
        sql += " where U.User_ID = P.User_Id ";
        if(order.equals("Name"))
        {
              sql += " order by ";
              sql += "P.Name";
	    }
        else if(order.equals("User_ID"))
        {
              sql += " order by ";
              sql += "P.User_ID";
	    }
        else if(order.equals("Portfolio_ID"))
        {
              sql += " order by ";
              sql += "P.Portfolio_ID";
	    }


        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("P.Portfolio_ID"));
                portfolioEntry.setUserId(rs.getInt("P.User_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("P.Name")));
                portfolioEntry.setUserName(convertFromDBString(rs.getString("U.Username")));
                portfolioEntry.setInvestmentId(rs.getInt("P.Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("P.Created_By"));
                portfolioEntry.setParentId(rs.getInt("P.Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("P.Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("P.Expiration_Date")));


                Portfolio.add(portfolioEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Portfolio;



	}


    /**
     *
     * @param Portfolio_id
     */
    public Portfolio getPortfolio(String Portfolio_id)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Portfolio portfolioEntry = null;

        String location = className + "getPortfolio";

        this.logger.debugMessage(location);

        String sql = "select * from Portfolio where Portfolio_id=";
        sql += Portfolio_id;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }



            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                portfolioEntry = new Portfolio();
                portfolioEntry.setPortfolioId(rs.getInt("Portfolio_ID"));
                portfolioEntry.setName(convertFromDBString(rs.getString("Name")));
                portfolioEntry.setUserId(rs.getInt("User_ID"));
                portfolioEntry.setInvestmentId(rs.getInt("Investment_ID"));
                portfolioEntry.setCreatedBy(rs.getInt("Created_By"));
                portfolioEntry.setParentId(rs.getInt("Parent_Account"));
                portfolioEntry.setCreatedDate(convertFromDBString(rs.getString("Created_Date")));
//                portfolioEntry.setExpirationDate(convertFromDBString(rs.getString("Expiration_Date")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return portfolioEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}