package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.Role;

public class RoleDB extends DBAPI {


    private static final String className = "RoleDB.";

    /**
     *
     * @param context
     */
    public RoleDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "RoleDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Role table
     *
     * @param newRole
     */
    public int createRole(Role newRole)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Role_ID = 0;
        String location = className + "createRole";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Object: " + newRole.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Roles (" +
                    "Role_ID, "+
                    "Role_Type_ID, "+
                    "Role_Name, "+
                    "Access_Level, "+
                    "Role_Description "+
                    " ) " +
                    " values ('" +
                    newRole.getRoleIdString()+"','"+
                    newRole.getRoleTypeIdString()+"','"+
                    newRole.getName()+"','"+
                    newRole.getAccessLevel()+"','"+
                    newRole.getDescription()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Role record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Role_ID;
    }



    /**
     * Function that creates a record in the Role table
     *
     * @param newRole
     */
    public boolean modifyRole(Role newRole)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyRole";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Object: " + newRole.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Roles set" +
                               " Role_Name = '"
                               + newRole.getName()
                               + "',"
                               + " Role_Type_ID = '"
                               + newRole.getRoleTypeId()
                               + "',"
                               + " Access_Level = '"
                               + newRole.getAccessLevel()
                               + "',"
                               + " Role_Description = '"
                               + newRole.getDescription()
                               + "' where Role_ID = "
							   + newRole.getRoleIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Role record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getRoleList(String order) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Role roleEntry = null;
        Collection roles = new ArrayList();

        String location = className + "getRoleList";

        this.logger.debugMessage(location);

        String sql = "select * from Roles";
        sql += " order by ";
        sql += order;
        sql += ";";
        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleEntry = new Role();
                roleEntry.setRoleId(rs.getInt("Role_ID"));
                roleEntry.setName(convertFromDBString(rs.getString("Role_Name")));
                roleEntry.setRoleTypeId(rs.getInt("Role_Type_ID"));
                roleEntry.setAccessLevel(convertFromDBString(rs.getString("Access_Level")));
                roleEntry.setDescription(convertFromDBString(rs.getString("Role_Description")));

                roles.add(roleEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roles;



	}


    /**
     *
     * @param Role_ID
     */
    public Role getRole(String Role_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Role roleEntry = null;

        String location = className + "getRole";

        this.logger.debugMessage(location);

        String sql = "select * from Roles where Role_ID=";
        sql += Role_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleEntry = new Role();
                roleEntry.setRoleId(rs.getInt("Role_ID"));
                roleEntry.setName(convertFromDBString(rs.getString("Role_Name")));
                roleEntry.setAccessLevel(convertFromDBString(rs.getString("Access_Level")));
                roleEntry.setRoleTypeId(rs.getInt("Role_Type_ID"));
                roleEntry.setDescription(convertFromDBString(rs.getString("Role_Description")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roleEntry;

    }


    public boolean roleNameExists(Role newRole) throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String location = className + "roleExists";
        this.logger.debugMessage(location);
        boolean isValidRole = false;

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            String sql =
                    "SELECT COUNT(*) FROM Roles WHERE Role_Name = '"
                    + newRole.getName()
                    + "'";
            logSQL(sql);
            rs = stmt.executeQuery(sql);
            if (rs.next()) {
                isValidRole =  rs.getInt("COUNT(*)") > 0 ? true : false;
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw e;
        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (useInternalConnectionPool) {
                    this.pool.freeConnection(conn);
                } else {
                    if (conn != null) {
                        conn.close();
                        conn = null;
                    }
                }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }
        return isValidRole;
    } // end of roleExists method


    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}