package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class RoleTypeDB extends DBAPI {


    private static final String className = "RoleTypeDB.";

    /**
     *
     * @param context
     */
    public RoleTypeDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "RoleTypeDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Role table
     *
     * @param newRoleType
     */
    public int createRoleType(RoleType newRoleType)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Role_Type_ID = 0;
        String location = className + "createRoleType";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Object: " + newRoleType.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Role_Type (" +
                    "Role_Type_ID, "+
                    "Parent_Role_Type_ID, "+
                    "Role_Type_Name, "+
                    "Role_Type_Description "+
                    " ) " +
                    " values ('" +
                    newRoleType.getRoleTypeIdString()+"','"+
                    newRoleType.getParentRoleTypeIdString()+"','"+
                    newRoleType.getRoleTypeName()+"','"+
                    newRoleType.getRoleTypeDescription()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Role record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Role_Type_ID;
    }



    /**
     * Function that creates a record in the Role table
     *
     * @param newRoleType
     */
    public boolean modifyRoleType(RoleType newRoleType)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyRoleType";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Type Object: " + newRoleType.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Role_Type set"
                               + " Role_Type_Name = '"
                               + newRoleType.getRoleTypeName()
                               + "',"
                               + " Role_Type_ID = '"
                               + newRoleType.getRoleTypeId()
                               + "',"
                               + " Parent_Role_Type_ID = '"
                               + newRoleType.getParentRoleTypeId()
                               + "',"
                               + " Role_Type_Description = '"
                               + newRoleType.getRoleTypeDescription()
                               + "' where Role_Type_ID = "
							   + newRoleType.getRoleTypeIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Role record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getRoleTypeList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        RoleType roleTypeEntry = null;
        Collection roles = new ArrayList();

        String location = className + "getRoleTypeList";

        this.logger.debugMessage(location);

        String sql = "select * from Role_Type;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleTypeEntry = new RoleType();
                roleTypeEntry.setRoleTypeId(rs.getInt("Role_Type_ID"));
                roleTypeEntry.setParentRoleTypeId(rs.getInt("Parent_Role_Type_ID"));
                roleTypeEntry.setRoleTypeName(convertFromDBString(rs.getString("Role_Type_Name")));
                roleTypeEntry.setRoleTypeDescription(convertFromDBString(rs.getString("Role_Type_Description")));

                roles.add(roleTypeEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roles;



	}


    /**
     *
     * @param Role_Type_ID
     */
    public RoleType getRoleType(String Role_Type_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        RoleType roleTypeEntry = null;

        String location = className + "getRoleType";

        this.logger.debugMessage(location);

        String sql = "select * from Role_Type where Role_Type_ID=";
        sql += Role_Type_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleTypeEntry = new RoleType();
                roleTypeEntry.setRoleTypeId(rs.getInt("Role_Type_ID"));
                roleTypeEntry.setParentRoleTypeId(rs.getInt("Parent_Role_Type_ID"));
                roleTypeEntry.setRoleTypeName(convertFromDBString(rs.getString("Role_Type_Name")));
                roleTypeEntry.setRoleTypeDescription(convertFromDBString(rs.getString("Role_Type_Description")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roleTypeEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}