package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class SectorDB extends DBAPI {


    private static final String className = "SectorDB.";

    /**
     *
     * @param context
     */
    public SectorDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "SectorDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Sector table
     *
     * @param newSector
     */
    public int createSector(Sector newSector)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Sector_ID = 0;
        String location = className + "createSector";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Sector Object: " + newSector.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Sector (" +
                    "Sector_ID, "+
                    "Sector_Name, "+
                    "Parent_Sector "+
                    " ) " +
                    " values ('" +
                    newSector.getSectorIdString()+"','"+
                    newSector.getSectorName()+"','"+
                    newSector.getParentSectorIdString()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Sector record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Sector_ID;
    }



    /**
     * Function that creates a record in the Sector table
     *
     * @param newSector
     */
    public boolean modifySector(Sector newSector)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifySector";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Sector Type Object: " + newSector.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Sector set"
                               + " Sector_Name = '"
                               + newSector.getSectorName()
                               + "',"
                               + " Sector_ID = '"
                               + newSector.getSectorId()
                               + "',"
                               + " Parent_Sector = '"
                               + newSector.getParentSectorIdString()
                               + "' where Sector_ID = "
							   + newSector.getSectorIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Sector record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getSectorList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Sector roleTypeEntry = null;
        Collection roles = new ArrayList();

        String location = className + "getSectorList";

        this.logger.debugMessage(location);

        String sql = "select * from Sector where Parent_Sector = 0 order by Sector_Name asc;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleTypeEntry = new Sector();
                roleTypeEntry.setSectorId(rs.getInt("Sector_ID"));
                roleTypeEntry.setSectorName(convertFromDBString(rs.getString("Sector_Name")));
                roleTypeEntry.setParentSectorId(rs.getInt("Parent_Sector"));

                roles.add(roleTypeEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roles;



	}


    /**
     *
     * @param Sector_ID
     */
    public Sector getSector(String Sector_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        Sector roleTypeEntry = null;

        String location = className + "getSector";

        this.logger.debugMessage(location);

        String sql = "select * from Sector where Sector_ID=";
        sql += Sector_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                roleTypeEntry = new Sector();
                roleTypeEntry.setSectorId(rs.getInt("Sector_ID"));
                roleTypeEntry.setSectorName(convertFromDBString(rs.getString("Sector_Name")));
                roleTypeEntry.setParentSectorId(rs.getInt("Parent_Sector"));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return roleTypeEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}