package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.*;

public class TypeLookupDB extends DBAPI {


    private static final String className = "TypeLookupDB.";

    /**
     *
     * @param context
     */
    public TypeLookupDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "TypeLookupDB";
        this.logger.debugMessage(location);
    }


    /**
     * Function that creates a record in the Role table
     *
     * @param newTypeLookup
     */
    public int createTypeLookup(TypeLookup newTypeLookup)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int Type_ID = 0;
        String location = className + "createTypeLookup";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Role Object: " + newTypeLookup.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Type_Lookup (" +
                    "Type_ID, "+
                    "Type_Name "+
                    " ) " +
                    " values ('" +
                    newTypeLookup.getTypeIdString()+"','"+
                    newTypeLookup.getTypeName()
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Type Lookup record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }


            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return Type_ID;
    }



    /**
     * Function that creates a record in the Role table
     *
     * @param newTypeLookup
     */
    public boolean modifyTypeLookup(TypeLookup newTypeLookup)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;

        String location = className + "modifyTypeLookup";
        this.logger.debugMessage(location);
        this.logger.debugMessage("Asset Class Object: " + newTypeLookup.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));


                  String sql2 ="update Type_Lookup set"
                               + " Type_Name = '"
                               + newTypeLookup.getTypeName()
                               + "' where Type_ID = "
							   + newTypeLookup.getTypeIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one Asset Class record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
           try {
		                       if (stmt != null) {
		                           stmt.close();
		                       }
		                       if (useInternalConnectionPool) {
		                           this.pool.freeConnection(conn);
		                       } else {
		                           if (conn != null) {
		                               conn.close();
		                               conn = null;
		                           }
		                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        return true;
    }



    public Collection getTypeLookupList() throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        TypeLookup typeLookupEntry = null;
        Collection typeLookup = new ArrayList();

        String location = className + "getTypeLookupList";

        this.logger.debugMessage(location);

        String sql = "select * from Type_Lookup;";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                typeLookupEntry = new TypeLookup();
                typeLookupEntry.setTypeId(rs.getInt("Type_ID"));
                typeLookupEntry.setTypeName(convertFromDBString(rs.getString("Type_Name")));

                typeLookup.add(typeLookupEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                       if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
				throw e;
            }
        }

        this.logger.debugMessage(location + " is complete");


        return typeLookup;



	}


    /**
     *
     * @param Type_ID
     */
    public TypeLookup getTypeLookup(String Type_ID)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        TypeLookup typeLookupEntry = null;

        String location = className + "getTypeLookup";

        this.logger.debugMessage(location);

        String sql = "select * from Type_Lookup where Type_ID=";
        sql += Type_ID;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                typeLookupEntry = new TypeLookup();
                typeLookupEntry.setTypeId(rs.getInt("Type_ID"));
                typeLookupEntry.setTypeName(convertFromDBString(rs.getString("Type_Name")));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
            }
        }

        this.logger.debugMessage(location + " is complete");


        return typeLookupEntry;

    }




    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }


}