package com.asc.server.database;
/**
 * @created 29-Jan-2007 10:18:04 AM
 * @version 1.0
 */

import java.sql.*;
import javax.servlet.*;
import java.util.*;


import com.core.server.database.DBAPI;
import com.core.server.common.*;
import com.asc.server.objects.User;
import com.aog.server.objects.*;

public class UserDB extends DBAPI {


    private static final String className = "UserDB.";

    /**
     *
     * @param context
     */
    public UserDB(ServletContext context) throws WebPageException{
        super(context);
        String location = className + "UserDB";
        this.logger.debugMessage(location);
    }


     public Collection getUsers(boolean searchByFirstName, String firstname,
            boolean searchByLastName, String lastname,
            boolean searchByEmail, String email, String order, String nUsers) throws SQLException, WebPageException
     {

        Collection userEntries = new ArrayList();
        User userEntry = null;

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;

        String location = className + "getUsers";
        this.logger.debugMessage(location);
        String sql = "select * from Users where 1=1  ";
        if (searchByFirstName) {
            sql += buildSQLLikeFilter(firstname,"First_Name");
        }
        if (searchByLastName) {
            sql += buildSQLLikeFilter(lastname,"Last_Name");
        }
        if (searchByEmail) {
            sql += buildSQLLikeFilter(email,"Email");
        }


        sql += " order by ";
        sql += order;

		if (!nUsers.equals("0"))
		{
				sql += " LIMIT 0 ,  ";
				sql += nUsers;
		}

        sql += ";";

        this.logger.debugMessage("Sql " + sql);
        logSQL(sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));



                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));


                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntries.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return userEntries;



	}



    /**
     * Function that creates a record in the User table
     *
     * @param newUser
     */
    public int createUser(User newUser)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int User_id = 0;
        String location = className + "createUser";
        this.logger.debugMessage(location);
        this.logger.debugMessage("User Object: " + newUser.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal = Calendar.getInstance(TimeZone.getDefault());
            Calendar cal_expire = Calendar.getInstance(TimeZone.getDefault());


DateTime yearLater = new DateTime();

            cal_expire.set(new Integer(yearLater.getYear()).intValue(),
                           new Integer(yearLater.getMonth()).intValue(),
                           new Integer(yearLater.getDay()).intValue());

            this.logger.debugMessage("Now: " + this.sdf.format(cal.getTime()));
            String sql2 ="insert into Users (" +
                    "User_ID, "+
                    "Role_ID, "+
                    "Username, "+
                    "Password, "+
                    "Email, "+
                    "Status, "+
                    "First_Name, "+
                    "MI, "+
                    "Last_Name, "+
                    "Phone_Number, "+
                    "Created_By, "+
                    "City, "+
                    "State, "+
                    "Address, "+
                    "Address_1, "+
                    "Company_Name, "+
                    "Zip_Code, "+
                    "Created_Date, "+
                    "Parent_User_ID, "+
                    "Expiration_Date "+
                    " ) " +
                    " values ('" +
                    newUser.getUserIdString()+"','"+
                    newUser.getRoleIdString()+"','"+
                    newUser.getUserName()+"','"+
                    newUser.getPassword()+"','"+
                    newUser.getEmail()+"','"+
                    newUser.getStatus()+"','"+
                    newUser.getFirstName()+"','"+
                    newUser.getMiddleInitial()+"','"+
                    newUser.getLastName()+"','"+
                    newUser.getPhoneNumber()+"','"+
                    newUser.getCreatedBy()+"','"+
                    newUser.getCity()+"','"+
                    newUser.getState()+"','"+
                    newUser.getAddress()+"','"+
                    newUser.getAddress1()+"','"+
                    newUser.getCompanyName()+"','"+
                    newUser.getZipCode()+"','"+
                    this.sdf.format(cal.getTime())+"','"+
                    newUser.getParentUserIdString()+"','"+
                    this.sdf.format(cal_expire.getTime())
                    + "');";
            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully added one User record");
            }

            // get the application id

        } catch (SQLException e) {
            throw e;
        } finally {
			try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return User_id;
    }


    public boolean modifyUser(User newUser)throws SQLException, WebPageException{
        Connection conn = null;
        Statement stmt = null;
        int User_id = 0;
        String location = className + "modifyUser";
        this.logger.debugMessage(location);
        this.logger.debugMessage("User Object: " + newUser.toString());
        try {

                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            Calendar cal_expire = Calendar.getInstance(TimeZone.getDefault());


            cal_expire.set(new Integer(newUser.getExpirationDate().getYear()).intValue(),
                           new Integer(newUser.getExpirationDate().getMonth()).intValue()-1,
                           new Integer(newUser.getExpirationDate().getDay()).intValue());


                  String sql2 ="update Users set" +
                               " Role_ID = '"
                               + newUser.getRoleIdString()
                               + "',"
                               + " Parent_User_ID = '"
                               + newUser.getParentUserIdString()
                               + "',"
                               + " Username = '"
                               + newUser.getUserName()
                               + "',"
                               + " Password = '"
                               + newUser.getPassword()
                               + "',"
                               + " First_Name = '"
                               + newUser.getFirstName()
                               + "',"
                               + " MI = '"
                               + newUser.getMiddleInitial()
                               + "',"
                               + " Last_Name = '"
                               + newUser.getLastName()
                               + "',"
                               + " City = '"
                               + newUser.getCity()
                               + "',"
                               + " State = '"
                               + newUser.getState()
                               + "',"
                               + " Address = '"
                               + newUser.getAddress()
                               + "',"
                               + " Address_1 = '"
                               + newUser.getAddress1()
                               + "',"
                               + " Zip_Code = '"
                               + newUser.getZipCode()
                               + "',"
                               + " Company_Name = '"
                               + newUser.getCompanyName()
                               + "',"
                               + " Status = '"
                               + newUser.getStatus()
                               + "',"
                               + " Expiration_Date = '"
                               + this.sdf.format(cal_expire.getTime())
                               + "',"
                               + " Phone_Number = '"
                               + newUser.getPhoneNumber()
                               + "',"
                               + " Email = '"
                               + newUser.getEmail()
                               + "' where User_id = "
							   + newUser.getUserIdString()
							   + ";";

            logSQL(sql2);
            stmt = conn.createStatement();
            int i = stmt.executeUpdate(sql2);
            if (i == 1) {
                this.logger.debugMessage("Successfully updated one User record");
            }


        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        return true;
    }


    public Collection getUserList(String order, String nUsers) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;
        Collection Users = new ArrayList();

        String location = className + "getUser";

        this.logger.debugMessage(location);

        String sql = "select * from Users ";
        sql += " order by ";
        sql += order;
        		if (!nUsers.equals("0"))
				{
						sql += " LIMIT 0 ,  ";
						sql += nUsers;
				}

		        sql += ";";


        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));
                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));



                Users.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Users;



	}


    /**
     *
     * @param User_id
     */
    public User getUser(String User_id)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;

        String location = className + "getUser";

        this.logger.debugMessage(location);

        String sql = "select * from Users where User_id=";
        sql += User_id;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));

                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));

         }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return userEntry;

    }


    public boolean userNameExists(String userName) throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String location = className + "userExists";
        this.logger.debugMessage(location);
        boolean isValidUser = false;

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            String sql =
                    "SELECT COUNT(*) FROM Users WHERE Username = '"
                    + userName
                    + "'";
            logSQL(sql);
            rs = stmt.executeQuery(sql);
            if (rs.next()) {
                isValidUser =  rs.getInt("COUNT(*)") > 0 ? true : false;
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }
        return isValidUser;
    } // end of userExists method


    public int validateAccount(String username, String password)throws SQLException,WebPageException{
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String location = className + "validateAccount";
        this.logger.debugMessage(location);
        int account_id = 0;

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            String sql =
                    "SELECT User_Id FROM Users WHERE Status = 'A' and Username = '"
                    + username
                    + "'"
                    + " and Password = '"
                    + password
                    + "'";
            logSQL(sql);
            rs = stmt.executeQuery(sql);
            if (rs.next()) {
                account_id =  rs.getInt("User_Id");
            }
        } catch (SQLException e) {
            e.printStackTrace();
            throw e;
        } finally {
            try {
                if (stmt != null) {
                    stmt.close();
                }
                if (useInternalConnectionPool) {
                    this.pool.freeConnection(conn);
                } else {
                    if (conn != null) {
                        conn.close();
                        conn = null;
                    }
                }

            } catch (SQLException e) {
                logger.exceptionMessage(e);
                e.printStackTrace();
            }
        }
        return account_id;

    }

    /**
     *
     * @exception Throwable
     */
    public void finalize()
    throws Throwable{

    }





    /**
     *
     * @param User_id
     */
    public String getPassword(String userName)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        String password  = null;

        String location = className + "getPassword";

        this.logger.debugMessage(location);

        String sql = "select Password from Users where Username='";
        sql += userName;
        sql += "';";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                password = convertFromDBString(rs.getString("Password"));
            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return password;

    }


    public Collection getUserListByParentID(String parentId, String order, String nUsers) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;
        Collection Users = new ArrayList();

        String location = className + "getUserListByRoleType";

        this.logger.debugMessage(location);

        String sql = "select * from Users ";
        sql += " where Parent_User_ID = ";
        sql += parentId;
        sql += " order by ";
        sql += order;
        		if (!nUsers.equals("0"))
				{
						sql += " LIMIT 0 ,  ";
						sql += nUsers;
				}

		        sql += ";";


        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));



                Users.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Users;



	}



    public Collection getUserListByCompany(String companyId, String order, String nUsers) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;
        Collection Users = new ArrayList();

        String location = className + "getUserListByRoleType";

        this.logger.debugMessage(location);

        String sql = "select * from Users ";
        sql += " where Parent_User_ID in (select User_ID from Users where Parent_User_ID = ";
        sql += companyId;
        sql += ") ";
        sql += " order by ";
        sql += order;


        		if (!nUsers.equals("0"))
				{
						sql += " LIMIT 0 ,  ";
						sql += nUsers;
				}

		        sql += ";";


        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));



                Users.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Users;



	}

    public Collection getUserListByRoleType(String roleType, String order, String nUsers) throws  Exception, WebPageException
    {

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;
        Collection Users = new ArrayList();

        String location = className + "getUserListByRoleType";

        this.logger.debugMessage(location);

        String sql = "select * from Users ";
        sql += " where Role_ID in (select Role_ID from Roles where Role_Type_ID = ";
        sql += roleType;
        sql += ") ";
        sql += " order by ";
        sql += order;
        		if (!nUsers.equals("0"))
				{
						sql += " LIMIT 0 ,  ";
						sql += nUsers;
				}

		        sql += ";";


        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));



                Users.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return Users;



	}



   /**
     *
     * @param User_id
     */
    public Collection getUserListByUserID(String User_id)throws SQLException {
        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;
        User userEntry = null;
        Collection Users = new ArrayList();

        String location = className + "getUser";

        this.logger.debugMessage(location);

        String sql = "select * from Users where User_id=";
        sql += User_id;
        sql += ";";

        this.logger.debugMessage("Sql " + sql);

        try {
                        if (useInternalConnectionPool) {
			                conn = this.pool.getConnection();
			            } else {
			                conn = this.ds.getConnection(dbUsername, dbPassword);
			            }


            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            logSQL(sql);
            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));

                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));

                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));

               Users.add(userEntry);

         }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


       return Users;

    }



     public Collection getUsersByRoleType(boolean searchByFirstName, String firstname,
            boolean searchByLastName, String lastname,
            boolean searchByEmail, String email, String order, String roleType, String nUsers) throws SQLException, WebPageException
     {

        Collection userEntries = new ArrayList();
        User userEntry = null;

        Connection conn = null;
        Statement stmt = null;
        ResultSet rs = null;

        String location = className + "getUsersByRoleType";
        this.logger.debugMessage(location);
        String sql = "select * from Users where 1=1 ";
        if (searchByFirstName) {
            sql += buildSQLLikeFilter(firstname,"First_Name");
        }
        if (searchByLastName) {
            sql += buildSQLLikeFilter(lastname,"Last_Name");
        }
        if (searchByEmail) {
            sql += buildSQLLikeFilter(email,"Email");
        }

        sql += " and Role_ID in (select Role_ID from Roles where Role_Type_ID = ";
        sql += roleType;
        sql += ") ";

        sql += " order by ";
        sql += order;
        		if (!nUsers.equals("0"))
				{
						sql += " LIMIT 0 ,  ";
						sql += nUsers;
				}

		        sql += ";";


        this.logger.debugMessage("Sql " + sql);
        logSQL(sql);

        try {
            if (useInternalConnectionPool) {
                conn = this.pool.getConnection();
            } else {
                conn = this.ds.getConnection(dbUsername, dbPassword);
            }
            stmt = conn.createStatement();
            rs = stmt.executeQuery(sql);

            while (rs != null && rs.next()) {
                userEntry = new User();
                userEntry.setUserId(rs.getInt("User_id"));
                userEntry.setRoleId(rs.getInt("Role_ID"));
                userEntry.setUserName(convertFromDBString(rs.getString("Username")));
                userEntry.setPassword(convertFromDBString(rs.getString("Password")));
                userEntry.setFirstName(convertFromDBString(rs.getString("First_Name")));
                userEntry.setMiddleInitial(convertFromDBString(rs.getString("MI")));
                userEntry.setLastName(convertFromDBString(rs.getString("Last_Name")));
                userEntry.setEmail(convertFromDBString(rs.getString("Email")));
                userEntry.setPhoneNumber(convertFromDBString(rs.getString("Phone_Number")));
                userEntry.setStatus(convertFromDBString(rs.getString("Status")));
                userEntry.setCreatedBy(rs.getInt("created_by"));
                userEntry.setCreatedDate(convertFromDBString(rs.getString("created_date")));
                userEntry.setExpirationDate(convertFromDBString(rs.getString("expiration_date")));


                userEntry.setCity(convertFromDBString(rs.getString("City")));
                userEntry.setState(convertFromDBString(rs.getString("State")));
                userEntry.setAddress(convertFromDBString(rs.getString("Address")));
                userEntry.setAddress1(convertFromDBString(rs.getString("Address_1")));
                userEntry.setCompanyName(convertFromDBString(rs.getString("Company_Name")));
                userEntry.setZipCode(convertFromDBString(rs.getString("Zip_Code")));
                userEntry.setParentUserId(rs.getInt("Parent_User_ID"));



                userEntries.add(userEntry);


            }

        } catch (SQLException e) {
            throw e;
        } finally {
            try {
                    if (stmt != null) {
                           stmt.close();
                       }
                       if (useInternalConnectionPool) {
                           this.pool.freeConnection(conn);
                       } else {
                           if (conn != null) {
                               conn.close();
                               conn = null;
                           }
                       }

            } catch (SQLException e) {
                e.printStackTrace();
            }
        }

        this.logger.debugMessage(location + " is complete");


        return userEntries;



	}





}