package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class AuditTracking {


    protected int event_id;
    protected DateTime event_time_date_stamp;
    protected int user_id;
    protected int tracking_id;

    public AuditTracking(){
        user_id = 0;
        event_id = 0;
        tracking_id = 0;
        event_time_date_stamp= new DateTime("");

    }
    public AuditTracking(int trackingId){
        tracking_id = trackingId;
        event_id = 0;
        event_time_date_stamp= new DateTime("");
        user_id = 0;

    }


    public AuditTracking(AuditTracking pAuditTracking) {
        event_id = pAuditTracking.event_id;
        event_time_date_stamp= new DateTime(pAuditTracking.event_time_date_stamp);
        user_id = pAuditTracking.user_id;
        tracking_id = pAuditTracking.tracking_id;

    }

    public AuditTracking(HttpServletRequest request) throws Exception {
        event_id = 0;
        user_id = 0;
        event_time_date_stamp= new DateTime("");

        try {

            String user_id = null;
            if (request.getParameter("user_id") != null) {
                user_id = new String(request.getParameter("user_id"));
                setUserId(new Integer(user_id).intValue());
            }
            String event_id = null;
            if (request.getParameter("event_id") != null) {
                event_id = new String(request.getParameter("event_id"));
                setEventId(new Integer(event_id).intValue());
            }
            String event_time_date_stamp = null;
            if (request.getParameter("event_time_date_stamp") != null) {
                event_time_date_stamp = new String(request.getParameter("event_time_date_stamp"));
                setEventTimeDateStamp(event_time_date_stamp);
            }


		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the AuditTracking table
     */
    public int getEventId(){
        return event_id;
    }

    public String getEventIdString() {
        return Integer.toString(event_id);
    }

    /**
     * unique identifier of the AuditTracking table
     */
    public int getTrackingId(){
        return tracking_id;
    }

    public String getTrackingIdString() {
        return Integer.toString(tracking_id);
    }


    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }



    public DateTime getEventTimeDateStamp(){
        return event_time_date_stamp;
    }

    public String getEventTimeDateStampDBString() {
        if (this.event_time_date_stamp != null && this.event_time_date_stamp.isValid()) {
            return this.event_time_date_stamp.getYear()+"-"+
                    this.event_time_date_stamp.getMonth()+"-"+
                    this.event_time_date_stamp.getDay();
        } else {
            return new String("");
        }

    }
    public String getEventTimeDateStampString() {
        if (this.event_time_date_stamp != null && this.event_time_date_stamp.isValid()) {
            return this.event_time_date_stamp.getDate("/");
        } else {
            return new String("");
        }

    }


    /**
     * unique identifier of the AuditTracking table
     *
     * @param newVal    newVal
     */
    public void setEventId(int newVal){
        event_id = newVal;
    }

    /**
     * unique identifier of the AuditTracking table
     *
     * @param newVal    newVal
     */
    public void setTrackingId(int newVal){
        tracking_id = newVal;
    }

    public void setEventTimeDateStamp(DateTime newVal){
        this.event_time_date_stamp = newVal;
    }



    public void setEventTimeDateStamp(String pDate) {
	        if (pDate != null) {
	            AOGStringTokenizer st = new AOGStringTokenizer(pDate, "-");

	            // Parse out the year
	            String endYear = new String(st.nextElement());

	            // Parse out the day
	            String endMonth = new String(st.nextElement());

	            // Parse out the month
	            String endDay = new String(st.nextElement());

	            AOGStringTokenizer dayToken = new AOGStringTokenizer(endDay, " ");

	            String day = dayToken.nextElement();

	            DateTime pBirthDate = new DateTime(endMonth + "/" + day + "/" + endYear);
	            setEventTimeDateStamp(pBirthDate);
	        }

    }
    /**
     * unique identifier of the User table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }
    public String toString() {
        String returnString = "Event Id: " + getEventIdString() + " | " +
        "User Id: " + getUserIdString() + " | " +
        "Tracking Id: " + getTrackingIdString() + " | " +
        "Event Time Date Stamp: "  + getEventTimeDateStamp();
        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}