package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;
import java.math.*;

public class Axis {

    protected long interval;

    protected int user_id;
    protected int portfolio_id;
    protected int axis_id;

    protected long scale_min;
    protected long scale_max;

    protected int category_id;
    protected String label_name;
    protected String label_type;

//X-Axis, Y-Axis, Z-Axis
    protected String type;

    public Axis(){
        portfolio_id = 0;
        user_id = 0;
        axis_id = 0;
        scale_max = 0;
        scale_min = 0;
        category_id = 0;
        interval = 0;
        label_name = new String("");
        label_type = new String("");
        type = new String("");
   }

   public Axis(int portfolioId){
        portfolio_id = portfolioId;
        user_id = 0;
        interval = 0;
        scale_max = 0;
        scale_min = 0;
        axis_id  = 0;
        category_id = 0;
        type = new String("");
        label_name = new String("");
        label_type = new String("");
    }


   public Axis(String axisType){
        portfolio_id = 0;
        user_id = 0;
        scale_max = 0;
        scale_min = 0;
        axis_id  = 0;
        category_id = 0;
        interval = 0;
        label_name = new String("");
        type = new String(axisType);
        label_type = new String("");
    }

    public Axis(Axis pAxis) {
        axis_id = pAxis.axis_id;
        user_id = pAxis.user_id;
        portfolio_id = pAxis.portfolio_id;
        category_id = pAxis.category_id;
        interval = pAxis.interval;

        scale_max = pAxis.scale_max;
        scale_min = pAxis.scale_min;
        label_name = new String(pAxis.label_name);
        label_type = new String(pAxis.label_type);
        type = new String(pAxis.type);

    }

    public Axis(HttpServletRequest request, String axisType) throws Exception {
        portfolio_id = 0;

        try {

            String user_id = null;
            if (request.getParameter("user_id") != null) {
                user_id = new String(request.getParameter("user_id"));
                setUserId(new Integer(user_id).intValue());
            }
            String portfolio_id = null;
			if (request.getParameter("id") != null) {
                portfolio_id = new String(request.getParameter("id"));
                setPortfolioId(new Integer(portfolio_id).intValue());
            }

            String scale_max = null;
            if (request.getParameter(axisType+"_scale_max") != null) {
                scale_max = new String(request.getParameter(axisType+"_scale_max"));
                setScaleMax(new Long(scale_max).longValue());
            }

            String scale_min = null;
            if (request.getParameter(axisType+"_scale_min") != null) {
                scale_min = new String(request.getParameter(axisType+"_scale_min"));
                setScaleMin(new Long(scale_min).longValue());
            }

            String axis_id = null;
            if (request.getParameter(axisType+"_axis_id") != null) {
                axis_id = new String(request.getParameter(axisType+"_axis_id"));
                setAxisId(new Integer(axis_id).intValue());
            }

            String label_name = null;
			if (request.getParameter(axisType+"_label_name") != null) {
			                label_name = new String(request.getParameter(axisType+"_label_name"));
			                setLabelName(label_name);
            }

            String label_type = null;
			if (request.getParameter(axisType+"_axis_label_type") != null) {
			                label_type = new String(request.getParameter(axisType+"_axis_label_type"));
			                setLabelType(label_type);
            }

            String interval = null;
			if (request.getParameter(axisType+"_interval") != null) {
			                interval = new String(request.getParameter(axisType+"_interval"));
			                setInterval(new Long(interval).longValue());
            }


            String category_id = null;
			            if (request.getParameter(axisType+"_category_id") != null) {
			                category_id = new String(request.getParameter(axisType+"_category_id"));
			                setCategoryId(new Integer(category_id).intValue());
            }

            type = new String(axisType);

		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the AxisAxesDefinition table
     */
    public int getAxisId(){
        return axis_id;
    }

    public String getAxisIdString() {
        return Integer.toString(axis_id);
    }

    public long getInterval(){
        return interval;
    }

    public String getIntervalString() {
        return String.valueOf(interval);
    }

    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }

    public int getPortfolioId(){
        return portfolio_id;
    }
    public String getPortfolioIdString() {
        return Integer.toString(portfolio_id);
    }
    public int getCategoryId(){
        return category_id;
    }
    public String getCategoryIdString() {
        return Integer.toString(category_id);
    }

    public long getScaleMax(){
        return scale_max;
    }

    public String  getScaleMaxString() {
//        return  Integer.toString(scale_max);
        return String.valueOf(scale_max);
    }

    public long getScaleMin(){
        return scale_min;
    }

    public String getScaleMinString() {
       // return Integer.toString(scale_min);
        return String.valueOf(scale_min);
    }

    public String getLabelName() {
        return label_name;
    }

    public String getLabelType() {
        return label_type;
    }

    public String getType() {
        return type;
    }

    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setAxisId(int newVal){
        axis_id = newVal;
    }

    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setInterval(long newVal){
        interval = newVal;
    }


    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setScaleMin(long  newVal){
        scale_min = newVal;
    }

    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setScaleMax(long newVal){
        scale_max = newVal;
    }

    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }

    public void setCategoryId(int newVal){
        category_id = newVal;
    }

    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setPortfolioId(int newVal){
        portfolio_id = newVal;
    }
    /**
     * unique identifier of the AxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setLabelName(String newVal){
        label_name = newVal;
    }

    public void setLabelType(String newVal){
        label_type = newVal;
    }

    public void setType(String newVal){
        type = newVal;
    }

    public String toString() {
        String returnString =
        "Portfolio Id: " + getPortfolioIdString() + " | " +
        "User Id: " + getUserIdString() + " | " +
        "Category Id: " + getCategoryIdString() + " | " +
        "Interval: " + getIntervalString() + " | " +
        "Axis Id: " + getAxisIdString() + " | " +
        "Scale Min: " + getScaleMin() + " | " +
        "Scale Max: " + getScaleMax() + " | " +
        "Type: " + getType() + " | " +
        "Label Type: " + getLabelType() + " | " +
        "LabelName: " + getLabelName();

        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}
