package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class InvestmentHolding {


    protected int portfolio_id;
    protected int user_id;
    protected int investment_id;

    protected int quantity;
    protected int value;

    public InvestmentHolding(){
        portfolio_id = 0;
        user_id = 0;
        investment_id = 0;

        quantity = 0;
		value = 0;
   }

   public InvestmentHolding(int p_investment_id, int portfolioId, int userId){
        portfolio_id = portfolioId;
        investment_id = p_investment_id;
        user_id = userId;
        quantity = 0;
        value = 0;
    }

    public InvestmentHolding(InvestmentHolding pInvestment) {
        portfolio_id = pInvestment.portfolio_id;
        user_id = pInvestment.user_id;
        quantity = pInvestment.quantity;
        investment_id = pInvestment.investment_id;
        value = pInvestment.value;

    }

    public InvestmentHolding(HttpServletRequest request) throws Exception {
        portfolio_id = 0;

        try {

            String user_id = null;
            if (request.getParameter("user_id") != null) {
                user_id = new String(request.getParameter("user_id"));
                setUserId(new Integer(user_id).intValue());
            }

            String quantity = null;
            if (request.getParameter("quantity") != null) {
                quantity = new String(request.getParameter("quantity"));
                setQuantity(new Integer(quantity).intValue());
            }

            String investment_id = null;
            if (request.getParameter("investment_id") != null) {
                investment_id = new String(request.getParameter("investment_id"));
                setInvestmentId(new Integer(investment_id).intValue());
            }

            String portfolio_id = null;
            if (request.getParameter("portfolio_id") != null) {
                portfolio_id = new String(request.getParameter("portfolio_id"));
                setPortfolioId(new Integer(portfolio_id).intValue());
            }

            String value = null;
            if (request.getParameter("value") != null) {
                value = new String(request.getParameter("value"));
                setValue(new Integer(value).intValue());
            }


		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the InvestmentHolding table
     */
    public int getPortfolioId(){
        return portfolio_id;
    }

    public String getPortfolioIdString() {
        return Integer.toString(portfolio_id);
    }

    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }


    public int getInvestmentId(){
        return investment_id;
    }

    public String getInvestmentIdString() {
        return Integer.toString(investment_id);
    }

    public int getQuantity(){
        return quantity;
    }

    public String getQuantityString() {
        return Integer.toString(quantity);
    }

    public int getValue(){
        return value;
    }

    public String getValueString() {
        return Integer.toString(value);
    }


    /* unique identifier of the InvestmentHolding table
     *
     * @param newVal    newVal
     */
    public void setValue(int newVal){
        value = newVal;
    }


    /**
     * unique identifier of the InvestmentHolding table
     *
     * @param newVal    newVal
     */
    public void setPortfolioId(int newVal){
        portfolio_id = newVal;
    }

    /**
     * unique identifier of the InvestmentHolding table
     *
     * @param newVal    newVal
     */
    public void setQuantity(int newVal){
        quantity = newVal;
    }

    /**
     * unique identifier of the InvestmentHolding table
     *
     * @param newVal    newVal
     */
    public void setInvestmentId(int newVal){
        investment_id = newVal;
    }

    /**
     * unique identifier of the InvestmentHolding table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }
    public String toString() {
        String returnString = "Portfolio Id: " + getPortfolioId() + " | " +
        "User Id: " + getUserIdString() + " | " +
        "Investment Id: " + getInvestmentIdString() + " | " +
        "Quantity: " + getQuantityString() + " | " +
        "Value: "  + getValueString();

        return (returnString);
    }
    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}