package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class Portfolio {


    protected int portfolio_id;
    protected int user_id;
    protected int investment_id;
    protected int parent_id;
    protected String name;

    protected int createdBy;
    protected DateTime createdDate;
    protected DateTime expirationDate;
    protected String username;


    public Portfolio(){
        portfolio_id = 0;
        user_id = 0;
        parent_id = 0;
        investment_id = 0;
        createdBy= 0;

        name= new String("");
        username= new String("");
        createdDate= new DateTime("");
        expirationDate= new DateTime("");
   }

   public Portfolio(int portfolioId){
        portfolio_id = portfolioId;
        user_id = 0;
        parent_id = 0;
        investment_id = 0;
        createdBy= 0;

        username= new String("");
        name= new String("");
        createdDate= new DateTime("");
        expirationDate= new DateTime("");
    }


    public Portfolio(Portfolio pPortfolio) {
        portfolio_id = pPortfolio.portfolio_id;
        user_id = pPortfolio.user_id;
        parent_id = pPortfolio.parent_id;
        investment_id = pPortfolio.investment_id;
        createdBy = pPortfolio.createdBy;
        createdDate= new DateTime(pPortfolio.createdDate);
        expirationDate= new DateTime(pPortfolio.expirationDate);
        name= new String(pPortfolio.name);
        username= new String(pPortfolio.username);


    }

    public Portfolio(HttpServletRequest request) throws Exception {
        portfolio_id = 0;
        investment_id = 0;

        try {

            String user_id = null;
            if (request.getParameter("user_id") != null) {
                user_id = new String(request.getParameter("user_id"));
                setUserId(new Integer(user_id).intValue());
            }

            String parent_id = null;
            if (request.getParameter("parent_id") != null) {
                parent_id = new String(request.getParameter("parent_id"));
                setParentId(new Integer(parent_id).intValue());
            }

            String name = null;
            if (request.getParameter("name") != null) {
                name = new String(request.getParameter("name"));
                setName(name);
            }

            String expiration_date = null;
            if (request.getParameter("expiration_date") != null) {

                expiration_date = new String(request.getParameter("expiration_date"));
                setExpirationDate(new DateTime(expiration_date));
            }
                    username= new String("");


		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the Portfolio table
     */
    public int getPortfolioId(){
        return portfolio_id;
    }

    public String getPortfolioIdString() {
        return Integer.toString(portfolio_id);
    }

    public String getName(){
        return name;
    }


    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }
    public int getParentId(){
        return parent_id;
    }

    public String getParentIdString() {
        return Integer.toString(parent_id);
    }

    public int getInvestmentId(){
        return investment_id;
    }

    public String getInvestmentIdString() {
        return Integer.toString(investment_id);
    }


    public int getCreatedBy(){
        return createdBy;
    }

    public String getCreatedByString() {
        return Integer.toString(createdBy);
    }

    public DateTime getCreatedDate(){
        return createdDate;
    }


    public String getCreatedDateDBString() {
        if (this.createdDate != null && this.createdDate.isValid()) {
            return this.createdDate.getYear()+"-"+
                    this.createdDate.getMonth()+"-"+
                    this.createdDate.getDay();
        } else {
            return new String("");
        }

    }

    public String getCreatedDateString() {
        if (this.createdDate != null && this.createdDate.isValid()) {
            return this.createdDate.getDate("/");
        } else {
            return new String("");
        }

    }

    public DateTime getExpirationDate(){
        return expirationDate;
    }

    public String getExpirationDateDBString() {
        if (this.expirationDate != null && this.expirationDate.isValid()) {
            return this.expirationDate.getYear()+"-"+
                    this.expirationDate.getMonth()+"-"+
                    this.expirationDate.getDay();
        } else {
            return new String("");
        }

    }
    public String getExpirationDateString() {
        if (this.expirationDate != null && this.expirationDate.isValid()) {
            return this.expirationDate.getDate("/");
        } else {
            return new String("");
        }

    }

    public String getUserName(){
        return username;
    }


    /**
     * unique identifier of the Portfolio table
     *
     * @param newVal    newVal
     */
    public void setPortfolioId(int newVal){
        portfolio_id = newVal;
    }
    public void setUserName(String newVal){
        username = newVal;
    }
    /**
     * unique identifier of the Portfolio table
     *
     * @param newVal    newVal
     */
    public void setParentId(int newVal){
        parent_id = newVal;
    }

    /**
     * unique identifier of the Portfolio table
     *
     * @param newVal    newVal
     */
    public void setInvestmentId(int newVal){
        investment_id = newVal;
    }

    /**
     * unique identifier of the Portfolio table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }


    public void setName(String newVal){
        name = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setCreatedBy(int newVal){
        createdBy = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setExpirationDate(DateTime newVal){
        this.expirationDate = newVal;
    }

    public void setExpirationDate(String pDate) {
        if (pDate != null) {
            AOGStringTokenizer st = new AOGStringTokenizer(pDate, "-");

            // Parse out the year
            String endYear = new String(st.nextElement());

            // Parse out the day
            String endMonth = new String(st.nextElement());

            // Parse out the month
            String endDay = new String(st.nextElement());

            AOGStringTokenizer dayToken = new AOGStringTokenizer(endDay, " ");

            String day = dayToken.nextElement();

            DateTime pBirthDate = new DateTime(endMonth + "/" + day + "/" + endYear);
            setExpirationDate(pBirthDate);
        }

    }

    public void setCreatedDate(DateTime newVal){
        this.createdDate = newVal;
    }



    public void setCreatedDate(String pDate) {
        if (pDate != null) {
            AOGStringTokenizer st = new AOGStringTokenizer(pDate, "-");

            // Parse out the year
            String endYear = new String(st.nextElement());

            // Parse out the day
            String endMonth = new String(st.nextElement());

            // Parse out the month
            String endDay = new String(st.nextElement());

            AOGStringTokenizer dayToken = new AOGStringTokenizer(endDay, " ");

            String day = dayToken.nextElement();

            DateTime pBirthDate = new DateTime(endMonth + "/" + day + "/" + endYear);
            setCreatedDate(pBirthDate);
        }

    }

    public String toString() {
        String returnString = "Portfolio Id: " + getPortfolioIdString() + " | " +
        "Name: "  + getName() + " | " +
        "Investment Id: " + getInvestmentIdString() + " | " +
        "User Id: " + getUserIdString() + " | " +
        "Parent Id: " + getParentIdString() + " | " +
        "Expiration Date: "  + getExpirationDateString() + " | " +
        "Created By: "  + getCreatedByString() + " | " +
        "Create Date: " + getCreatedDateString();

        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}