package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class PortfolioAxesDefinition {


    protected int user_id;
    protected int portfolio_id;
    protected Axis x_axis;
    protected Axis y_axis;
    protected Axis z_axis;



    public PortfolioAxesDefinition(){
        portfolio_id = 0;
        user_id = 0;
        x_axis = new Axis("X");
        z_axis = new Axis("Z");
        y_axis = new Axis("Y");
   }

   public PortfolioAxesDefinition(int portfolioId){
        portfolio_id = portfolioId;
        user_id = 0;
        x_axis = new Axis("X");
        z_axis = new Axis("Z");
        y_axis = new Axis("Y");
    }


    public PortfolioAxesDefinition(PortfolioAxesDefinition pXAxis) {
        user_id = pXAxis.user_id;
        portfolio_id = pXAxis.portfolio_id;

        x_axis = new Axis(pXAxis.x_axis);
        y_axis = new Axis(pXAxis.y_axis);
        z_axis = new Axis(pXAxis.z_axis);
    }

    public PortfolioAxesDefinition(HttpServletRequest request) throws Exception {
        portfolio_id = 0;

        try {

            String user_id = null;
            if (request.getParameter("user_id") != null) {
                user_id = new String(request.getParameter("user_id"));
                setUserId(new Integer(user_id).intValue());
            }

            String z_axis = null;
            if (request.getParameter("z_axis") != null) {
                z_axis = new String(request.getParameter("z_axis"));
                setZAxisId(new Integer(z_axis).intValue());
            }

            String y_axis = null;
            if (request.getParameter("y_axis") != null) {
                y_axis = new String(request.getParameter("y_axis"));
                setYAxisId(new Integer(y_axis).intValue());
            }

            String x_axis = null;
            if (request.getParameter("x_axis") != null) {
                y_axis = new String(request.getParameter("x_axis"));
                setYAxisId(new Integer(y_axis).intValue());
            }

            String portfolio_id = null;
			if (request.getParameter("portfolio_id") != null) {
			    portfolio_id = new String(request.getParameter("portfolio_id"));
			    setPortfolioId(new Integer(portfolio_id).intValue());
            }
		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the XAxisAxesDefinition table
     */
    public int getXAxisId(){
        return x_axis.getAxisId();
    }

    public String getXAxisIdString() {
        return x_axis.getAxisIdString();
    }

    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }

    public int getPortfolioId(){
        return portfolio_id;
    }
    public String getPortfolioIdString() {
        return Integer.toString(portfolio_id);
    }

    public int getZAxisId(){
        return z_axis.getAxisId();
    }

    public String getZAxisIdString() {
        return z_axis.getAxisIdString();
    }

    public int getYAxisId(){
        return y_axis.getAxisId();
    }

    public String getYAxisIdString() {
        return y_axis.getAxisIdString();
    }

    public Axis getXAxis(){
        return x_axis;
    }

    public Axis getYAxis(){
        return y_axis;
    }

    public Axis getZAxis(){
        return z_axis;
    }


    public void setXAxis(Axis newVal){
        x_axis = new Axis(newVal);
    }

    public void setYAxis(Axis newVal){
        y_axis = new Axis(newVal);
    }

    public void setZAxis(Axis newVal){
        z_axis = new Axis(newVal);
    }


    /**
     * unique identifier of the XAxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setXAxisId(int newVal){
        x_axis.setAxisId(newVal);
    }

    /**
     * unique identifier of the XAxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setYAxisId(int newVal){
        y_axis.setAxisId(newVal);
    }

    /**
     * unique identifier of the XAxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setZAxisId(int newVal){
        z_axis.setAxisId(newVal);
    }

    /**
     * unique identifier of the XAxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }

    /**
     * unique identifier of the XAxisAxesDefinition table
     *
     * @param newVal    newVal
     */
    public void setPortfolioId(int newVal){
        portfolio_id = newVal;
    }

    public String toString() {
        String returnString =
        "Portfolio Id: " + getPortfolioIdString() + " | " +
        "XAxis Id: " + getXAxisIdString() + " | " +
        "YAxis Id: " + getYAxisIdString() + " | " +
        "User Id: " + getXAxisIdString() + " | " +
        "ZAxis Id: " + getZAxisIdString();

        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}