package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class Role {


    protected int role_id;
    protected int role_type_id;
    protected String name;
    protected String description;
    protected String access;

    public Role(){
        role_id = 0;
        role_type_id = 0;
        name= new String("");
        description= new String("");
        access= new String("");

    }
    public Role(int roleId){
        role_id = roleId;
        role_type_id = 0;
        name= new String("");
        description= new String("");
        access= new String("");

    }


    public Role(Role pRole) {
        role_id = pRole.role_id;
        role_type_id = pRole.role_type_id;;
        name= new String(pRole.name);
        description= new String(pRole.description);

    }

    public Role(HttpServletRequest request) throws Exception {
        role_id = 0;
        role_type_id = 0;
        name= new String("");
        description= new String("");
        access= new String("");

        try {
            String role_type_id = null;
            if (request.getParameter("role_type_id") != null) {
                role_type_id = new String(request.getParameter("role_type_id"));
                setRoleTypeId(new Integer(role_type_id).intValue());
            }

            String name = null;
            if (request.getParameter("name") != null) {
                name = new String(request.getParameter("name"));
                setName(name);
            }
            String access = null;
            if (request.getParameter("access") != null) {
                access = new String(request.getParameter("access"));
                setAccessLevel(access);
            }
            String description = null;
            if (request.getParameter("description") != null) {
                description = new String(request.getParameter("description"));
                setDescription(description);
            }


		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the Role table
     */
    public int getRoleId(){
        return role_id;
    }

    public int getRoleTypeId(){
        return role_type_id;
    }
    public String getRoleTypeIdString() {
        return Integer.toString(role_type_id);
    }

    public String getRoleIdString() {
        return Integer.toString(role_id);
    }

    public String getName(){
        return name;
    }

    public String getDescription(){
        return description;
    }
    public String getAccessLevel(){
        return access;
    }

    /**
     * unique identifier of the Role table
     *
     * @param newVal    newVal
     */
    public void setRoleId(int newVal){
        role_id = newVal;
    }
    public void setRoleTypeId(int newVal){
        role_type_id = newVal;
    }

    public void setName(String newVal){
        name = newVal;
    }
    public void setAccessLevel(String newVal){
        access = newVal;
    }
    /**
     * name
     *
     * @param newVal    newVal
     */
    public void setDescription(String newVal){
        description = newVal;
    }


    public String toString() {
        String returnString = "Role Id: " + getRoleIdString() + " | " +
                "Role Type Id: "  + getRoleTypeIdString() + " | " +
                "Name: "  + getName() + " | " +
                "AccessLevel: "  + getAccessLevel() + " | " +
                "Description: "  + getDescription();
        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}