package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class RoleType {


    protected int role_type_id;
    protected String role_type_name;
    protected String role_type_description;
    protected int parent_role_type_id;

    public RoleType(){
        role_type_id = 0;
        parent_role_type_id = 0;
        role_type_name= new String("");
        role_type_description= new String("");

    }
    public RoleType(int roleId){
        role_type_id = roleId;
        parent_role_type_id = 0;
        role_type_name= new String("");
        role_type_description= new String("");

    }


    public RoleType(RoleType pRole) {
        role_type_id = pRole.role_type_id;
        parent_role_type_id = pRole.parent_role_type_id;
        role_type_name= new String(pRole.role_type_name);
        role_type_description= new String(pRole.role_type_description);

    }

    public RoleType(HttpServletRequest request) throws Exception {
        role_type_id = 0;
        parent_role_type_id = 0;
        role_type_name= new String("");
        role_type_description= new String("");

        try {

            String role_type_name = null;
            if (request.getParameter("role_type_name") != null) {
                role_type_name = new String(request.getParameter("role_type_name"));
                setRoleTypeName(role_type_name);
            }

            String role_type_description = null;
            if (request.getParameter("role_type_description") != null) {
                role_type_description = new String(request.getParameter("role_type_description"));
                setRoleTypeDescription(role_type_description);
            }


            String parent_role_type_id = null;
            if (request.getParameter("parent_role_type_id") != null) {
                parent_role_type_id = new String(request.getParameter("parent_role_type_id"));
                setParentRoleTypeId(new Integer(parent_role_type_id).intValue());
            }

		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the RoleType table
     */
    public int getRoleTypeId(){
        return role_type_id;
    }

    public int getParentRoleTypeId(){
        return parent_role_type_id;
    }


    public String getRoleTypeIdString() {
        return Integer.toString(role_type_id);
    }

    public String getParentRoleTypeIdString() {
        return Integer.toString(parent_role_type_id);
    }

    public String getRoleTypeName(){
        return role_type_name;
    }

    public String getRoleTypeDescription(){
        return role_type_description;
    }

    /**
     * unique identifier of the RoleType table
     *
     * @param newVal    newVal
     */
    public void setRoleTypeId(int newVal){
        role_type_id = newVal;
    }

    /**
     * unique identifier of the RoleType table
     *
     * @param newVal    newVal
     */
    public void setParentRoleTypeId(int newVal){
        parent_role_type_id = newVal;
    }

    public void setRoleTypeName(String newVal){
        role_type_name = newVal;
    }
    /**
     * role_type_name
     *
     * @param newVal    newVal
     */
    public void setRoleTypeDescription(String newVal){
        role_type_description = newVal;
    }


    public String toString() {
        String returnString = "RoleType Id: " + getRoleTypeIdString() + " | " +
                "Parent Role ID: "  + getParentRoleTypeIdString() + " | " +
                "Role Type Name: "  + getRoleTypeName() + " | " +
                "Role Type Description: "  + getRoleTypeDescription();
        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}