package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class Sector {


    protected int sector_id;
    protected String sector_name;
    protected int parent_sector_id;

    public Sector(){
        sector_id = 0;
        sector_name= new String("");
        parent_sector_id= 0;

    }
    public Sector(int roleId){
        sector_id = roleId;
        sector_name= new String("");
        parent_sector_id = 0;

    }


    public Sector(Sector pSector) {
        sector_id = pSector.sector_id;
        sector_name= new String(pSector.sector_name);
        parent_sector_id = pSector.parent_sector_id;

    }

    public Sector(HttpServletRequest request) throws Exception {
        sector_id = 0;
        sector_name= new String("");
        parent_sector_id= 0;

        try {

            String sector_name = null;
            if (request.getParameter("sector_name") != null) {
                sector_name = new String(request.getParameter("sector_name"));
                setSectorName(sector_name);
            }

            String parent_sector_id = null;
            if (request.getParameter("parent_sector_id") != null) {
                parent_sector_id = new String(request.getParameter("parent_sector_id"));
                setParentSectorId(new Integer(parent_sector_id).intValue());
            }


		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the Sector table
     */
    public int getSectorId(){
        return sector_id;
    }

    public String getSectorIdString() {
        return Integer.toString(sector_id);
    }

    public String getSectorName(){
        return sector_name;
    }

    public String getParentSectorIdString() {
        return Integer.toString(parent_sector_id);
    }


    /**
     * unique identifier of the Sector table
     *
     * @param newVal    newVal
     */
    public void setSectorId(int newVal){
        sector_id = newVal;
    }

    public void setSectorName(String newVal){
        sector_name = newVal;
    }

    /**
     * sector_name
     *
     * @param newVal    newVal
     */
    public void setParentSectorId(int newVal){
        parent_sector_id = newVal;
    }


    public String toString() {
        String returnString = "Sector Id: " + getSectorIdString() + " | " +
                "SectorName: "  + getSectorName() + " | " +
                 "ParentSector: "  + getParentSectorIdString();
        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}