package com.asc.server.objects;

/**
 * @created 27-Jan-2007 9:30:48 PM
 * @author Travis Kennedy
 * @version 1.0
 */
import com.core.server.objects.*;
import javax.servlet.http.*;
import com.core.server.common.*;

public class User {

    public static String pActive = "A";
    public static String Inactive = "I";
    public static String Pending = "P";

    protected int user_id;
    protected int role_id;
    protected int parent_user_id;
    protected String username;
    protected String password;
    protected String email;
    protected String phoneNumber;
    protected String status;
    protected String firstname;
    protected String middleinitial;
    protected String lastname;



    protected String city;
    protected String state;
    protected String company_name;
    protected String address;
    protected String address_1;
    protected String zip_code;


    protected int createdBy;
    protected DateTime createdDate;
    protected DateTime expirationDate;

    public User(){
        parent_user_id = 0;
        user_id = 0;
        role_id = 0;
        username= new String("");
        password= new String("");
        email= new String("");
        status= new String("P");
        firstname = new String("");
        middleinitial= new String("");
        lastname= new String("");
        phoneNumber= new String("");


        city= new String("");
        state= new String("");
        company_name= new String("");
        address= new String("");
        address_1= new String("");
        zip_code= new String("");


        createdBy= 0;
        createdDate= new DateTime("");
        expirationDate= new DateTime("");

    }
    public User(int userId){
        user_id = userId;
        role_id = 0;
        parent_user_id = 0;
        firstname = new String("");
        lastname= new String("");
        username= new String("");
        email= new String("");
        middleinitial= new String("");
        password= new String("");
        phoneNumber= new String("");
        createdBy= 0;
        createdDate= new DateTime("");
        expirationDate= new DateTime("");
        status= new String("P");
        city= new String("");
        state= new String("");
        company_name= new String("");
        address= new String("");
        address_1= new String("");
        zip_code= new String("");

    }


    public User(User pUser) {
        user_id = pUser.user_id;
        role_id = pUser.role_id;
        firstname = new String(pUser.firstname);
        lastname= new String(pUser.lastname);
        username= new String(pUser.lastname);
        email= new String(pUser.email);
        phoneNumber= new String(pUser.phoneNumber);
        middleinitial= new String(pUser.middleinitial);
        password= new String(pUser.password);
        createdBy= pUser.createdBy;
        createdDate= new DateTime(pUser.createdDate);
        expirationDate= new DateTime(pUser.expirationDate);
        status= new String(pUser.status);
        parent_user_id = pUser.parent_user_id;

        city = pUser.city;
        state = pUser.state;
        company_name = pUser.company_name;
        address = pUser.address;
        address_1 = pUser.address_1;
        zip_code = pUser.zip_code;

    }

    public User(HttpServletRequest request) throws Exception {
        user_id = 0;
        role_id = 0;
        username= new String("");
        password= new String("");
        email= new String("");
        phoneNumber= new String("");
        status= new String("P");
        firstname = new String("");
        middleinitial= new String("");
        lastname= new String("");
parent_user_id=0;
        createdBy= 0;
        createdDate= new DateTime("");
        expirationDate= new DateTime("");

        try {

            String email = null;
            if (request.getParameter("email") != null) {
                email = new String(request.getParameter("email"));
                setEmail(email);
                setUserName(email);
            }

            String phoneNumber = null;
            if (request.getParameter("phonenumber") != null) {
                phoneNumber = new String(request.getParameter("phonenumber"));
                setPhoneNumber(phoneNumber);
            }

            String firstname = null;
            if (request.getParameter("firstname") != null) {
                firstname = new String(request.getParameter("firstname"));
                setFirstName(firstname);
            }

            String lastname = null;
            if (request.getParameter("lastname") != null) {
                lastname = new String(request.getParameter("lastname"));
                setLastName(lastname);
            }

            String middleinitial = null;
            if (request.getParameter("middleinitial") != null) {
                middleinitial = new String(request.getParameter("middleinitial"));
                setMiddleInitial(middleinitial);
            }

            String password = null;
            if (request.getParameter("password1") != null) {
                password = new String(request.getParameter("password1"));
                setPassword(password);
            }

            String role_id_string = null;
            if (request.getParameter("role_id") != null) {
                role_id_string = new String(request.getParameter("role_id"));
                setRoleId(new Integer(role_id_string).intValue());
            }

            String status =	 null;
            if (request.getParameter("status") != null) {
                status = new String(request.getParameter("status"));
                setStatus(status);
            }

            String parent_user_id_string = null;
            if (request.getParameter("parent_user_id") != null) {
                parent_user_id_string = new String(request.getParameter("parent_user_id"));
                setParentUserId(new Integer(parent_user_id_string).intValue());
            }
            if (request.getParameter("city") != null) {
                city = new String(request.getParameter("city"));
                setCity(city);
            }

            String state_s;
            if (request.getParameter("state_s") != null) {
                state_s = new String(request.getParameter("state_s"));
                setState(state_s);
            }

            String company_name;
            if (request.getParameter("company_name") != null) {
                company_name = new String(request.getParameter("company_name"));
                setCompanyName(company_name);
            }

            String address;
           if (request.getParameter("address") != null) {
                address = new String(request.getParameter("address"));
                setAddress(address);
            }

            String address_1;
            if (request.getParameter("address_1") != null) {
                address_1 = new String(request.getParameter("address_1"));
                setAddress1(address_1);
            }
            String zip_code;
            if (request.getParameter("zip_code") != null) {
                zip_code = new String(request.getParameter("zip_code"));
                setZipCode(zip_code);
            }
            String expiration_date = null;
            if (request.getParameter("expiration_date") != null) {

                expiration_date = new String(request.getParameter("expiration_date"));
                setExpirationDate(new DateTime(expiration_date));
            }
		} catch (Exception e) {
		            throw e;
		}
    }



    /**
     * unique identifier of the User table
     */
    public int getUserId(){
        return user_id;
    }

    public String getUserIdString() {
        return Integer.toString(user_id);
    }

    public int getParentUserId(){
        return parent_user_id;
    }

    public String getParentUserIdString() {
        return Integer.toString(parent_user_id);
    }

    public int getRoleId(){
        return role_id;
    }

    public String getRoleIdString() {
        return Integer.toString(role_id);
    }

    public String getFirstName(){
        return firstname;
    }
    public String getMiddleInitial(){
        return middleinitial;
    }
    public String getLastName(){
        return lastname;
    }

    public String getFullName(){
        return firstname + " " + lastname;
    }

    public String getUserName(){
        return username;
    }

    public String getStatus(){
        return status;
    }

    public String getPassword(){
        return password;
    }

    public String getEmail(){
        return email;
    }

    public String getPhoneNumber(){
        return phoneNumber;
    }

    public int getCreatedBy(){
        return createdBy;
    }
  public String getCity() {return this.city;}

  public String getState() {return this.state;}

  public String getCompanyName() {return this.company_name;}

  public String getAddress() {return this.address;}

  public String getAddress1() {return this.address_1;}

  public String getZipCode() {return this.zip_code;}

    public String getCreatedByString() {
        return Integer.toString(createdBy);
    }

    public DateTime getCreatedDate(){
        return createdDate;
    }


    public String getCreatedDateDBString() {
        if (this.createdDate != null && this.createdDate.isValid()) {
            return this.createdDate.getYear()+"-"+
                    this.createdDate.getMonth()+"-"+
                    this.createdDate.getDay();
        } else {
            return new String("");
        }

    }

    public String getCreatedDateString() {
        if (this.createdDate != null && this.createdDate.isValid()) {
            return this.createdDate.getDate("/");
        } else {
            return new String("");
        }

    }



    public DateTime getExpirationDate(){
        return expirationDate;
    }

    public String getExpirationDateDBString() {
        if (this.expirationDate != null && this.expirationDate.isValid()) {
            return this.expirationDate.getYear()+"-"+
                    this.expirationDate.getMonth()+"-"+
                    this.expirationDate.getDay();
        } else {
            return new String("");
        }

    }
    public String getExpirationDateString() {
        if (this.expirationDate != null && this.expirationDate.isValid()) {
            return this.expirationDate.getDate("/");
        } else {
            return new String("");
        }

    }


    /**
     * unique identifier of the User table
     *
     * @param newVal    newVal
     */
    public void setUserId(int newVal){
        user_id = newVal;
    }

    public void setParentUserId(int newVal){
        parent_user_id = newVal;
    }


    public void setRoleId(int newVal){
        role_id = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setFirstName(String newVal){
        firstname = newVal;
    }
    /**
     *
     * @param newVal    newVal
     */
    public void setLastName(String newVal){
        lastname = newVal;
    }

    public void setUserName(String newVal){
        username = newVal;
    }

    public void setCity(String newVal){
        city = newVal;
    }

    public void setState(String newVal){
        state = newVal;
    }
    public void setCompanyName(String newVal){
        company_name = newVal;
    }
    public void setAddress(String newVal){
        address = newVal;
    }
    public void setAddress1(String newVal){
        address_1 = newVal;
    }
    public void setZipCode(String newVal){
        zip_code = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setCreatedBy(int newVal){
        createdBy = newVal;
    }


    /**
     *
     * @param newVal    newVal
     */
    public void setPhoneNumber(String newVal){
        phoneNumber = newVal;
    }
    /**
     *
     * @param newVal    newVal
     */
    public void setEmail(String newVal){
        email = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setMiddleInitial(String newVal){
        middleinitial = newVal;
    }

    /**
     * username
     *
     * @param newVal    newVal
     */
    public void setPassword(String newVal){
        password = newVal;
    }

    /**
     *
     * @param newVal    newVal
     */
    public void setExpirationDate(DateTime newVal){
        this.expirationDate = newVal;
    }



    public void setExpirationDate(String pDate) {
        if (pDate != null) {
            AOGStringTokenizer st = new AOGStringTokenizer(pDate, "-");

            // Parse out the year
            String endYear = new String(st.nextElement());

            // Parse out the day
            String endMonth = new String(st.nextElement());

            // Parse out the month
            String endDay = new String(st.nextElement());

            AOGStringTokenizer dayToken = new AOGStringTokenizer(endDay, " ");

            String day = dayToken.nextElement();

            DateTime pBirthDate = new DateTime(endMonth + "/" + day + "/" + endYear);
            setExpirationDate(pBirthDate);
        }

    }

    public void setCreatedDate(DateTime newVal){
        this.createdDate = newVal;
    }



    public void setCreatedDate(String pDate) {
        if (pDate != null) {
            AOGStringTokenizer st = new AOGStringTokenizer(pDate, "-");

            // Parse out the year
            String endYear = new String(st.nextElement());

            // Parse out the day
            String endMonth = new String(st.nextElement());

            // Parse out the month
            String endDay = new String(st.nextElement());

            AOGStringTokenizer dayToken = new AOGStringTokenizer(endDay, " ");

            String day = dayToken.nextElement();

            DateTime pBirthDate = new DateTime(endMonth + "/" + day + "/" + endYear);
            setCreatedDate(pBirthDate);
        }

    }


   /**
     *
     * @param newVal    newVal
     */
    public void setStatus(String newVal){
        status = newVal;
    }

    public String toString() {
        String returnString = "First Name: " + getFirstName() + " | " +
                "Middle Initial: "  + getMiddleInitial() + " | " +
                "Last Name: "  + getLastName() + " | " +
                "Username: "  + getUserName() + " | " +
                "Password: "  + getPassword() + " | " +
                "Email: "  + getEmail() + " | " +
                "Phone Number: "  + getPhoneNumber() + " | " +
                "Expiration Date: "  + getExpirationDateString() + " | " +
                "Created By: "  + getCreatedByString() + " | " +
                "Create Date: "  + getCreatedDateString() + " | " +
                "Status: "  + getStatus() + " | " +
                "Parent Role Id: "  + getParentUserIdString() + " | " +
                "Role Id: "  + getRoleIdString() + " | " +
                "User Id: " + getUserIdString();
        return (returnString);
    }

    /**
     *
     * @exception Throwable Throwable
     */
    public void finalize()
    throws Throwable{

    }
}