/*************************************************************************
 * Author : Kavitha Subramani
 * Date   : Sep 02 2007
 * Version: 1.0
**************************************************************************/
package com.asc.utils;

import javax.media.j3d.*;
import javax.vecmath.*;


public class Cube extends Shape3D {

	private float dim = 0.0f;
	private float negDim = 0.0f;


	public Cube(float dim, Appearance appearance){

		this.dim=dim;
		this.negDim = -1 * dim;
	
		this.setGeometry(createGeometry());
		this.setAppearance(appearance);

	}





   private Geometry createGeometry() {

		float[] verts = {
        	// Front Face
        	dim, negDim, dim, dim, dim, dim,
        	negDim, dim, dim, negDim, negDim, dim,
        	// Back Face
            negDim, negDim, negDim, negDim, dim, negDim,
             dim, dim, negDim, dim, negDim, negDim,
            // Right Face
             dim, negDim, negDim, dim, dim, negDim,
             dim, dim, dim, dim, negDim, dim,
            // Left Face
            negDim, negDim, dim, negDim, dim, dim,
            negDim, dim, negDim, negDim, negDim, negDim,
            // Top Face
             dim, dim, dim, dim, dim, negDim,
            negDim, dim, negDim, negDim, dim, dim,
            // Bottom Face
            negDim, negDim, dim, negDim, negDim, negDim,
             dim, negDim, negDim, dim, negDim, dim,
        };


    	float[] normals = {
    	    // Front Face
             0.0f, 0.0f, dim, 0.0f, 0.0f, dim,
             0.0f, 0.0f, dim, 0.0f, 0.0f, dim,
           	// Back Face
             0.0f, 0.0f, negDim, 0.0f, 0.0f, negDim,
             0.0f, 0.0f, negDim, 0.0f, 0.0f, negDim,
            // Right Face
             dim, 0.0f, 0.0f, dim, 0.0f, 0.0f,
             dim, 0.0f, 0.0f, dim, 0.0f, 0.0f,
            // Left Face
             negDim, 0.0f, 0.0f, negDim, 0.0f, 0.0f,
             negDim, 0.0f, 0.0f, negDim, 0.0f, 0.0f,
            // Top Face
            0.0f, dim, 0.0f, 0.0f, dim, 0.0f,
            0.0f, dim, 0.0f, 0.0f, dim, 0.0f,
            // Bottom Face
            0.0f, negDim, 0.0f, 0.0f, negDim, 0.0f,
            0.0f, negDim, 0.0f, 0.0f, negDim, 0.0f,
        };

      float[] textCoords = {
            // Front Face
    		 dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f,
            // Back Face
             dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f,
            // Right Face
             dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f,
            // Left Face
             dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f,
            // Top Face
             dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f,
            // Bottom Face
             dim, 0.0f, dim, dim,
             0.0f, dim, 0.0f, 0.0f
        };

        QuadArray quadArray = new QuadArray(24, QuadArray.COORDINATES |
		                                 					QuadArray.NORMALS |
			                                   				QuadArray.TEXTURE_COORDINATE_2);
		          quadArray.setCoordinates(0, verts);
		          quadArray.setNormals(0, normals);
		          quadArray.setTextureCoordinates(0, 0, textCoords);

        return quadArray;

    }










 }

