package com.asc.utils;

import javax.vecmath.Matrix3d;
import javax.vecmath.Vector3d;

public class Java3DMath {
	
	
	 /**
	* for the j3d engine
	*/
	 public static Vector3d rotationMatrixToEuler(Matrix3d m) {
		 
		 	//System.out.println(m.m00 + "; " + m.m01 + "; " + m.m02);
		 	//System.out.println(m.m10 + "; " + m.m11 + "; " + m.m12);
		 	//System.out.println(m.m20 + "; " + m.m21 + "; " + m.m22);

	        // Assuming the angles are in radians. 
	        if (m.m10 > 0.998) {
	            // singularity at north pole
	            return new Vector3d(0, Math.atan2(m.m02, m.m22),
	                    Math.PI / 2);
	        }
	        if (m.m10 < - 0.998) {
	            // singularity at south pole
	            return new Vector3d(0, Math.atan2(m.m02, m.m22),
	                    -Math.PI / 2);
	        }

	        return new Vector3d(Math.atan2(-m.m12, m.m11),
	                Math.atan2(-m.m20, m.m00), Math.asin(m.m10));
	 }
	

}
