/*************************************************************************
 * Author : Kavitha Subramani
 * Date   : Aug 28 2007
 * Version: 1.0
**************************************************************************/

package com.asc.utils;

import java.text.NumberFormat;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;
import javax.media.j3d.BoundingSphere;

public interface PortfolioCubeConstants {

	//	 colors
    static Color3f 	black   = new Color3f(0.0f, 0.0f, 0.0f);
    static Color3f 	red     = new Color3f(1.0f, 0.0f, 0.0f);
    static Color3f 	green   = new Color3f(0.0f, 1.0f, 0.0f);
    static Color3f 	darkGreen = new Color3f(0.2f, 0.7f, 0.2f);
    static Color3f 	blue    = new Color3f(0.0f, 0.0f, 1.0f);
    static Color3f	skyBlue = new Color3f(0.6f, 0.7f, 0.9f);
    static Color3f 	cyan    = new Color3f(0.0f, 1.0f, 1.0f);
    static Color3f 	magenta = new Color3f(1.0f, 0.0f, 1.0f);
    static Color3f 	yellow  = new Color3f(1.0f, 1.0f, 0.0f);
    static Color3f 	brightWhite = new Color3f(1.0f, 1.5f, 1.5f);
    static Color3f 	white   = new Color3f(1.0f, 1.0f, 1.0f);
    static Color3f 	darkGrey= new Color3f(0.15f, 0.15f, 0.15f);
    static Color3f 	medGrey = new Color3f(0.3f, 0.3f, 0.3f);    
    static Color3f 	grey    = new Color3f(0.5f, 0.5f, 0.5f);
    //static Color3f 	lightGrey= new Color3f(0.75f, 0.75f, 0.75f);
    
    
    //  colors
    static Color3f blue1 = new Color3f(0.3922f, 0.5765f, 0.9497f);


    // infinite bounding region, used to make env nodes active everywhere
    BoundingSphere	infiniteBounds = new BoundingSphere(new Point3d(),
				Double.MAX_VALUE);

    // common values
    static final String       nicestString = "NICEST";
    static final String       fastestString = "FASTEST";
    static final String       antiAliasString = "Anti-Aliasing";
    static final String       noneString = "NONE";

    // light type constants
    static int 	LIGHT_AMBIENT = 1;
    static int 	LIGHT_DIRECTIONAL = 2;
    static int 	LIGHT_POSITIONAL = 3;
    static int 	LIGHT_SPOT = 4;

    // screen capture constants
    static final int	USE_COLOR = 1;
    static final int	USE_BLACK_AND_WHITE = 2;

    // number formatter
    NumberFormat        nf = NumberFormat.getInstance();


}

